﻿<%@ Page Title="Admin Commands" Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage" %>

<asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
	Admin Commands
</asp:Content>

<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
<div class="row-fluid">
                    <div class="span12">
                        <ul id="js-admincommands-relatedlinks">
                            <li>
                                <a href="http://winshuttle-help.s3.amazonaws.com/foundation/en/winshuttle_svadm_tool_commands.htm">Documentation</a>
                            </li>
                        </ul>
                        <ul id="breadcrumbs">
                            <li><a href="/Home">Administration</a> &rsaquo;</li>
                            <li id="li-commandtext">Admin Commands</li>
                        </ul>
                        <ul id="secnav">
                            <li id="js-header" class="active">
                                <h1 class="js-text-header">Admin Commands</h1>
                            </li>
                        </ul>
                    </div>
                </div>
                <div id="js-admincommands-base" class="row-fluid">
                    <div class="span6">
                        <div class="settings-info js-initial-hide">
                            <form class="form-horizontal">
                                <fieldset>
                                    <div class="control-group">
                                        <label class="control-label">Admin Command <span class="required">*</span></label>
                                        <div class="controls">
                                            <select id="js-admincommands-operation-list" class="input-max"></select>
                                        </div>
                                    </div>
                                </fieldset>
                            </form>
                        </div>
                        
                        <div class="settings-info">
                            <form id="js-admincommands-form-base" class="form-horizontal">
                                <fieldset></fieldset>
                            </form>
                        </div>
                        
                        
                        
                        <div class="settings-info">
                            <form class="form-horizontal">
                                <fieldset>
                                    <div id="js-form-submitcancel" class="form-actions">
                                        <button class="js-form-button-submit btn btn-primary"><span>Continue</span></button>
                                        <button class="js-form-button-cancel btn"><span>Cancel</span></button>
                                    </div>
                                </fieldset>
                            </form>
                        </div>
                        
                    </div><!-- /div .span6 -->
                    <div class="span6">
                        <div id="js-terminal">
                        </div>
                    </div><!-- /div .span6 -->
                </div><!-- /div .row-fluid -->
                 <script src="http://ajax.googleapis.com/ajax/libs/jquery/1.11.1/jquery.min.js"></script>
        <script>
            if (!window.jQuery) {
                console.error("jQuery CDN is down.")
                document.write('<script src="<%=Url.Content("~/Content/assets/js/jquery.min.js") %>"><\/script>');
            }
        </script>
        <script src="http://maxcdn.bootstrapcdn.com/bootstrap/3.2.0/js/bootstrap.min.js"></script>
        <script>
            if (!$.fn.modal) {
                console.error("Bootstrap CDN is down.")
                document.write('<script src="<%=Url.Content("~/Content/assets/js/bootstrap.min.js") %>"><\/script>');
            }
        </script>
        <script src="<%=Url.Content("~/Content/assets/js/kendo.all.min.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/filedrop-min.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/wslib_master.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/wsplugin_master.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/ws_admincommands.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/ws_common.js") %>"></script>
        <script>
            $(document).ready(function () {
                ws_showProgressBar();
                ws_initializeWebApp('/admin/getallwebapp', $('#select-webapp'), function (data, callbackdata) {

                    var adminCommand = wsPlugin_getURLParameter('admincommandID');
                    if (adminCommand != undefined && adminCommand != null && adminCommand != '') {
                        $('#li-commandtext').html('<a href="/command" >Admin Commands</a>');
                    }

                    loadCommands(data, callbackdata);
                });

                $('#select-webapp').on('change', function () {
                    SetupLinks();
                });
            });

            function loadCommands(data, callbackdata) {
                var server = getServer();
                $('#select-webapp').val(server)
                var ws_externalAdminCommands = ws_admincommands(server);

                wsLib_console(ws_externalAdminCommands);
                ws_hideProgressBar();
            }

            function getServer() {

                var server = wsPlugin_getURLParameter('server');
                if (server == undefined || server == null || server == '') {
                    server = $('#select-webapp :selected').val();
                }

                return server;
            }
        </script>
</asp:Content>
