﻿<%@ Page Title="Database Usage Status" Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage" %>

<asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
	Database Usage Status
</asp:Content>

<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
 <div class="row-fluid">
                    <div class="span12">
                        <ul id="breadcrumbs">
                            <li><a href="/Home">Administration</a> &rsaquo;</li>
                            <li>Database Usage Status</li>
                            <li class="related-links">
								<ul>
									<li class="related-label">Related:</li>
									<li class="link"><a href="/Scheduler">Scheduler</a></li>
									<li class="link"><a href="/WorkflowProcess">Process Control</a></li>
									<li class="link"><a href="/Chart">Charts</a></li>
								</ul>
							</li>
                        </ul>
                        <ul id="secnav">
                            <li class="active">
                                <h1>Database Usage Status</h1>
                            </li>
                        </ul>
                    </div>
                </div>
                <!-- /div .row-fluid -->
                <div class="row-fluid">
                	<table width="100%" class="usage-table">
                		<tr class="usage-bar">
                			<td id="Configuration-Percent" width="5%" class="configuration-data" onclick="location.href='#div-Configuration'"></td>
                			<td id="Solution-Percent" width="20%" class="solution-definition-data" onclick="location.href='#div-Solution'"></td>
                			<td id="Transaction-Percent" width="75%" class="process-transaction-data" onclick="location.href='#div-Transaction'"></td>
                		</tr>
                		<tr>
                			<td colspan="3">
                				<ul>
                					<li>
                						<a href="#div-Configuration"><span class="configuration-data"></span> Configuration Data</a>
                					</li>
                					<li>
                						<a href="#div-Solution"><span class="solution-definition-data"></span> Workflow Solution Definition Data</a>
                					</li>
                					<li>
                						<a href="#div-Transaction"><span class="process-transaction-data"></span> Process/Transaction Data</a>
                					</li>
                				</ul>
                				<div class="pull-right">
                					<p><span id="inactive-processes"></span><span id="current-date"></span></p>
									<p><span id="obsolete-solutions"></span></p>
                				</div>
                			</td>
                		</tr>
                	</table>
                </div>
                 <div class="control-group">
                    <span id="js-notice-message"></span>
                </div>
                <div class="row-fluid" id="div-Configuration">
                    <table class="tableHeader table-bordered" >
                            <tr class="tableHeader-menu">
								<th colspan="2">
                                    <div>
									<h2>Configuration Data Cache</h2>
                                    </div>
								</th>
							</tr>
					</table>
					<table class="table table-striped table-bordered" id="table-Configuration">
						<thead>
						    <tr class="table-sort">
						  	<th width="25%"><a href="#">Table</a></th>
						    <th width="10%"><a href="#">Data Cache</a></th>
						  </tr>
						</thead>
						<tbody id="table-body-Configuration">
							
						</tbody>
					</table>
					</div>
				    <div class="row-fluid"  id="div-Solution">
                     <table class="tableHeader table-bordered" >
                            <tr class="tableHeader-menu">
								<th colspan="2">
                                    <div>
									<h2>Workflow Solution Definition Data Usage by Table</h2>
                                    </div>
									<div class="links">
										<ul>
											<li><a href="/Scheduler">Scheduler</a></li>
											<li><a href="/Scheduler/ArchiveObsoleteWorkflowSolution">Archive Obsolete Workflow Solution</a></li>
										</ul>
									</div>
								</th>
							</tr>
					</table>
					<table class="table table-striped table-bordered"  id="table-Solution">
						<thead>
							<tr class="table-sort">
						  	<th width="25%"><a href="#">Table</a></th>
						    <th width="10%"><a href="#">Data Usage</a></th>
						  </tr>
						</thead>
						<tbody>
						
						</tbody>
					</table>
					</div>  
					<div class="row-fluid" id="div-Transaction">
                     <table class="tableHeader table-bordered" >
                            <tr class="tableHeader-menu">
								<th colspan="2">
                                    <div>
									<h2>Process/Transaction Data Usage by Table</h2>
                                    </div>
									<div class="links">
										<ul>
											<li><a href="/Scheduler/PurgeProcessData">Purge Process Data</a></li>
										</ul>
									</div>
								</th>
							</tr>
					</table>
					<table class="table table-striped table-bordered"  id="table-Transaction">
						<thead>
							<tr class="table-sort">
						  	<th width="25%"><a href="#">Table</a></th>
						    <th width="10%"><a href="#">Data Usage</a></th>
						  </tr>
						</thead>
						<tbody>
							
						</tbody>
					</table>
					</div> 
					<script src="http://ajax.googleapis.com/ajax/libs/jquery/1.11.1/jquery.min.js"></script>
        <script>
            if (!window.jQuery) {
                console.error("jQuery CDN is down.")
                document.write('<script src="<%=Url.Content("~/Content/assets/js/jquery.min.js") %>"><\/script>');
            }
        </script>
        <script src="http://maxcdn.bootstrapcdn.com/bootstrap/3.2.0/js/bootstrap.min.js"></script>
        <script>
            if (!$.fn.modal) {
                console.error("Bootstrap CDN is down.")
                document.write('<script src="<%=Url.Content("~/Content/assets/js/bootstrap.min.js") %>"><\/script>');
            }
        </script>
        <script src="../../Content/assets/js/kendo.all.min.js"></script>
        <script src="../../Content/assets/js/wslib_master.js"></script>
        <script src="../../Content/assets/js/wsplugin_master.js"></script>
        <script src="../../Content/assets/js/ws_admincommands.js"></script>
        <script src="../../Content/assets/js/ws_common.js"></script>
        <script src="../../Content/assets/js/jquery.tablesorter.js"></script>
        <script>
            $(document).ready(function () {
                ws_showProgressBar();
                ws_initializeWebApp('/admin/getallwebapp', $('#select-webapp'), function () {
                    var webappUrl = $('#select-webapp').val();
                    ws_ajaxCall('/DatabaseUsage/GetDataUsageforTables', { server: $('#select-webapp').val() }, onLoadDataUsage, onError, null);
                    $("table").tablesorter({
				     //cssAsc--the class name to be appended to sortable tr elements in the thead on a ascending sort
				      // cssDesc--the class name to be appended to sortable tr elements in the thead on a descending sort. 
				      cssAsc: "sortup", cssDesc: "sortdown"
                      });
                });

                $("#select-webapp").change(function () {
                    SetupLinks();
                });
            });

            function onLoadDataUsage(data, callbackdata) {
                var ConfigurationSize = 0;
                var SolutionSize = 0;
                var TransactionSize = 0;
                if (data != undefined && data != null) {
                    $.each(data, function (key, value) {
                        value.data_size = value.data_size.replace("KB", "");
                        var row = createRow(value);
                        if (value.Category == "Configuration") {
                            $("#table-Configuration > tbody:last").append(row);
                            ConfigurationSize += +value.data_size;
                        }
                        else if (value.Category == "Solution") {
                            $("#table-Solution > tbody:last").append(row);
                            SolutionSize += +value.data_size;
                        }
                        else {
                            $("#table-Transaction > tbody:last").append(row);
                            TransactionSize += +value.data_size;
                        }
                    });
                    var total = +ConfigurationSize + +SolutionSize + +TransactionSize;
                    var ConfigurationPercent = getPercent(ConfigurationSize, total);
                    var SolutionPercent = getPercent(SolutionSize, total);
                    var TransactionPercent = getPercent(TransactionSize, total);
                    var ConfigurationSizeInMB = CalculateDataInMB(ConfigurationSize);
                    var SolutionSizeInMB = CalculateDataInMB(SolutionSize);
                    var TransactionSizeInMB = CalculateDataInMB(TransactionSize);
                    $('#Configuration-Percent').width(ConfigurationPercent);
                    if (ConfigurationSize > 0) {
                        $('#Configuration-Percent').text(ConfigurationSizeInMB);
                        $('#Configuration-Percent').attr('title', ConfigurationSizeInMB);
                    }
                    $('#Solution-Percent').width(SolutionPercent);
                    if (SolutionSize > 0) {
                        $('#Solution-Percent').text(SolutionSizeInMB);
                        $('#Solution-Percent').attr('title', SolutionSizeInMB);
                    }
                    $('#Transaction-Percent').width(TransactionPercent);
                    if (TransactionSize > 0) {
                        $('#Transaction-Percent').text(TransactionSizeInMB);
                        $('#Transaction-Percent').attr('title', TransactionSizeInMB);
                    }
                    $("table").trigger("update");
                    //sortList: [[columnIndex, sortDirection]]--first value of array  sort on the First column, order asc
                    var sorting = [[0, 0]];
                    $("table").trigger("sorton", [sorting]);
                }
                ws_ajaxCall('/DatabaseUsage/GetInactiveAndObsoleteSolutionsCount', { server: $('#select-webapp').val() }, onLoadInactiveObsoleteCount, onError, null);
            }

            function onLoadInactiveObsoleteCount(data, callbackdata) {

                if (data != undefined && data != null) {
                    if (data.Table != undefined && data.Table != null) {
                        if (data.Table[0].InactiveProcessCount != undefined && data.Table[0].InactiveProcessCount != null) {
                            $('#inactive-processes').text(data.Table[0].InactiveProcessCount + " Processes marked as inactive");
                            //$('#current-date').text(currentDateTime());
                        }
                    }
                    if (data.Table1 != undefined && data.Table1 != null) {
                        if (data.Table1[0].ObsoleteSolutionCount != undefined && data.Table1[0].ObsoleteSolutionCount != null) {
                            $('#obsolete-solutions').text(data.Table1[0].ObsoleteSolutionCount + " Obsolete Workflow Solutions");
                        } 
                    }
                }
                ws_hideProgressBar();
            }
            function createRow(rowData) {
                var row = '<tr><td>' + rowData.tableName + '</td><td>' + CalculateDataInMB(rowData.data_size) + '</td></tr>';
                return row;
            }
            function CalculateDataInMB(value) {
                return (parseInt(value) / (1024)).toFixed(3) + " MB";
            }

            function currentDateTime() {
                var tdate = new Date();
                var dd = tdate.getDate(); //yields day
                var MM = tdate.getMonth(); //yields month
                var yyyy = tdate.getFullYear(); //yields year
                //var hh = tdate.getHours();
                //var mm =tdate.getMinutes();
                // return (MM + 1) + "-" + dd + "-" + yyyy + ' ' + (hh < 10 ? '0' : '') + hh + ':' + (mm < 10 ? '0' : '') + mm;
                return (MM + 1) + "-" + dd + "-" + yyyy;

            }
            function getPercent(value, Total) {
                return ((parseInt(value) * 100) / Total) + "%";
            }
            function cleanData() {
                $("#table-Configuration tbody tr").remove();
                $("#table-Solution tbody tr").remove();
                $("#table-Transaction tbody tr").remove();
                $('#Configuration-Percent').width(0);
                $('#Configuration-Percent').text('');
                $('#Configuration-Percent').attr('title', '');
                $('#Solution-Percent').width(0);
                $('#Solution-Percent').text('');
                $('#Solution-Percent').attr('title', '');
                $('#Transaction-Percent').width(0);
                $('#Transaction-Percent').text('');
                $('#Transaction-Percent').attr('title', '');
                $('#inactive-processes').text('');
                $('#obsolete-solutions').text('');
                $('#current-date').text('');
            }
            function onError(xhr, status, error) {

                if (xhr.statusText != null && xhr.statusText != undefined) {
                    wsLib_createBootstrapAlert($('#js-notice-message'), xhr.statusText, "error", true);
                }
                else {
                    wsLib_createBootstrapAlert($('#js-notice-message'), xhr.responseText, "error", true);
                }

                ws_hideProgressBar();
            }
            </script>
</asp:Content>
