﻿<%@ Page Title="Extend Workflow" Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage" %>

<asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
	Extend Workflow
</asp:Content>

<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
<div class="row-fluid">
                    <div class="span12">
                        <ul id="breadcrumbs">
                            <li><a href="/Home">Administration</a> &rsaquo;</li>
                            <li>Extend Workflow</li>
                        </ul>
                        <ul id="secnav">
                            <li class="active">
                                <h1>Extend Workflow</h1>
                            </li>
                        </ul>
                    </div>
                </div>
                
                <div class="row-fluid">
                    <div class="span8" id="form-data">
                        <div class="settings-info">
                            <div class="clearfix" style="border-bottom: 1px solid #ccc; margin-bottom:30px">
                                <h2><b>Install Location</b></h2>
                            </div>
                            <form class="form-horizontal">
                                <fieldset>
                                    <div class="control-group">
                                        <label class="control-label">Location Type <span class="required">*</span></label>
                                        <div class="controls">
                                            <ul class="inline-list checkbox-group">
                                                <li>
                                                    <label>
                                                        <input type="radio" id="nonWFWebAppsRadio" name="installlocation_locationtype" class="js-installlocation-location-toggle-view-master-0" checked="checked"/> Web Application
                                                    </label>
                                                </li>
                                                <li>
                                                    <label>
                                                        <input type="radio" id="nonWFWebAppUrlTextBox" name="installlocation_locationtype" class="js-installlocation-location-toggle-view-master-1"/> URL
                                                    </label>
                                                </li>
                                            </ul>
                                        </div>
                                    </div>
                                    <div class="control-group">
                                        <label class="control-label">Location <span class="required">*</span></label>
                                        <div class="controls">
                                            <div class="js-installlocation-location-toggle-view-slave-0">
                                                <select class="input-max" id="nonWFWebApps" validation-type="required" required-message="Please select a web application.">
                                                </select>
                                            </div>
                                            <div class="js-installlocation-location-toggle-view-slave-1 js-initial-hide">
                                                <input type="text" class="input-max" id="nonWFWebAppUrl" validation-type="required, regex" required-message="Please enter the web application URL."
                                                validation-regex="^((http(s)?)://([^\s:/]+)(:([0-9]+))?(/[^\s]*)*)$" regex-message="Please enter the URL in correct format."/>
                                            </div>
                                        </div>
                                    </div>
                                </fieldset>
                            </form>
                        </div>
                        

                        <div class="settings-info">
                            <div class="page-header clearfix">
                                <h2><b>Database Settings</b></h2>
								<div style="clear:both">                                
									<%=Resources.Resource.WFAdminWeb_Page_ExtendPage_DatabaseSettings%>
								</div>
								<br />
                            </div>
                            <form class="form-horizontal">
                                <fieldset>
                                    <div class="control-group">
                                        <label class="control-label">Database Instance Name <span class="required">*</span></label>
                                        <div class="controls">
                                            <input type="text" validation-type="required" required-message="Please enter the SQL server instance name." class="input-max" id="dbInstanceName"/>
                                        </div>
                                    </div>
                                    <div class="control-group">
                                        <label class="control-label">Database Name <span class="required">*</span></label>
                                        <div class="controls">
                                            <input type="text" class="input-max" validation-type="required, regex" required-message="Please enter the database name." id="dbName"
                                            validation-regex="^[^\\{}\[\]?*|/'=]+$" regex-message="<%=Resources.Resource.WFAdminWeb_Page_ExtendPage_DBNameCharacters %>"
                                            />
                                        </div>
                                    </div>
                                    <div class="control-group">
                                        <label class="control-label">Authentication Type <span class="required">*</span></label>
                                        <div class="controls">
                                            <ul class="inline-list checkbox-group">
                                                <li>
                                                    <label>
                                                        <input type="radio" id="databaseinitializationSQL" name="databasesettings_authenticationtype" class="js-databasesettings-authenticationtype-toggle-view-master-0"/> SQL Server
                                                    </label>
                                                </li>
                                                <li>
                                                    <label>
                                                        <input type="radio" id="databaseinitializationWindows" name="databasesettings_authenticationtype" class="js-databasesettings-authenticationtype-toggle-view-master-1" checked="checked"/> Windows
                                                    </label>
                                                </li>
                                            </ul>
                                        </div>
                                    </div>
                                    <div class="js-databasesettings-authenticationtype-toggle-view-slave-1 control-group">
                                        <label class="control-label">Domain</label>
                                        <div class="controls">
                                            <input type="text" class="input-xlarge"  id="databaseinitializationDomain"/>
                                        </div>
                                    </div>
                                    <div class="control-group">
                                        <label class="control-label">Username <span class="required">*</span></label>
                                        <div class="controls">
                                            <input type="text" class="input-xlarge" validation-type="required, regex" required-message="Please enter the username."  id="databaseinitializationUsername"
                                            validation-regex="^[^\\;=\[\]']+$" regex-message="<%=Resources.Resource.WFAdminWeb_Page_ExtendPage_UserNameCharacters %>" />
                                        </div>
                                    </div>
                                    <div class="control-group">
                                        <label class="control-label">Password <span class="required">*</span></label>
                                        <div class="controls">
                                            <input type="password" class="input-xlarge" validation-type="required" required-message="Please enter the password." id="databaseinitializationPassword"/>
                                        </div>
                                    </div>
                                </fieldset>
                            </form>
                        </div>
                        
                        
                        
                        <div class="settings-info">
                            <div class="page-header clearfix">
                                <h2><b>Database Initialization</b></h2>
								<div style="clear:both">
									<%=Resources.Resource.WFAdminWeb_Page_ExtendPage_DatabaseInitialization%>
								</div>
								<br />
                            </div>
                            <form class="form-horizontal">
                                <fieldset>
                                    <div class="control-group">
                                        <label class="control-label">Authentication Type <span class="required">*</span></label>
                                        <div class="controls">
                                            <ul class="inline-list checkbox-group">
                                                <li>
                                                    <label>
                                                        <input type="radio" id="dbCreatorAuthenticationSQL" name="databaseinitialization_authenticationtype" class="js-databaseinitialization-authenticationtype-toggle-view-master-0"/> SQL Server
                                                    </label>
                                                </li>
                                                <li>
                                                    <label>
                                                        <input type="radio" id="dbCreatorAuthenticationWindows" name="databaseinitialization_authenticationtype" class="js-databaseinitialization-authenticationtype-toggle-view-master-1" checked="checked"/> Windows
                                                    </label>
                                                </li>
                                            </ul>
                                        </div>
                                    </div>
                                    <div class="js-databaseinitialization-authenticationtype-toggle-view-slave-1 control-group">
                                        <label class="control-label">Domain</label>
                                        <div class="controls">
                                            <input type="text" class="input-xlarge" id="dbCreatorDomainName"/>
                                        </div>
                                    </div>
                                    <div class="control-group">
                                        <label class="control-label">Username <span class="required">*</span></label>
                                        <div class="controls">
                                            <input type="text" class="input-xlarge" validation-type="required, regex" required-message="Please enter the username." id="dbCreatorUserName"
                                            validation-regex="^[^\\;=\[\]']+$" regex-message="<%=Resources.Resource.WFAdminWeb_Page_ExtendPage_UserNameCharacters %>" />
                                        </div>
                                    </div>
                                    <div class="control-group">
                                        <label class="control-label">Password <span class="required">*</span></label>
                                        <div class="controls">
                                            <input type="password" class="input-xlarge" validation-type="required" required-message="Please enter the password." id="dbCreatorPassword"/>
                                        </div>
                                    </div>
                                </fieldset>
                            </form>
                        </div>
                        
                        
                        
                        <div class="settings-info">
                            <form class="form-horizontal">
                                <fieldset>
                                    <div class="control-group">
                                        <span id="js-notice-message"></span>
                                    </div>
                                    <div class="form-actions">
                                        <button type="submit" id="btn_Save" class="btn btn-primary"><span>Extend</span></button>
                                        <button class="btn" id="btnCancel"><span>Cancel</span></button>
                                    </div>
                                </fieldset>
                            </form>
                        </div>
                        
                    </div><!-- /div .span6 -->
                </div><!-- /div .row-fluid -->
				
        <script src="http://ajax.googleapis.com/ajax/libs/jquery/1.11.1/jquery.min.js"></script>
        <script>
            if (!window.jQuery) {
                console.error("jQuery CDN is down.")
                document.write('<script src="<%=Url.Content("~/Content/assets/js/jquery.min.js") %>"><\/script>');
            }
        </script>
        <script src="http://maxcdn.bootstrapcdn.com/bootstrap/3.2.0/js/bootstrap.min.js"></script>
        <script>
            if (!$.fn.modal) {
                console.error("Bootstrap CDN is down.")
                document.write('<script src="<%=Url.Content("~/Content/assets/js/bootstrap.min.js") %>"><\/script>');
            }
        </script>
        <script src="<%=Url.Content("~/Content/assets/js/kendo.all.min.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/wslib_master.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/wsplugin_master.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/ws_admincommands.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/ws_common.js") %>"></script>
        <script>
            $('.js-tooltip-target').tooltip({
                animation: true
            });
            
            wsLib_toggleViews("installlocation-location", 2, "radio", "no", 200);
            wsLib_toggleViews("databasesettings-authenticationtype", 2, "radio", "no", 200);
            wsLib_toggleViews("databaseinitialization-authenticationtype", 2, "radio", "no", 200);

            $(document).ready(function () {
                ws_showProgressBar();
                ws_initializeWebApp("/admin/GetAllWebApp", $('#select-webapp'), function () {
                    ws_initializeWebApp("/admin/GetNonWFWebApps", $('#nonWFWebApps'), function () { ws_hideProgressBar(); });
                });                

                $("#btnCancel").click(function () {
                    window.location.href = '/Home/index?server=' + $('#select-webapp');
                    return false;
                });

                $("#select-webapp").change(function () {
                    SetupLinks();
                });
            });

            function CallBackFunctionSuccess(data, callbackdata) {
			    ws_initializeWebApp("/admin/GetAllWebApp", $('#select-webapp'), null);
			    ws_initializeWebApp("/admin/GetNonWFWebApps", $('#nonWFWebApps'), null);
			    clearFields();
			    ws_hideProgressBar();
			    wsLib_createBootstrapAlert($('#js-notice-message'), data, "success", true, 120000);
			}

			function clearFields() {
			    $("#dbInstanceName").val('');
			    $("#dbName").val(''); 
                $("#dbCreatorUserName").val(''); $("#dbCreatorPassword").val(''); $("#dbCreatorDomainName").val('');
			    $("#databaseinitializationUsername").val(''); $("#databaseinitializationPassword").val(''); $("#databaseinitializationDomain").val('');
			}

			function CallBackFunctionFailure(xhr, status, error, callbackdata) {
			    ws_hideProgressBar();
			    if (xhr.statusText != null && xhr.statusText != undefined) {
			        wsLib_createBootstrapAlert($('#js-notice-message'), xhr.statusText, "error", true);
			    }
			}

			$("#btn_Save").click(function () {
			    var theUrl, bIsTrustedInstallation, sDbcUser, sDbcPwd, sDbcDomain, bIsTrustedLogin, sDbUser, sDbPwd, sDbDomain, sDbInstance, sDbName;

			    if (!validateClientSide("form-data")) {

			        return false;
			    }
                //Get the Web APP URL
			    var radioWebAppValue = $("#nonWFWebAppsRadio").prop('checked');
			    if (radioWebAppValue == true) {
			        theUrl = $("#nonWFWebApps").val();
			    }
			    else {
			        theUrl = $("#nonWFWebAppUrl").val();
			    }

			    // Get the DB Instance Name and authentication type to create database.
			    sDbInstance = $("#dbInstanceName").val();
			    sDbName = $("#dbName").val();

			    var radioDBCreatorAuthentication = $("#dbCreatorAuthenticationWindows").prop('checked');
			    if (radioDBCreatorAuthentication == true) {
			        bIsTrustedInstallation = true;
			        sDbcUser = $("#dbCreatorUserName").val();
			        sDbcPwd = $("#dbCreatorPassword").val();
			        sDbcDomain = $("#dbCreatorDomainName").val();
			    }
			    else {
			        bIsTrustedInstallation = false;
			        sDbcUser = $("#dbCreatorUserName").val();
			        sDbcPwd = $("#dbCreatorPassword").val();
			        sDbcDomain = null;
			    }

			    // Get the user credentials to be created in the DB, and used in Workflow DB connection string.
			    var radioDBInitialization = $("#databaseinitializationWindows").prop('checked');
			    if (radioDBInitialization == true) {
			        bIsTrustedLogin = true;
			        sDbUser = $("#databaseinitializationUsername").val();
			        sDbPwd = $("#databaseinitializationPassword").val();
			        sDbDomain = $("#databaseinitializationDomain").val();
			    }
			    else {
			        bIsTrustedLogin = false;
			        sDbUser = $("#databaseinitializationUsername").val();
			        sDbPwd = $("#databaseinitializationPassword").val();
			        sDbDomain = null;
			    }

			    wsLib_destroyBootstrapAlert($('#js-notice-message'));
			    ws_showProgressBar();
			    ws_ajaxCall('/ExtendWorkflow/ExtendWorkflow',
                            {
                                url: theUrl,
                                isTrustedInstallation: bIsTrustedInstallation,
                                dbcUser: sDbcUser,
                                dbcPwd: sDbcPwd,
                                dbcDomain: sDbcDomain,
                                isTrustedLogin: bIsTrustedLogin,
                                dbUser: sDbUser,
                                dbPwd: sDbPwd,
                                dbDomain: sDbDomain,
                                dbInstance: sDbInstance,
                                dbName: sDbName
                            },
                              CallBackFunctionSuccess, CallBackFunctionFailure,
                              null);
			    return false;
			});
        </script>
</asp:Content>
