﻿<%@ Page Title="Winshuttle Workflow Central Administration" Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage" %>

<asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
	Winshuttle Workflow Central Administration
</asp:Content>

<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
    <div class="container-fluid">
    <div class="row-fluid">
        <div class="span12">
            <ul id="secnav">
                <li class="active">
                    <h1>Administration</h1>
                </li>
            </ul>
        </div>
    </div>
    <!-- /div .row-fluid -->
                
    <div class="row-fluid">
        <div class="span12">
			    <h2>Logs &amp; Reporting</h2>
		    <ul class="home-links home-links-64px">
			    <li class="charts"><a href="/chart"><span></span><h3>Charts</h3></a></li>
			    <li class="data-dump"><a href="/WorkflowDump"><span></span><h3>Excel Workflow Data Dump</h3></a></li>
			    <li class="log-file-viewer"><a href="/LogViewer"><span></span><h3>Log File Viewer</h3></a></li>
                <li class="logging"><a href="/Logging"><span></span><h3>Logging</h3></a></li>			    
		    </ul>
        </div>
    </div>
    <!-- /div .row-fluid -->
                
    <div class="row-fluid">
        <div class="span12">
			    <h2>Processes</h2>
		    <ul class="home-links home-links-64px">
                <li class="background-tasks"><a href="/Job"><span></span><h3>Manage Background Jobs</h3></a></li>
			    <li class="process-control"><a href="/WorkflowProcess"><span></span><h3>Process Control</h3></a></li>			    
		    </ul>
        </div>
    </div>
    <!-- /div .row-fluid -->
                
    <div class="row-fluid">
        <div class="span12">
			    <h2>Server Administration</h2>
		    <ul class="home-links home-links-64px">
			    <li class="admin-commands"><a href="/Command"><span></span><h3>Admin Commands</h3></a></li>
                <li class="config-options"><a href="/keyconfiguration"><span></span><h3>Configure Options</h3></a></li>
                <li class="database-status"><a href="/DatabaseUsage"><span></span><h3>Database Usage Status</h3></a></li>
                <li class="extensions"><a href="/ExtendWorkflow"><span></span><h3>Extend Workflow</h3></a></li>
                <li class="farm-config"><a href="/frontendconfiguration"><span></span><h3>Front End Configuration</h3></a></li>
                <li class="licenses"><a href="/License"><span></span><h3>Licenses</h3></a></li>
                <li class="scheduler"><a href="/Scheduler"><span></span><h3>Scheduler</h3></a></li>
			    <li class="configure-options"><a href="/ServerConfig"><span></span><h3>Workflow Design Configuration</h3></a></li>               
		    </ul>
        </div>
    </div>
    <script src="http://ajax.googleapis.com/ajax/libs/jquery/1.11.1/jquery.min.js"></script>
        <script>
            if (!window.jQuery) {
                console.error("jQuery CDN is down.")
                document.write('<script src="<%=Url.Content("~/Content/assets/js/jquery.min.js") %>"><\/script>');
            }
        </script>
        <script src="http://maxcdn.bootstrapcdn.com/bootstrap/3.2.0/js/bootstrap.min.js"></script>
        <script>
            if (!$.fn.modal) {
                console.error("Bootstrap CDN is down.")
                document.write('<script src="<%=Url.Content("~/Content/assets/js/bootstrap.min.js") %>"><\/script>');
            }
        </script>
        <script src="<%=Url.Content("~/Content/assets/js/kendo.all.min.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/chosen.jquery.min.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/wslib_master.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/wsplugin_master.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/ws_common.js") %>"></script>
        <script>
            $('a.js-tooltip-target').tooltip({
                html: true,
                trigger: 'click',
                animation: true
            });

            $('body').on('click', '.js-tooltip-target', function (event) {
                event.stopPropagation();

                $('div.tooltip').not($(this).siblings('div.tooltip')).remove();
            });

            $(document).ready(function () {
                ws_showProgressBar();
                ws_initializeWebApp('/admin/getallwebapp', $('#select-webapp'), function (data, callbackdata) {
                    var anchors = $('.home-links').find('a'); //.on('click', function () {
                    $.each(anchors, function () {
                        var hrefattr = $(this).attr('href');
                        if (hrefattr != null && hrefattr != undefined && hrefattr != '#' && (hrefattr.toLowerCase().indexOf('http://') == -1)) {
                            $(this).attr('href', hrefattr + '?server=' + $('#select-webapp').val());
                        }
                    });

                    ws_hideProgressBar()
                });

                $("#select-webapp").change(function () {
                    SetupLinks();
                });
            });
        </script>
</asp:Content>
