﻿<%@ Page Title="Scheduler" Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage" %>

<asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
	Scheduler
</asp:Content>

<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
  <div class="row-fluid">
                    <div class="span12">
                        <ul id="breadcrumbs">
                            <li><a href="/Home">Administration</a> &rsaquo;</li>
                            <li>Scheduler</li>
                            <li class="related-links">
								<ul>
									<li class="related-label">Schedule New:</li>
									<li class="link"><a href="/Scheduler/MarkInactiveProcesses">Mark Inactive Processes</a></li>
									<li class="link"><a href="/Scheduler/PurgeBackgroundJobs">Purge Background Jobs</a></li>
									<li class="link"><a href="/Scheduler/PurgeProcessData">Purge Process Data</a></li>
									<li class="link"><a href="/Scheduler/ArchiveObsoleteWorkflowSolution">Archive Obsolete Workflow Solution</a></li>
								</ul>
							</li>
                        </ul>
                        <ul id="secnav">
                            <li class="active">
                                <h1>Scheduler</h1>
                           </li>
                        </ul>
                    </div>
                </div>

                <div class="form-actions top-line">
                    <span id="js-notice-message"></span>
                </div>
                <div class="row-fluid">
                    <div class="span12">
                        <table class="table table-scheduler table-striped table-bordered" id="table-scheduledjobs">
                            <thead>
                                <tr class="table-sort">
                                    <th style="display:none;" class="no-sort">
                                        ID
                                    </th>
                                    <th width="30%" sort-key="TYPE">
                                        <a href="#">Scheduled Job</a>
                                    </th>
                                    <th width="30%" sort-indicator="Ascending" class="sortup" sort-key="SCHEDULE">
                                        <a href="#">Schedule</a>
                                    </th>
                                    <th sort-key="PROCESSINGDATE">
										<a href="#">Last Run</a>
                                    </th>
                                </tr>
                            </thead>
                            <tbody>
                                
                            </tbody>
                        </table>
                        
                        
                    </div><!-- /div .span8 -->
                </div><!-- /div .row-fluid -->
                
				
                <div class="row-fluid">
					<h2 class="compact">History</h2>
					<table class="table table-header">
						<tbody>
							<tr>
								<td>
									<form>
										<div>
										  <label>Job Type</label>
										  	<select name="" class="input-medium" id="jobtype">
										  		<option>All</option>
                                                <option>Purge Background Jobs</option>
                                                <option>Purge Process Data</option>
                                                <option>Archive Obsolete Workflow Solution</option>
                                                <option>Mark Inactive Processes</option>
										  	</select>
										</div>
										    
										<div>
											<label>Result</label>
											<select name="" class="input-medium" id="resulttype">
												<option>All</option>
                                                <option>Success</option>
                                                <option>Failure</option>
                                                <option>Cancelled</option>
											</select>
										</div>
										<div>
											<label>&nbsp;</label>
											<div class="input-btn-primary">
												<input class="btn btn-primary" type="button" name="" value="Search" id="btnSearch"/>
											</div>
										</div>
									</form>
								</td>
								<td class="text-right" id="clearHistory"><a href="javascript:void(0)">Clear history > 6 months</a></td>
							</tr>
						</tbody>
					</table>
				</div>	
                <div class="row-fluid">
					<table class="table table-striped table-bordered" id="table-jobhistory">
						<thead>
							<tr class="table-menu">
								<th colspan="8">
									<div class="display">
										<span id="lblPage"> Displaying 0 of 0</span>
										<select id="select-pagesize" name="" onchange="" class="input-small">
											<option selected="selected" value="10">10</option>
											<option value="20">20</option>
											<option value="50">50</option>
											<option value="100">100</option>
										</select>
                                        <span><a href="#" onclick="ExportData();return false;">&nbsp;Export</a></span>
									</div>
								</th>
							</tr>
						  <tr class="table-sort">
						  	<th width="20%" sort-key="JOB"><a href="javascript:void(0)">Job</a></th>
						    <th width="15%" sort-indicator="Descending" class="sortdown" sort-key="COMPLETEDDATE"><a href="javascript:void(0)">Date Run</a></th>
						    <th width="10%" sort-key="DURATION"><a href="javascript:void(0)">Duration (hh:mm:ss)</a></th>
						    <th width="15%" sort-key="RESULT"><a href="javascript:void(0)">Result</a></th>
						    <th class="no-sort"><a href="javascript:void(0)">Comments</a></th>
						  </tr>
						</thead>
						<tbody>
							
						</tbody>
					</table>
					
                    <div id="div-paging">
                        <ul id="pagination-elmt"class="pagination-sm"></ul>
                    </div>
					</div>
					
        <script src="http://ajax.googleapis.com/ajax/libs/jquery/1.11.1/jquery.min.js"></script>
        <script>
            if (!window.jQuery) {
                console.error("jQuery CDN is down.")
                document.write('<script src="<%=Url.Content("~/Content/assets/js/jquery.min.js") %>"><\/script>');
            }
        </script>
        <script src="http://maxcdn.bootstrapcdn.com/bootstrap/3.2.0/js/bootstrap.min.js"></script>
        <script>
            if (!$.fn.modal) {
                console.error("Bootstrap CDN is down.")
                document.write('<script src="<%=Url.Content("~/Content/assets/js/bootstrap.min.js") %>"><\/script>');
            }
        </script>
        <script src="/Content/assets/js/kendo.all.min.js"></script>
        <script src="/Content/assets/js/chosen.jquery.min.js"></script>
        <script src="/Content/assets/js/wslib_master.js"></script>
        <script src="/Content/assets/js/wsplugin_master.js"></script>
        <script src="/Content/assets/js/ws_global_initialization_administration.js"></script>
        <script src="/Content/assets/js/ws_common.js"></script>
        <script src="/Content/assets/js/jquery.twbsPagination.min.js"></script>
		<script id="delete-confirmation" type="text/x-kendo-template">
        <p class="delete-message">{Placeholder}</p>
		<div align='center'>
		<ul class="pagination">
		<li>
        <button class="delete-confirm k-button">Yes</button>
		</li>
		<li>
        <button class="delete-cancel k-button">No</button>
		</li>
		<ul>
		</div>
        </script>
        <script>
            $('a.js-tooltip-target').tooltip({
                html: true,
                trigger: 'click',
                animation: true
            });

            var _globalMessage = '<%=TempData["Scheduling_Message"] %>';
            var _searchHistoryData = {};
            var _searchJobData = {};
            $(document).ready(function () {
                ws_showProgressBar();
                $('#select-webapp').change(function () {
                    SetupLinks();
                });

                $('#select-pagesize').change(function () {
                    ws_showProgressBar();
                    clearPaging();
                    _searchHistoryData.pageSize = $('#select-pagesize option:selected').val();
                    LoadJobHistoryData(_searchHistoryData, 1);
                });

                $('#clearHistory a').click(function () {

                    var kendoWindow = $("<div />").kendoWindow({
                        title: "Confirm",
                        resizable: false,
                        modal: true
                    });

                    kendoWindow.data("kendoWindow")
                    .content($("#delete-confirmation").html().replace('{Placeholder}', 'This will clear the entire job history older then 6 months. Are you sure you want to proceed?'))
                    .center().open();

                    kendoWindow
                    .find(".delete-confirm,.delete-cancel")
                    .click(function () {
                        if ($(this).hasClass("delete-confirm")) {
                            ws_showProgressBar();
                            //Getting HostName
                            var strHostName = $("#select-webapp").val();
                            if (strHostName.length == 0) {
                                return false;
                            }
                            ws_ajaxCall('/scheduler/clearJobHistory',
                            {
                                hostName: strHostName
                            }, function () { LoadJobHistoryData(_searchHistoryData, 1); }, CallBackFunctionFailure, null);
                        }
                        kendoWindow.data("kendoWindow").close();
                    })
                    .end()

                });

                $('#table-scheduledjobs').applySorting(function (event, data) {
                    ws_showProgressBar();
                    _searchJobData.sortKey = data.SortKey;
                    _searchJobData.sortOrder = data.SortOrder;
                    LoadScheduledJobsData(_searchJobData);
                    return false;
                });

                $('#table-jobhistory').applySorting(function (event, data) {
                    ws_showProgressBar();
                    clearPaging();
                    _searchHistoryData.sortKey = data.SortKey;
                    _searchHistoryData.sortOrder = data.SortOrder;
                    LoadJobHistoryData(_searchHistoryData, 1);
                    return false;
                });

                ws_initializeWebApp("/admin/GetAllWebApp", $('#select-webapp'), function () {
                    if (_globalMessage != '') {
                        wsLib_createBootstrapAlert($('#js-notice-message'), _globalMessage, "success", true, 10000);
                    }
                    _searchHistoryData = getJobHistorySearchCriteria();
                    _searchJobData = getJobSearchCriteria();
                    LoadScheduledJobsData(_searchJobData);
                    LoadJobHistoryData(_searchHistoryData, 1);
                });
            });

            function CallBackFunctionFailure(xhr, status, error, callbackdata) {
                ws_hideProgressBar();
                if (xhr.statusText != null && xhr.statusText != undefined) {
                    wsLib_createBootstrapAlert($('#js-notice-message'), xhr.statusText, "error", true);
                }
            }

            function getJobHistorySearchCriteria() {
                var pageSize = $('#select-pagesize option:selected').val();
                var strHostName = $("#select-webapp").val();
                var strJobType = $("#jobtype").val();
                var strResultType = $("#resulttype").val();

                var data = { hostName: strHostName, jobType: strJobType, resultType: strResultType, pageSize: pageSize };
                return data;
            }

            function getJobSearchCriteria() {
                var strHostName = $("#select-webapp").val();
                var data = { hostName: strHostName };
                return data;
            }

            function LoadScheduledJobsData(data) {
                ws_ajaxCall('/scheduler/getScheduledJobs', data , onLoad, CallBackFunctionFailure, null);
                }

            function LoadJobHistoryData(data, curPage) {
                    data['curPage'] = curPage;
                    ws_ajaxCall('/scheduler/fetchJobHistory',data , addJobHistory, CallBackFunctionFailure, null);
            }

            function onLoad(data, callbackdata) {
                $("#table-scheduledjobs > tbody tr").remove();
                    $.each(data.Rows, function (key, value) {
                        var row = createScheduledJobRow(value);
                        $("#table-scheduledjobs > tbody:last").append(row);
                        attachCancellationEvent($("#table-scheduledjobs > tbody:last > tr:last"));
                    });
                ws_hideProgressBar();
            }

            function createScheduledJobRow(rowData) {
                var editPage;
                switch (rowData.Job) {
                    case 'Purge Background Jobs':
                        editPage = '/Scheduler/PurgeBackgroundJobs';
                        break;
                    case 'Purge Process Data':
                        editPage = '/Scheduler/PurgeProcessData';
                        break;
                    case 'Archive Obsolete Workflow Solution':
                        editPage = '/Scheduler/ArchiveObsoleteWorkflowSolution';
                        break;
                    case 'Mark Inactive Processes':
                        editPage = '/Scheduler/MarkInactiveProcesses';
                        break;
                    default:
                        editPage = '#';
                        break;
                }
                var row = '<tr><td style="display:none;">' + rowData.ID + '</td><td class="table-dropdown"><span class="jobType">' + rowData.Job +
                '</span><div class="btn-group"><a class="btn btn-action dropdown-toggle" data-toggle="dropdown" href="#"></a><ul class="dropdown-menu"><li><a href="' + editPage + '?id=' + rowData.ID + '&server=' + rowData.HostName + '">Edit Scheduled Job</a></li><li><a class="cancelJob" href="#">Cancel Scheduled Job</a></li></ul></div></td><td>'
				+ rowData.Schedule + '</td><td>' + rowData.ProcessingDate + '</td></tr>';
                return row;
            }

            function attachCancellationEvent(row) {
                $(row).find(".cancelJob").click(function () {
                    var kendoWindow = $("<div />").kendoWindow({
                        title: "Confirm",
                        resizable: false,
                        modal: true
                    });

                    kendoWindow.data("kendoWindow")
                    .content($("#delete-confirmation").html().replace('{Placeholder}', 'Are you sure you want to cancel this job?'))
                    .center().open();

                    kendoWindow
                    .find(".delete-confirm,.delete-cancel")
                    .click(function () {
                        if ($(this).hasClass("delete-confirm")) {
                            ws_showProgressBar();
                            //Getting HostName
                            var strHostName = $("#select-webapp").val();
                            if (strHostName.length == 0) {
                                return false;
                            }
                            var id = $(row).find("td:first").html();
                            var strJobType = $(row).find(".jobType").html();
                            ws_ajaxCall('/scheduler/cancelJob', { hostName: strHostName, id: id, jobType: strJobType }, function () {
                                LoadScheduledJobsData(_searchJobData);
                                LoadJobHistoryData(_searchHistoryData, 1);
                            }, CallBackFunctionFailure, null);
                        }
                        kendoWindow.data("kendoWindow").close();
                    })
                    .end()

                });
            }

            function addJobHistory(data, callbackdata) {
                $("#table-jobhistory > tbody tr").remove();
                var pageSize = $('#select-pagesize option:selected').val();
                var displayStartRecord = 1;
                if (data.Count > 0) {
                    enablePaging(data.TotalPage, 7);
                    if (data.Rows != null) {
                        $.each(data.Rows, function (key, value) {
                            var row = createJobHistoryRow(value);
                            $("#table-jobhistory > tbody:last").append(row);
                        });
                    }
                    displayStartRecord = (((parseInt(data.CurrentPage) - 1) * parseInt(pageSize)) + 1);
                }
                else {
                    displayStartRecord = 0;
                }
                    
                    var lastRecord = ((parseInt(data.CurrentPage) * parseInt(pageSize)) < data.Count) ? (parseInt(data.CurrentPage) * parseInt(pageSize)) : data.Count;
                    var displayRecords = "Displaying " + displayStartRecord + " - " + lastRecord + " of " + data.Count;
                    $("#lblPage").text(displayRecords);
                ws_hideProgressBar();
            }

            function createJobHistoryRow(rowData) {
                var row = '<tr><td>' + rowData.Job + '</td><td>' + rowData.CompletedDate + '</td><td>'
				+ rowData.Duration + '</td><td>' + rowData.Result + '</td><td>' + rowData.Comments + '</td></tr>';
                return row;
            }

            $("#btnSearch").click(function () {
                ws_showProgressBar();
                clearPaging();
                _searchHistoryData = getJobHistorySearchCriteria();
                LoadJobHistoryData(_searchHistoryData, 1);
                return false;
            });

            $('body').on('click', '.js-tooltip-target', function (event) {
                event.stopPropagation();

                $('div.tooltip').not($(this).siblings('div.tooltip')).remove();
            });

            function ExportData() {
                //Getting HostName
                var strHostName = $("#select-webapp").val();
                if (strHostName.length == 0) {
                    return false;
                }
                //Getting JobType
                var strJobType = $("#jobtype").val();
                if (strJobType.length == 0) {
                    return false;
                }
                //Getting ResultType
                var strResultType = $("#resulttype").val();
                if (strResultType.length == 0) {
                    return false;
                }
                window.open('/scheduler/ExportHistory?hostName=' + strHostName + '&jobType=' + strJobType + '&resultType=' + strResultType, "_parent");

            }

            function enablePaging(totalPages, visiblePages) {
                $('#pagination-elmt').twbsPagination({
                    totalPages: totalPages,
                    visiblePages: visiblePages,
                    onPageClick: function (event, page) {
                        ws_showProgressBar();
                        LoadJobHistoryData(_searchHistoryData, page);
                    }
                });
            }

            function clearPaging() {
                $('#div-paging').html('');
                $('#div-paging').html('<ul id="pagination-elmt" class="pagination-sm"></ul>');
            }

        </script>
</asp:Content>
