﻿<%@ Page Title="Mark Inactive Processes" Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage" %>

<asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
	Mark Inactive Processes
</asp:Content>

<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
 <div class="row-fluid">
                    <div class="span12">
                        <ul id="breadcrumbs">
                            <li><a href="/home">Administration</a> &rsaquo;</li>
                            <li><a href="/Scheduler">Scheduler</a> &rsaquo;</li>
                            <li>Mark Inactive Processes</li>
                            <li class="related-links">
								<ul>
									<li class="related-label">Related:</li>
									<li class="link"><a href="/Scheduler">Scheduler</a></li>
									<li class="link"><a href="/Scheduler/PurgeBackgroundJobs">Purge Background Jobs</a></li>
									<li class="link"><a href="/Scheduler/PurgeProcessData">Purge Process Data</a></li>
									<li class="link"><a href="/Scheduler/ArchiveObsoleteWorkflowSolution">Archive Obsolete Workflow Solution</a></li>
                                    <li class="link"><a href="/Command?admincommandID=unmarkinactiveprocesses">Unmark Inactive Processes</a></li>
								</ul>
							</li>
                        </ul>
                        <ul id="secnav">
                            <li class="active">
                                <h1>Mark Inactive Processes</h1>
                                <p class="page-description">NOTE: This activity can be time consuming. It should be run when the system is idle or not overloaded.
                                </p>
                            </li>
                        </ul>
                    </div>
                </div>
                <div class="row-fluid">
                    <div class="span8">
                        <div class="settings-info">
                            <form class="form-horizontal" id="form-control-container">
                                <fieldset>
                                    <div class="control-group">
                                        <label class="control-label">Dry Run</label>
                                        <div class="controls">
                                            <ul class="checkbox-group">
                                                <li>                                                    
                                                    <label>
                                                        <input type="checkbox" id="dryRunChkBox" />                                                        
                                                    </label>
                                                </li>                                            
                                            </ul>
                                        </div>
                                        </div>
                                        <div class="control-group">
                                         <label class="control-label">Delete Inactive Processes</label>
                                        <div class="controls">
                                            <ul class="checkbox-group">
                                                <li>
                                                    <label>
                                                        <input type="checkbox" id="deleteInactiveProcessesChkBox"/>                                                        
                                                    </label>
                                                </li>                                               
                                            </ul>
                                        </div>
                                        </div>
                                        <div class="control-group">
                                        <label class="control-label">Start Marking</label>
                                        <div class="controls">
                                            <ul class="inline-list checkbox-group">
                                                <li>
                                                    <label>
                                                    <input type="radio" name="startmarking"  id= "markInactiveNowRadio" class="js-startmarking-toggle-view-master-0" checked="checked" check-text="now" autocomplete="off"/> Now
                                                    </label>
                                                </li>
                                                <li>
                                                    <label>
                                                    <input type="radio" name="startmarking" id= "markInactiveScheduleRadio" class="js-startmarking-toggle-view-master-1" check-text="schedule" autocomplete="off"/> Schedule 
                                                    </label>
                                                </li>
                                            </ul>
                                        </div>
                                    </div>
                                    <div class="js-startmarking-toggle-view-slave-1 control-group js-initial-hide">
                                        <label class="control-label">Day <span class="required">*</span></label>
                                        <div class="controls">
                                            <select class="js-chosen-target input-onethirds" id="markInactiveScheduleDayDropDown" validation-type="required" required-message="Schedule Day is a required field.">
                                                <option value="N/A">Select Option</option>
                                                <option value="1">First day of month</option>
                                                <option value="100">Last day of month</option>
                                                <option value="2">2nd</option>
                                                <option value="3">3rd</option>
                                                <option value="4">4th</option>
                                                <option value="5">5th</option>
                                                <option value="6">6th</option>
                                                <option value="7">7th</option>
                                                <option value="8">8th</option>
                                                <option value="9">9th</option>
                                                <option value="10">10th</option>
                                                <option value="11">11th</option>
                                                <option value="12">12th</option>
                                                <option value="13">13th</option>
                                                <option value="14">14th</option>
                                                <option value="15">15th</option>
                                                <option value="16">16th</option>
                                                <option value="17">17th</option>
                                                <option value="18">18th</option>
                                                <option value="19">19th</option>
                                                <option value="20">20th</option>
                                                <option value="21">21st</option>
                                                <option value="22">22nd</option>
                                                <option value="23">23rd</option>
                                                <option value="24">24th</option>
                                                <option value="25">25th</option>
                                                <option value="26">26th</option>
                                                <option value="27">27th</option>
                                                <option value="28">28th</option>
                                                <option value="29">29th</option>
                                                <option value="30">30th</option>
                                            </select>
                                        </div>
                                    </div>
                                    <div class="js-startmarking-toggle-view-slave-1 control-group js-initial-hide">
                                        <label class="control-label">Time <span class="required">*</span></label>
                                        <div class="controls">
                                            <input class="js-kendo-timepicker input-onethirds" type="text" id="markInactiveScheduleTimeDropDown" placeholder="HH:mm AM/PM" validation-type="required,regex" validation-regex="^([0-9]|1[0-2]):[0-5][0-9]\s(AM|PM)$" regex-message="Time should be in HH:MM AM/PM format"/>
                                        </div>
                                    </div>
                                    <div class="control-group">
                                        <label class="control-label" >User(s) to Notify <span class="required" id ="userToNotifySpan" style="visibility:hidden">*</span></label>
                                        <div class="controls">
                                            <input type="text" class="input-max" id="usersToNotifyTxtBox" placeholder="e.g. user@winshuttle.com, user@email.com" validation-type="regex" validation-regex="^((\w+([-+.]\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*)\s*[,]{0,1}\s*)+$" regex-message="Email should be in the format abc@xyz.com."/>
                                        </div>
                                    </div>
                                    <div class="control-group">
                                        <span id="js-notice-message"></span>
                                    </div>
                                    <div class="form-actions top-line">
                                        <button id="btnSave" class="btn btn-primary"><span>Save</span></button>
                                        <button class="btn" id="btnCancel"><span>Cancel</span></button>
                                    </div>
                                </fieldset>
                            </form>
                        </div>
                    </div>
                    <!-- /div .span8 -->
                </div>
                <!-- /div .row-fluid -->
		
        
        <script src="http://ajax.googleapis.com/ajax/libs/jquery/1.11.1/jquery.min.js"></script>
        <script>
            if (!window.jQuery) {
                console.error("jQuery CDN is down.")
                document.write('<script src="<%=Url.Content("~/Content/assets/js/jquery.min.js") %>"><\/script>');
            }
        </script>
        <script src="http://maxcdn.bootstrapcdn.com/bootstrap/3.2.0/js/bootstrap.min.js"></script>
        <script>
            if (!$.fn.modal) {
                console.error("Bootstrap CDN is down.")
                document.write('<script src="<%=Url.Content("~/Content/assets/js/bootstrap.min.js") %>"><\/script>');
            }
        </script>
        <script src="/Content/assets/js/kendo.all.min.js"></script>
        <script src="/Content/assets/js/chosen.jquery.min.js"></script>
        <script src="/Content/assets/js/wslib_master.js"></script>
        <script src="/Content/assets/js/wsplugin_master.js"></script>
        <script src="/Content/assets/js/ws_admincommands.js"></script>        
        <script src="/Content/assets/js/ws_common.js"></script>
        <script>
            var strTimestamp;   //Global Variable
            
            $('.js-chosen-target').chosen({
                width: "33.3333333333%",
                disable_search: true
            });

            wsLib_toggleViews("startmarking", 2, "radio", "no", 200);

            $('input.js-kendo-timepicker').kendoTimePicker();


            $(document).ready(function () {
                ws_showProgressBar();
                ws_initializeWebApp("/admin/GetAllWebApp", $('#select-webapp'), function () {
                    var $id = wsPlugin_getURLParameter('id');
                    var $url = $('#select-webapp').val();
                    if ($id != null) {
                        ws_ajaxCall('/service/detail', { id: $id, url: $url }, function (data, callbackdata) {

                            var xml = data.Xml;
                            var xmlDocumentObj = loadXMLString(xml);
                            strTimestamp = data.TimeStamp;
                            var strStatus = data.Status;
                            var isDryRun = $(xmlDocumentObj).find("IsDryRun").text();
                            var isDeleteProcesses = $(xmlDocumentObj).find("IsDeleteProcesses").text();                            
                            var usersToNotify = $(xmlDocumentObj).find("UsersToNotify").text();                            
                            var hostName = $(xmlDocumentObj).find("HostName").text();
                            var scheduleXml = $(xmlDocumentObj).find("ScheduleXml").text();

                            xmlDocumentObj = loadXMLString(scheduleXml);
                            var scheduleType = $(xmlDocumentObj).find("Type").text();
                            var scheduleDay = $(xmlDocumentObj).find("ScheduleDay").text();
                            var scheduleTime = $(xmlDocumentObj).find("ScheduleTime").text();

                            $("#dryRunChkBox").attr('checked', isDryRun.toLowerCase() === 'true');
                            $("#deleteInactiveProcessesChkBox").attr('checked', isDeleteProcesses.toLowerCase()=== 'true');
                            if (isDryRun.toLowerCase() === 'true') {
                                $("#deleteInactiveProcessesChkBox").prop('disabled', 'disabled')
													   .prop('checked', false);
                                $("#userToNotifySpan").css('visibility', 'visible');
                                $("#usersToNotifyTxtBox").attr('validation-type', 'required,regex');
                            }
                            else {
                                $("#deleteInactiveProcessesChkBox").prop('disabled', '');
                                $("#userToNotifySpan").css('visibility', 'hidden');
                                $("#usersToNotifyTxtBox").attr('validation-type', 'regex');
                            }

                            if (scheduleType == 'now') {
                                $('#markInactiveNowRadio').prop('checked', true).change();
                            }
                            else {
                                $('#markInactiveScheduleRadio').prop('checked', true).change();
                                $("#markInactiveScheduleDayDropDown").val(scheduleDay).trigger("chosen:updated");
                                $("#markInactiveScheduleTimeDropDown").val(scheduleTime);
                            }

                            $("#usersToNotifyTxtBox").val(usersToNotify);
                            $("#select-webapp").val(hostName);
                            if (strStatus != 'Pending') {
                                wsLib_createBootstrapAlert($('#js-notice-message'), "This job cannot be modified. As this is running or no more valid.", "error", false);
                                $("#btnSave").prop('disabled', 'disabled').addClass('btn-disabled');
                                ws_hideProgressBar();
                                return false;
                            }

                        }, null, null);
                        $('#select-webapp').prop("disabled", true);
                    }
                    ws_hideProgressBar();
                });

                $("#select-webapp").change(function () {
                    SetupLinks();
                });

            });

            function CallBackFunctionSuccess(data, callbackdata) {
                window.location.href = '/Scheduler?server=' + $("#select-webapp").val();
            }

            function CallBackFunctionFailure(xhr, status, error, callbackdata) {
                ws_hideProgressBar();
                if (xhr.statusText != null && xhr.statusText != undefined) {
                    wsLib_createBootstrapAlert($('#js-notice-message'), xhr.statusText, "error", true);
                }
            }

            $("#btnCancel").click(function () {
                window.location.href = '/Scheduler?server=' + $("#select-webapp").val();
                return false;
            });

            $('#dryRunChkBox').click(function () {
                if ($("#dryRunChkBox").prop('checked')) {
                    $("#deleteInactiveProcessesChkBox").prop('disabled', 'disabled')
													   .prop('checked', false);
                    $("#userToNotifySpan").css('visibility', 'visible');
                    $("#usersToNotifyTxtBox").attr('validation-type', 'required,regex');


                }
                else {
                    $("#deleteInactiveProcessesChkBox").prop('disabled', '');
                    $("#userToNotifySpan").css('visibility', 'hidden');
                    $("#usersToNotifyTxtBox").attr('validation-type', 'regex');
                }
            });

            function ValidateScheduleDay() {
                $("#markInactiveScheduleDayDropDown_chosen-validationMessage").remove();
                val = $("#markInactiveScheduleDayDropDown").find("option:selected").val();
                if ($("#markInactiveScheduleDayDropDown_chosen").is(':visible') && val == "N/A") {
                    createSpanElement($("#markInactiveScheduleDayDropDown_chosen"), 'Schedule Day is a required field.', 'field-validation-error');
                    $("#markInactiveScheduleDayDropDown").on('change', function () {
                        if ($("#markInactiveScheduleDayDropDown").find("option:selected").val() == "N/A") {
                            $("#markInactiveScheduleDayDropDown_chosen-validationMessage").remove();
                            createSpanElement($("#markInactiveScheduleDayDropDown_chosen"), 'Schedule Day is a required field.', 'field-validation-error');
                        }
                        else {
                            $("#markInactiveScheduleDayDropDown_chosen-validationMessage").remove();
                        }
                    });
                    return false;
                }

                return true;
            }

            $("#btnSave").click(function () {
                var blnScheduleDayValdiation = ValidateScheduleDay();
                if (!validateClientSide('form-control-container') || !blnScheduleDayValdiation) {
                    return false;
                }

                var blnIsDryRun, blnIsDeleteInactiveProcesses, blnMarkInactiveNow, strScheduleType, strScheduleDay, strScheduleTime, strUserNotifyEmail;

                blnIsDryRun = $("#dryRunChkBox").prop('checked');
                blnIsDeleteInactiveProcesses = $("#deleteInactiveProcessesChkBox").prop('checked');

                //Getting Schedule Pattern
                blnMarkInactiveNow = $("#markInactiveNowRadio").prop('checked');
                strScheduleType = $("input[name=startmarking]:checked").attr('check-text');
                if (blnMarkInactiveNow == false) {
                    strScheduleDay = $("#markInactiveScheduleDayDropDown").val();
                    if (strScheduleDay.length == 0) {
                        return false;
                    }
                    strScheduleTime = $("#markInactiveScheduleTimeDropDown").val();
                    if (strScheduleTime.length == 0) {
                        return false;
                    }
                }

                strUserNotifyEmail = $("#usersToNotifyTxtBox").val();

                //Getting HostName
                var strHostName = $("#select-webapp").val();
                if (strHostName.length == 0) {
                    return false;
                }

                var $id = wsPlugin_getURLParameter('id');
                ws_showProgressBar();
                if ($id == null) {
                    ws_ajaxCall('/Scheduler/CreateMarkInactiveProcessesEntry',
                            {
                                isDryRun: blnIsDryRun,
                                isDeleteInactiveProcesses: blnIsDeleteInactiveProcesses,
                                isMarckInactiveNow: blnMarkInactiveNow,
                                scheduleType: strScheduleType,
                                scheduleDay: strScheduleDay,
                                scheduleTime: strScheduleTime,
                                usersToNotify: strUserNotifyEmail,
                                hostName: strHostName
                            },
                              CallBackFunctionSuccess, CallBackFunctionFailure,
                              null);
                        } else {
                            ws_ajaxCall('/Scheduler/UpdateMarkInactiveProcessesEntry',
                            {
                                id: $id,
                                isDryRun: blnIsDryRun,
                                isDeleteInactiveProcesses: blnIsDeleteInactiveProcesses,
                                isMarckInactiveNow: blnMarkInactiveNow,
                                scheduleType: strScheduleType,
                                scheduleDay: strScheduleDay,
                                scheduleTime: strScheduleTime,
                                usersToNotify: strUserNotifyEmail,
                                hostName: strHostName,
                                timeStamp: strTimestamp
                            },
                              CallBackFunctionSuccess, CallBackFunctionFailure,
                              null);
                }
                return false;
            });
        </script>		         
</asp:Content>
