﻿<%@ Page Title="Participant Resolvers" Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage" %>

<asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
	Participant Resolvers
</asp:Content>

<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
<div class="row-fluid">
                    <div class="span12">
                        <ul id="breadcrumbs">
                            <li><a href="/Home">Administration</a> &rsaquo;</li>
                            <li><a href="/ServerConfig">Workflow Design Configuration</a> &rsaquo;</li>
                            <li>Participant Resolvers</li>
                            <li class="related-links">
                                <ul>
                                    <li class="related-label">Related Tasks:</li>
                                    <li class="link"><a href="/ServerConfig/Index">Workflow Design Configuration</a></li>
                                    <li class="link"><a href="/ServerConfig/Plugins">Plugins</a></li>
                                    <li class="link"><a href="/ServerConfig/FormControls">Form Controls</a></li>
                                </ul>
                            </li>
                        </ul>
                        <ul id="secnav">
                            <li class="active">
                                <h1>Participant Resolvers</h1>                                
                            </li>
                        </ul>
                    </div>                    
                </div>
                <div class="control-group">
                    <span id="js-notice-message"></span>
                </div>
                <div class="row-fluid">
                    <table class="table table-header">
                        <tbody>
                            <tr>
                                <td>
                                    <form>
                                        <div>
                                            <label>Name Contains</label>
                                            <input type="text" id="txtNameControl" class="form-control input-xlarge" placeholder=""/>
                                        </div>
                                        <div>
                                            <label>Definition Contains</label>
                                            <input type="text" id="txtDefinitionControl" class="form-control input-xlarge" placeholder=""/>
                                        </div>
                                        <div>
                                            <label>&nbsp;</label>
                                            <button id="btnSearch" class="btn btn-primary"><span>Search</span></button>
                                        </div>
                                    </form>
                                </td>
                            </tr>
                        </tbody>
                    </table>
                </div>
                <div class="row-fluid">
                    <div class="span12">
                        <table id="table-controls" class="table table-scheduler table-striped table-bordered">
                            <thead>
                                <tr class="table-menu">
                                    <th colspan="2">
                                        <div class="display">
                                            <span id="rowDisplay"></span>
                                            <select name="" id="pagesizedropdown" onchange="" class="input-small">
                                                <option selected="selected" value="10">10</option>
                                                <option value="20">20</option>                                                
                                                <option value="50">50</option>
                                                <option value="100">100</option>
                                            </select>
                                        </div>
                                    </th>
                                </tr>
                                <tr class="table-sort">
                                    <th sort-indicator="Ascending" class="sortup"  sort-key="Name" ><a href="#">Name</a></th>
                                    <th class="no-sort">Definition</th>
                                </tr>
                            </thead>
                            <tbody>                               
                            </tbody>
                        </table>
                        <div id="div-paging">
                            <ul id="pagination-elmt"class="pagination-sm"></ul>
                        </div>
                    </div>
                    <!-- /div .span8 -->
                </div>
                <!-- /div .row-fluid -->
				
        <script src="http://ajax.googleapis.com/ajax/libs/jquery/1.11.1/jquery.min.js"></script>
        <script>
            if (!window.jQuery) {
                console.error("jQuery CDN is down.")
                document.write('<script src="<%=Url.Content("~/Content/assets/js/jquery.min.js") %>"><\/script>');
            }
        </script>
        <script src="http://maxcdn.bootstrapcdn.com/bootstrap/3.2.0/js/bootstrap.min.js"></script>
        <script>
            if (!$.fn.modal) {
                console.error("Bootstrap CDN is down.")
                document.write('<script src="<%=Url.Content("~/Content/assets/js/bootstrap.min.js") %>"><\/script>');
            }
        </script>
        <script src="<%=Url.Content("~/Content/assets/js/kendo.all.min.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/chosen.jquery.min.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/wslib_master.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/wsplugin_master.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/ws_common.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/jquery.twbsPagination.min.js") %>"></script>
        <script>
            $('a.js-tooltip-target').tooltip({
                html: true,
                trigger: 'click',
                animation: true
            });
            
            $('body').on('click', '.js-tooltip-target', function(event) {
                event.stopPropagation();
                
                $('div.tooltip').not($(this).siblings('div.tooltip')).remove();
            });
        </script>
        <script>
           var thePageCount;
           var theRecordCount;
           var orderSort = 'ASC';
           var pagenumber = 1;
           var _globalMessage = '<%=TempData["PRMessage"] %>';
           $('a.js-tooltip-target').tooltip({
               html: true,
               trigger: 'click',
               animation: true
           });

           $('body').on('click', '.js-tooltip-target', function (event) {
               event.stopPropagation();

               $('div.tooltip').not($(this).siblings('div.tooltip')).remove();
           });

           $(document).ready(function () {
               ws_showProgressBar();
               ws_initializeWebApp("/admin/GetAllWebApp", $('#select-webapp'), OnLoad);
               $("#btnSearch").click(function () {
                   wsLib_destroyBootstrapAlert($('#js-notice-message'));
                   _globalMessage = '';
                   clearPaging();
                   pagenumber = 1;
                   LoadData(pagenumber);
                   return false;
               });

               BindEnterKeyEvent($("#txtNameControl, #txtDefinitionControl"), $("#btnSearch"));

               $('#select-webapp').change(function () {
                   SetupLinks();
               });

               $('#pagesizedropdown').change(function () {
                   wsLib_destroyBootstrapAlert($('#js-notice-message'));
                   clearPaging();
                   _globalMessage = '';
                   pagenumber = 1;
                   LoadData(pagenumber);
                   return false;
               });

               ApplySorting();
           });

           function OnLoad() {
               clearPaging();
               $("#txtNameControl").val("");
               $("#txtDefinitionControl").val("");
               pagenumber = 1;
               LoadData(pagenumber);
               return false;
           }

           function LoadData(pagenumber) {
               ws_showProgressBar();
               $('#table-controls > tbody tr').remove();
               ws_ajaxCall("/ServerConfig/GetAllParticipantResolvers", { server: $('#select-webapp').val(),
                   pagesize: $('#pagesizedropdown').val(),
                   pagenumber: pagenumber,
                   namefilter: $("#txtNameControl").val(),
                   descfilter: $("#txtDefinitionControl").val(),
                   ordersort: orderSort
               }, CallBackSuccess, CallBackFailure, null);
               return false;
           }

           function CallBackFailure(xhr, status, error, callbackdata) {
               ws_hideProgressBar();
               if (xhr.statusText != null && xhr.statusText != undefined) {
                   wsLib_createBootstrapAlert($('#js-notice-message'), xhr.statusText, "error", true);
               }
           }

           function CallBackSuccess(data) {               
               var message = '';
               if (data.PageCount != undefined && data.RecordCount != undefined && data.Records != null && data.Records != undefined) {
                   enablePaging(data.PageCount, 7);
                   thePageCount = data.PageCount;
                   theRecordCount = data.RecordCount;
                   $.each(data.Records, function (k, v) {
                       var row = CreateRow(v);
                       $("#table-controls > tbody:last").append(row);
                   });


                   var theCount = data.PageCount;
                   if (theCount > 0) {
                       var recordcount = $('#pagesizedropdown').val() * (pagenumber);
                       if (data.RecordCount >= recordcount) {
                           var therecords = ($('#pagesizedropdown').val() * (-1 + pagenumber)) + 1;
                           message = 'Displaying ' + therecords + ' to ' + (therecords + parseInt($('#pagesizedropdown').val()) - 1) + ' of ' + data.RecordCount;
                       }
                       else {
                           var therecords = ($('#pagesizedropdown').val() * (-1 + pagenumber)) + 1;
                           message = 'Displaying ' + therecords + ' to ' + (data.RecordCount) + ' of ' + data.RecordCount;
                       }
                   }
               }
               else {
                   wsLib_createBootstrapAlert($('#js-notice-message'), '<%=Resources.Resource.WFAdminWeb_Page_NoResultFound %>', "success", true);
               }

               $('#rowDisplay').text(message);

               ws_hideProgressBar();
               if (_globalMessage != null && _globalMessage != undefined && $.trim(_globalMessage).length != 0) {
                   wsLib_createBootstrapAlert($('#js-notice-message'), _globalMessage, "success", true);
               }

               return false;
           }


           function CreateRow(obj) {
               var markup = 
                '<tr>' +
                '  <td>' + obj.Name + '<a href="editpr?server=' + $('#select-webapp').val() + '&name=' + obj.Name + '" class="edit"><i class="icon-edit"></i></a></td>' +
                '        <td>' + $('<span/>').text(obj.MetaData.toString()).html() + '</td>' +
                '   </tr>';
               
               return markup;
           }

           function DeletePR(id) {
               ws_showProgressBar();
               _globalMessage = '';
               ws_ajaxCall("/ServerConfig/DeleteParticipantResolver", { server: $('#select-webapp').val(),
                   id: id,
                   pagenumber: 1,
                   pagesize: $('#pagesizedropdown').val(),
                   namefilter: $("#txtNameControl").val(),
                   descfilter: $("#txtDefinitionControl").val()
               }, CallBackSuccess, CallBackFailure, null);

               return false;
           }
           </script>
           <script>
               function clearPaging() {
                   $('#div-paging').html('');
                   $('#div-paging').html('<ul id="pagination-elmt"class="pagination-sm"></ul>');
               }

               function enablePaging(totalPages, visiblePages) {
                   $('#pagination-elmt').twbsPagination({
                       totalPages: totalPages,
                       visiblePages: visiblePages,
                       onPageClick: function (event, page) {
                           _globalMessage = '';
                           pagenumber = page;
                           LoadData(page);
                       }
                   });
               }

               function resetSortingFunctionality() {
                   var ths = $('#table-controls').find('th[sort-indicator]').removeClass().attr('sort-indicator', 'NoSort');
                   orderSort = "DESC";
               }

               function CallBackFunctionFailure(xhr, status, error, callbackdata) {
                   ws_hideProgressBar();
                   if (xhr.statusText != null && xhr.statusText != undefined) {
                       wsLib_createBootstrapAlert($('#js-notice-message'), xhr.statusText, "error", true);
                   }
               }

               function ApplySorting() {
                   $('#table-controls').applySorting(function (event, data) {
                       ws_showProgressBar();
                       _globalMessage = '';
                       orderSort = (data.SortOrder.toLowerCase() == 'descending' ? 'DESC' : 'ASC');
                       LoadData(pagenumber);
                       return false;
                   });
               }
           </script>
</asp:Content>
