﻿<%@ Page Title="Job Details" Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage" %>

<asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
	Job Details
</asp:Content>

<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
 <div class="row-fluid">
                    <div class="span12">
                        
                        <ul id="breadcrumbs">
                            <li><a href="/Home">Administration</a> &rsaquo;</li>
                            <li>Job Details</li>
                            <li class="related-links">
							<ul>
                                    <li class="related-label">Related:</li>
                                    <li>
                                        <a href="/Job">Background Jobs</a>
                                    </li>
                                    <li>
                                        <a href="/WorkflowProcess">Process Control</a>
                                    </li>
                                    <li>
                                        <a href="/Scheduler">Scheduler</a>
                                    </li>
                                </ul>
						    </li>
                        </ul>
                        <ul id="secnav">
                            <li class="active">
                                <h1>Job Details</h1>
                            </li>
                            <li class="pull-right">
                            	<button id="btn-reset-pending" class="btn pull-right"><span>Reset Status to Pending</span></button>
                            </li>
                        </ul>
                    </div>
                </div>
                 <div class="control-group">
                          <span id="js-notice-message"></span>
                    </div>
                <div class="row-fluid">
                    <div class="span8" id="service-details">
                        
                    </div><!-- /div .span6 -->
                </div><!-- /div .row-fluid -->
				
        <script src="http://ajax.googleapis.com/ajax/libs/jquery/1.11.1/jquery.min.js"></script>
        <script>
            if (!window.jQuery) {
                console.error("jQuery CDN is down.")
                document.write('<script src="<%=Url.Content("~/Content/assets/js/jquery.min.js") %>"><\/script>');
            }
        </script>
        <script src="http://maxcdn.bootstrapcdn.com/bootstrap/3.2.0/js/bootstrap.min.js"></script>
        <script>
            if (!$.fn.modal) {
                console.error("Bootstrap CDN is down.")
                document.write('<script src="<%=Url.Content("~/Content/assets/js/bootstrap.min.js") %>"><\/script>');
            }
        </script>
        <script src="<%=Url.Content("~/Content/assets/js/kendo.all.min.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/wslib_master.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/wsplugin_master.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/ws_admincommands.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/jquery.tmpl.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/ws_common.js") %>"></script>
        <script type="text/javascript">
            $(document).ready(function () {
                $("#select-webapp").change(function () {
                    SetupLinks();
                });
                ws_initializeWebApp('/admin/getallwebapp', $('#select-webapp'), function () {                    
                    GetDetails();
                    return false;
                });

                $("#btn-reset-pending").on("click", function () {
                    var tempid = wsPlugin_getURLParameter('id');
                    var tempurl = $("#select-webapp").val();
                    ws_ajaxCall('/service/setpending', { id: tempid, url: tempurl }, function (data, callbackdata) {
                        GetDetails();
                        return false;
                    }, CallBackFunctionFailure, null);
                });

                function GetDetails() {
                    $("#service-details").empty();
                    var $id = wsPlugin_getURLParameter('id');
                    var $url = $("#select-webapp").val();
                    ws_ajaxCall('/service/detail', { id: $id, url: $url }, function (data, callbackdata) {
                        if (data.StatusCode == 1 || data.StatusCode == 4) {
                            $("#btn-reset-pending").remove();
                        }
                                                
                        $("#service-details").html($("#service-detail-tmpl").tmpl(data));
                    }, CallBackFunctionFailure, null);
                }
            });

            function CallBackFunctionFailure(xhr, status, error, callbackdata) {
                ws_hideProgressBar();
                if (xhr.statusText != null && xhr.statusText != undefined) {
                    wsLib_createBootstrapAlert($('#js-notice-message'), xhr.statusText, "error", true);
                }
            }

            
        </script>
        <script id="service-detail-tmpl" type="text/x-jQuery-tmpl">
            <div class="settings-info">
                <p class="clearfix">
                    <span class="label">Type</span>
                    ${Type}
                </p>
                <p class="clearfix">
                    <span class="label">ID</span>
                    ${ID}
                </p>
                <p class="clearfix">
                    <span class="label">Status</span>
                    ${Status}
                </p>
                <p class="clearfix">
                    <span class="label">Start Date</span>
                    ${StartDate}
                </p>
                <p class="clearfix">
                    <span class="label">Completion Date</span>
                    ${CompletionDate}
                </p>
                <p class="clearfix">
                    <span class="label">Assembly Name</span>
                    ${AssemblyName}
                </p>
                <p class="clearfix">
                    <span class="label">Class Name</span>
                    ${ClassName}
                </p>
                <p class="clearfix">
                    <span class="label">XML</span>
                    ${Xml}
                </p>
                <p class="clearfix">
                    <span class="label">Reference Key</span>
                    ${ReferenceKey}
                </p>
                 <p class="clearfix">
                    <span class="label">Error</span>
                    ${Error}
                </p>
            </div>
        </script>
</asp:Content>
