﻿<%@ Page Title="Manage Background Jobs" Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage" %>

<asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
	Manage Background Jobs
</asp:Content>

<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
 <div class="row-fluid">
                    <div class="span12">
                        <ul id="breadcrumbs">
                            <li><a href="/Home">Administration</a> &rsaquo;</li>
                            <li>Manage Background Jobs</li>
                            <li class="related-links">
                                <ul>
                                    <li class="related-label">Related:</li>
                                    <li class="link"><a href="/WorkflowProcess">Process Control</a></li>
                                    <li class="link"><a href="/Scheduler">Scheduler</a></li>
                                </ul>
                            </li>
                        </ul>
                        <ul id="secnav">
                            <li class="active">
                                <h1>Manage Background Jobs</h1>
                            </li>
                        </ul>
                    </div>
                    <div class="control-group">
                          <span id="js-notice-message"></span>
                    </div>
                </div>
                <div class="row-fluid">
                    <table class="table table-header">
                        <tbody>
                            <tr>
                                <td>
                                    <form>
                                       <div>
                                            <label>Period</label>
                                            <select name="" class="input-large" id="svserviceperiod">
                                                <option value="all">All</option>
                                                <option selected="selected" value="1w">Last 1 Week</option>
                                                <option value="1m">Last 1 Month</option>
                                                <option value="3m">Last 3 Months</option>
                                                <option value="1y">Last 1 Year</option>
                                            </select>
                                        </div>
                                        <div>
                                            <label>Type</label>
                                            <select name="" class="input-small" id="svservicetype">
                                                <option selected="selected" value="all">All</option>
                                            </select>
                                        </div>
                                        <div>
                                            <label>Status</label>
                                            <select name="" class="input-small" id="svservicestatus">
                                                <option selected="selected" value="all">All</option>
                                            </select>
                                        </div>
                                        <div>
                                            <label>&nbsp;</label>
												<button id="btnSearch" class="btn btn-primary"><span>Search</span></button>
                                        </div>
                                    </form>
                                </td>
                            </tr>
                        </tbody>
                    </table>
                </div>
                <div class="row-fluid">
                    <table id="table-SVServiceData" class="table table-striped table-bordered">
                        <thead>
                            <tr class="table-menu">
                                <th colspan="9">
                                    <div class="js-administration-managebackgroundjobs-resetstatus js-initial-hide">
                                        <button class="btn" id ="btnReset"><span>Reset status to pending</span></button>
                                    </div>
                                    <div class="display">
                                        <span id="rowDisplay"></span>
                                        <select name="" id="dropdownpagesize" class="input-small">
                                            <option selected="selected" value="10">10</option>
                                            <option value="20">20</option>                                            
                                            <option value="50">50</option>
                                            <option value="100">100</option>
                                        </select>
                                        <a href="#" onclick="ExportData();return false;">Export</a>
                                    </div>
                                </th>
                            </tr>
                            <tr class="table-sort">
                                <th title="checkbox" width="2%" class="no-sort">
                                    <span title="Select All">
                                    <input id="checkallBox" class="js-managebackgroundjobs-check-all-master" type="checkbox"/>
                                    </span>
                                </th>
                                <th sort-indicator="Descending" class="sortdown" sort-key="ID"><a href="#">ID</a></th>
                                <th sort-key="StatusString"><a href="#">Status</a></th>
                                <th sort-key="Type"><a href="#">Type</a></th>
                                <th sort-key="ClassName"><a href="#">Class Name</a></th>
                                <th sort-key="StartDate"><a href="#">Start</a></th>
                                <th sort-key="CompletionDate"><a href="#">Stopped</a></th>
                                <th sort-key="ReferenceKey"><a href="#">Ref Key</a></th>
                                <th sort-key="Owner"><a href="#">Owner</a></th>
                            </tr>
                        </thead>
                        <tbody>
                        </tbody>
                    </table>
                    <div id="div-paging">
                        <ul id="pagination-elmt"class="pagination-sm"></ul>
                    </div>
                </div>
                <script src="http://ajax.googleapis.com/ajax/libs/jquery/1.11.1/jquery.min.js"></script>
        <script>
            if (!window.jQuery) {
                console.error("jQuery CDN is down.")
                document.write('<script src="<%=Url.Content("~/Content/assets/js/jquery.min.js") %>"><\/script>');
            }
        </script>
        <script src="http://maxcdn.bootstrapcdn.com/bootstrap/3.2.0/js/bootstrap.min.js"></script>
        <script>
            if (!$.fn.modal) {
                console.error("Bootstrap CDN is down.")
                document.write('<script src="<%=Url.Content("~/Content/assets/js/bootstrap.min.js") %>"><\/script>');
            }
        </script>
        <script src="<%=Url.Content("~/Content/assets/js/kendo.all.min.js")%>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/chosen.jquery.min.js")%>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/wslib_master.js")%>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/wsplugin_master.js")%>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/ws_global_initialization_administration.js")%>"></script>
		<script src="<%=Url.Content("~/Content/assets/js/ws_common.js")%>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/jquery.twbsPagination.min.js") %>"></script>
        
        <script>
            var currentPage = 1;
            var orderBy = 'ID';
            var orderSort = 'DESC';
            $(document).ready(function () {
                ws_showProgressBar();
                ws_initializeWebApp("/admin/GetAllWebApp", $('#select-webapp'), function () {
                    ws_initializeDropdown("/job/GetJobStatuses", null, $('#svservicestatus'), LoadJobTypes, CallBackFunctionFailure, null, false, null);
                });
                ApplySorting();
                //ws_hideProgressBar();
                $("#select-webapp").change(function () {
                    SetupLinks();
                });

                $("#dropdownpagesize").change(function () {
                    wsLib_destroyBootstrapAlert($('#js-notice-message'));
                    ws_showProgressBar();
                    var pagesize = this.value;
                    clearPaging();
                    currentPage = 1;
                    LoadData($("#select-webapp").val(), getPeriod(), $('#svservicetype').val(), $('#svservicestatus').val(), pagesize, currentPage);
                    //ws_hideProgressBar();
                });

                $("#btnSearch").click(function () {
                    wsLib_destroyBootstrapAlert($('#js-notice-message'));
                    ws_showProgressBar();
                    var url = $("#select-webapp").val();
                    clearPaging();
                    currentPage = 1;
                    LoadData(url, getPeriod(), $('#svservicetype').val(), $('#svservicestatus').val(), $('#dropdownpagesize').val(), currentPage);
                    return false;
                });

                $("#btnReset").click(function () {
                    wsLib_destroyBootstrapAlert($('#js-notice-message'));
                    ws_showProgressBar();
                    var ID = '';
                    $('input[name=selectedCheckbox]').each(function () {
                        if (this.checked) {
                            var td = $(this).closest("td");
                            var id = $(td).next().text();
                            ID += id + ',';
                        }
                    });

                    SetStatus(ID.substring(0, ID.lastIndexOf(",")), 1);
                    //ws_hideProgressBar();
                });

                //enablePaging(data.TotalPage, 7);
            });

            function ResetAll() {
				$('#table-SVServiceData > tbody tr').remove();			
                var $master = $('.js-managebackgroundjobs-check-all-master');
				$master.prop('disabled', true);
				$master.attr('disabled', 'disabled');
                $master.prop({ 'checked': false, 'indeterminate': false });
                var $administrationManageBackgroundJobsResetStatus = $('div.js-administration-managebackgroundjobs-resetstatus');
                $administrationManageBackgroundJobsResetStatus.fadeOut();
            }

            function LoadJobTypes() {
                ws_initializeDropdown("/job/GetJobTypes", { server: $('#select-webapp').val() }, $('#svservicetype'), 
                CallBackFunctionSuccess, CallBackFunctionFailure, null, false, getOption);
            }

            function getOption(data) {
                var option = '';
                if (data != undefined && data != null) {
                    $.each(data, function (k, v) {
                        option += '<option value="' + v + '">' + v + '</option>';
                    });
                }

                return option;
            }

            function createRow(rowData) {
                var theStatusClass = '';
                if (rowData.Status == "1") {
                    theStatusClass = 'icon-status-pending';
                }
                else if (rowData.Status == "2") {
                    theStatusClass = 'icon-status-complete';
                }
                else if (rowData.Status == "3") {
                    theStatusClass = 'icon-status-error';
                }
                else if (rowData.Status == "4") {
                    theStatusClass = 'icon-status-running';
                }

                var theRowContent =
                '<tr>' +
                                '<td class="js-managebackgroundjobs-check-all-slaves" title="checkbox" width="2%">';
                if (rowData.Status != "1" && rowData.Status != "4") {
                    theRowContent += '<input id="" type="checkbox" name="selectedCheckbox" onclick="" />';
                }
                theRowContent += '</td>';
                theRowContent += '<td><a href="/job/detail?server=' + $('#select-webapp').val() + '&id=' + rowData.ID + '">' + rowData.ID + '</a></td>' +
                                '<td class="table-dropdown process-status">' +
                                    '<span class="' + theStatusClass + '"></span>' +
                                    '<span>' + rowData.StatusString + '</span>';

                if (rowData.Status != "1" && rowData.Status != "4") {
                    theRowContent += '<div class="btn-group">' +
                                        '<a class="btn btn-action dropdown-toggle" data-toggle="dropdown" href="#"></a>' +
                                        '<ul class="dropdown-menu">' +
                                            '<li><a href="/job/detail?server=' + $('#select-webapp').val() + '&id=' + rowData.ID + '">View Details</a></li>';

                    theRowContent += '<li><a href="#" onclick="SetStatus(\'' + rowData.ID + '\', 1);">[Reset to Pending]</a></li>';
                }

                theRowContent += '</ul>' +
                                    '</div>';

                theRowContent += '</td>' +
                                '<td>' + rowData.Type + '</td>' +
                                '<td>' + rowData.ClassName + '</td>' +
                                '<td>' + rowData.StartDate + '</td>' +
                                '<td>' + rowData.CompletionDate + '</td>' +
                                '<td>' + rowData.ReferenceKey + '</td>' +
                                '<td>' + rowData.Owner + '</td>' +
                            '</tr>';
                return theRowContent;
            }

            function getPeriod() {
                return $('#svserviceperiod').val();
            }

            function ExportData() {
                window.open('/Job/ExportLogs?server=' + $('#select-webapp').val() + '&period=' + getPeriod() + '&type=' +
                $('#svservicetype').val() + '&status=' + $('#svservicestatus').val(), "_parent");
            }

            function SetStatus(id, status) {
                ws_ajaxCall('/Job/UpdateEntry', {
                    server: $('#select-webapp').val(),
                    status: status,
                    ids: id
                },
                function (data) {
                    clearPaging();
                    LoadData($('#select-webapp').val(), getPeriod(), $('#svservicetype').val(), $('#svservicestatus').val(), $('#dropdownpagesize').val(), 1);
                }, CallBackFunctionFailure, null);

                return false;
            }

            function CallBackFunctionSuccess(data, callbackdata) {
                clearPaging();
                LoadData($('#select-webapp').val(), getPeriod(), $('#svservicetype').val(), $('#svservicestatus').val(), $('#dropdownpagesize').val(), 1);
            }

            function LoadData(serverurl, periodvalue, servicetype, servicestatus, pagesize, pagenumber) {
                // $("#checkallBox").prop("checked", false);
				//' $("#checkallBox").prop("disabled", true);
				//' $('#table-SVServiceData > tbody tr').remove();
				ResetAll();
                ws_ajaxCall('/Job/GetJobs', {
                    server: serverurl,
                    period: periodvalue,
                    status: servicestatus,
                    type: servicetype,
                    pagesize: pagesize,
                    pagenumber: pagenumber,
                    orderby: orderBy,
                    ascdesc: orderSort
                },
                function (data) {
                    var message = '';
                    if (data.PageCount != undefined && data.PageCount > 0) {
                        //alert('Page Count: ' + data.PageCount);                                                
                        if (data.Records != undefined) {
                            enablePaging(data.PageCount, 7);                            
                            $.each(data.Records, function (k, v) {
                                var row = createRow(v);
                                $("#table-SVServiceData > tbody:last").append(row);
                            });

                            var theCount = data.PageCount;
                            if (theCount > 0) {
                                var recordcount = $('#dropdownpagesize').val() * (currentPage);
                                if (data.RecordCount >= recordcount) {
                                    var therecords = ($('#dropdownpagesize').val() * (-1 + pagenumber)) + 1;
                                    message = 'Displaying ' + therecords + ' to ' + (therecords + parseInt($('#dropdownpagesize').val()) - 1) + ' of ' + data.RecordCount;
                                }
                                else {
                                    var therecords = ($('#dropdownpagesize').val() * (-1 + currentPage)) + 1;
                                    message = 'Displaying ' + therecords + ' to ' + (data.RecordCount) + ' of ' + data.RecordCount;
                                }
                            }

                            var $master = $('.js-managebackgroundjobs-check-all-master');
                            var $slaveRing = $('.js-managebackgroundjobs-check-all-slaves');
							var $slaves = $slaveRing.children('input[type="checkbox"]');
							if($slaves.length > 0)
							{
								$master.removeProp('disabled');
								$master.removeAttr('disabled');
							}							
							
							wsLib_checkAll('managebackgroundjobs', undefined, {
                            empty: function () {
                                $administrationManageBackgroundJobsResetStatus.fadeOut();
                            },
                            partial: function () {
                                $administrationManageBackgroundJobsResetStatus.fadeIn();
                            },
                            full: function () {
                                $administrationManageBackgroundJobsResetStatus.fadeIn();
                            }
                        }
						);
                        }
                        else {
                            wsLib_createBootstrapAlert($('#js-notice-message'), '<%=Resources.Resource.WFAdminWeb_Page_NoResultFound %>', "success", true);
                        }

                    $('#rowDisplay').text(message);                    
                }
				else
				{
				    wsLib_createBootstrapAlert($('#js-notice-message'), '<%=Resources.Resource.WFAdminWeb_Page_NoResultFound %>', "success", true);
                    $('#rowDisplay').text('');
				}
				
				ws_hideProgressBar();
				}, CallBackFunctionFailure, null);
            }

            //ApplySorting();

            function clearPaging() {
                $('#div-paging').html('');
                $('#div-paging').html('<ul id="pagination-elmt"class="pagination-sm"></ul>');
            }
           
            function enablePaging(totalPages, visiblePages) {

                $('#pagination-elmt').twbsPagination({
                    totalPages: totalPages,
                    visiblePages: visiblePages,
                    onPageClick: function (event, page) {
                        ws_showProgressBar();
                        currentPage = page;
                        LoadData($('#select-webapp').val(), getPeriod(), $('#svservicetype').val(), $('#svservicestatus').val(), $('#dropdownpagesize').val(), page);
                        //ws_hideProgressBar();
                    }
                });
            }


            function CallBackFunctionFailure(xhr, status, error, callbackdata) {
                ws_hideProgressBar();
                if (xhr.statusText != null && xhr.statusText != undefined) {
                    wsLib_createBootstrapAlert($('#js-notice-message'), xhr.statusText, "error", true);
                }
            }

            function ApplySorting() {
                $('#table-SVServiceData').applySorting(function (event, data) {
                    ws_showProgressBar();
                    //clearPaging();
                    orderBy = data.SortKey;
                    orderSort = (data.SortOrder.toLowerCase() == 'descending' ? 'DESC' : 'ASC');
                    LoadData($('#select-webapp').val(), getPeriod(), $('#svservicetype').val(), $('#svservicestatus').val(), $('#dropdownpagesize').val(), currentPage);
                    //ws_hideProgressBar();
                    return false;
                });
            }
        </script>
        <script>
            $('a.js-tooltip-target').tooltip({
                html: true,
                trigger: 'click',
                animation: true
            });

            $('body').on('click', '.js-tooltip-target', function (event) {
                event.stopPropagation();

                $('div.tooltip').not($(this).siblings('div.tooltip')).remove();
            });

            var $administrationManageBackgroundJobsResetStatus = $('div.js-administration-managebackgroundjobs-resetstatus');

            wsLib_checkAll('managebackgroundjobs', undefined, {
                empty: function () {
                    $administrationManageBackgroundJobsResetStatus.fadeOut();
                },
                partial: function () {
                    $administrationManageBackgroundJobsResetStatus.fadeIn();
                },
                full: function () {
                    $administrationManageBackgroundJobsResetStatus.fadeIn();
                }
            });
        </script>
</asp:Content>

