﻿<%@ Page Title="Add Configuration Key" Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage" %>

<asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
    Add Configuration
</asp:Content>
<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
    <div class="row-fluid">
        <div class="span12">
            <ul id="breadcrumbs">
                <li><a name='aAdministration' href="/Home">Administration</a> &rsaquo;</li>
                <li><a name='aConfigureOptions' href="/KeyConfiguration">Configuration Options</a> &rsaquo;</li>
                <li>Add Configuration</li>                
                <li class="related-links">
                    <ul>
                        <li class="related-label">Related Tasks:</li>
                        <li class="link"><a href="/KeyConfiguration">Configuration Options</a></li>
                        <li class="link"><a href="http://cdn.winshuttle.com/products/help/winshuttle-foundation-help-center/index.htm#options.htm">
                        Configuration Documentation</a></li>
                    </ul>
                </li>
            </ul>
            <ul id="secnav">
                <li class="active">
                    <h1>
                        Add Configuration</h1>
                </li>
            </ul>
        </div>
    </div>
    <div class="row-fluid">
        <div class="span8">
            <div class="settings-info">
                <form class="form-horizontal">
                <fieldset>
                    <div class="control-group" id="divTextBox">
                        <label class="control-label">
                            Name <span class="required">*</span></label>
                        <div class="controls">
                            <input type="text" id="txtKeyName" class="form-control input-block-level input-max" data-provide="typeahead" data-items="10" validation-type="required, regex" 
                            required-message="<%=Resources.Resource.WFAdminWeb_Page_KeyPage_KeyNameBlank %>" validation-regex="^[a-zA-Z0-9\-_]+$" 
                            regex-message="<%=Resources.Resource.WFAdminWeb_Page_KeyPage_KeyNameCharacters %>" />
                        </div>
                    </div>
                </fieldset>
                </form>
            </div>
        </div>
        <!-- /div .span8 -->
    </div>
    <!-- /div .row-fluid -->
    <div class="row-fluid">
        <div class="span8">
            <fieldset class="form-horizontal">
                <div class="control-group">
                                        <span id="js-notice-message"></span>
                                    </div>
                <div class="form-actions top-line">
                    <button class="btn btn-primary" id="btnAdd">
                        <span>Add</span></button>
                    <button class="btn"  id="btnCancel">
                        <span>Cancel</span></button>
                </div>
            </fieldset>
        </div>
    </div>

    <script src="http://ajax.googleapis.com/ajax/libs/jquery/1.11.1/jquery.min.js"></script>
        <script>
            if (!window.jQuery) {
                console.error("jQuery CDN is down.")
                document.write('<script src="<%=Url.Content("~/Content/assets/js/jquery.min.js") %>"><\/script>');
            }
        </script>
        <script src="http://maxcdn.bootstrapcdn.com/bootstrap/3.2.0/js/bootstrap.min.js"></script>
        <script>
            if (!$.fn.modal) {
                console.error("Bootstrap CDN is down.")
                document.write('<script src="<%=Url.Content("~/Content/assets/js/bootstrap.min.js") %>"><\/script>');
            }
        </script>
        <script src="<%=Url.Content("~/Content/assets/js/kendo.all.min.js") %>"></script>
		<script src="<%=Url.Content("~/Content/assets/js/wslib_master.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/wsplugin_master.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/ws_common.js") %>"></script>
		<script src="<%=Url.Content("~/Content/assets/js/json2.js") %>"></script>
		<script>
		    $(document).ready(function () {
		        ws_showProgressBar();
		        ws_initializeWebApp("/admin/GetAllWebApp", $('#select-webapp'), OnLoad);
		        $('#select-webapp').change(function () {
		            SetupLinks();
		        });

		        $('#btnAdd').click(function (event) {
		            event.preventDefault();
		            if (!validateClientSide("divTextBox")) {

		                return false;
		            }

	                var url = encodeURI("/KeyConfiguration/EditKey?k=" + $('#txtKeyName').val() + "&server=" + $('#select-webapp').val());
	                window.location.href = url;
		            return false;
		        });

		        function OnLoad() {
		            ws_ajaxCall("/KeyConfiguration/GetSuggestions", { server: $('#select-webapp').val() }, CallBackSuccess, CallBackFailure, null);
		            ws_hideProgressBar();
		            return false;
		        }

		        $("#btnCancel").click(function () {
		            window.location.href = '/KeyConfiguration/Index?server=' + $('#select-webapp').val();
		            return false;
		        });

		        function CallBackFailure(xhr, status, error, callbackdata) {
		            ws_hideProgressBar();
		            if (xhr.statusText != null && xhr.statusText != undefined) {
		                wsLib_createBootstrapAlert($('#js-notice-message'), xhr.statusText, "error", true);
		            }
		        }		        

		        function CallBackSuccess(data) {
		            ws_hideProgressBar();
		            if (data != null && data.length > 0) {
		                var suggestions = [];
		                var datum = '[';
		                $.each(data, function (index, object) {
		                    suggestions.push(object);
		                });

		                datum += suggestions.join(",") + ']';
		                var array = datum.split(',');
		                $('#txtKeyName').attr("data-source", JSON.stringify(suggestions));
		            }
		            $('.chzn-select').chosen();
		            return false;
		        }
		    });
        </script>
        <script src="<%=Url.Content("~/Content/assets/js/chosen.jquery.min.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/bootstrap.typeahead.js") %>"></script>
       
        
        <script>
            $('.chzn-select').chosen();
        </script>
</asp:Content>
