﻿<%@ Page Title="Edit Configuration" Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage" %>

<asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
    Edit Configuration
</asp:Content>
<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
<link href="<%=Url.Content("~/content/assets/css/chosen.css") %>" rel="stylesheet">
    <div class="row-fluid">
        <div class="span12">
            <ul id="breadcrumbs">
                <li><a href="/Home">Administration</a> &rsaquo;</li>
                <li><a href="/KeyConfiguration">Configuration Options</a> &rsaquo;</li>
                <li>Edit Configuration</li>
                <li class="related-links">
                    <ul>
                        <li class="related-label">Related:</li>
                        <li class="link"><a href="/KeyConfiguration">Configure Options</a></li>
                        <li class="link"><a href='http://cdn.winshuttle.com/products/help/winshuttle-foundation-help-center/index.htm#options.htm'>
                        Configuration Documentation</a></li>
                    </ul>
                </li>
            </ul>
            <ul id="secnav">
                <li class="active">
                    <h1>
                        Edit Configuration</h1>
                </li>
            </ul>
        </div>
    </div>
    <div class="row-fluid">
        <div class="span8">
            <div class="settings-info">
                <p class="clearfix">
                    <span class="label">Name</span>
                    <label id="keyname">
                    </label>
                </p>
                <p class="clearfix">
                    <span class="label">Description</span>
                    <label id="keydescription">
                    </label>
                </p>
                <p class="clearfix">
                    <span class="label">Type</span>
                    <label id="keytype">
                    </label>
                </p>
                <p class="clearfix">
                    <span class="label">Scope</span>
                    <label id="keyscope">
                    </label>
                </p>
            </div>
        </div>
        <!-- /div .span8 -->
    </div>
    <div class="row-fluid">
        <div class="span8">
            <h2>
                Value</h2>
            <table id="table-key" class="table table-striped table-bordered table-addedit-form">
                <thead>
                    <tr>
                        <th width="33.3333333333%">
                            <a href="#">Scope</a>
                        </th>
                        <th width="66.6666666667%">
                            <a href="#">Value</a>
                        </th>
                    </tr>
                </thead>
                <tbody id="js-administration-editconfiguration-value">
                    <!-- add new value -->
                    <tr class="js-rowadd-toggle-view-slave-1 row-add">
                        <td colspan="2">
                            <a class="js-rowadd-toggle-view-master-0" href="#">Add New Value</a>
                        </td>
                    </tr>
                    <tr class="js-rowadd-toggle-view-slave-0 row-add js-initial-hide">
                        <td id="td-dropDown">
                        </td>
                        <td id="td-dropdown-value">
                            <div class="add-actions">
                                <button class="js-administration-editconfiguration-value-addrow js-rowadd-toggle-view-master-1
                                                    js-addnewvalue-toggle-view-slave-1
                                                    btn btn-primary js-initial-hide">
                                    <span>Add</span>
                                </button>
                                <button class="js-rowadd-toggle-view-master-1 btn">
                                    <span>Cancel</span></button>
                            </div>
                        </td>
                    </tr>
                </tbody>
            </table>
        </div>
    </div>
    <div class="row-fluid">
        <div class="span8">
            <div class="form-actions">
                <div class="control-group">
                                        <span id="js-notice-message"></span>
                </div>
                <button type="submit" id="btnSave" class="btn btn-primary">
                    <span>Save</span></button>
                <button class="btn" id="btnCancel">
                    <span>Cancel</span></button>
            </div>
        </div>
    </div>
    <script src="http://ajax.googleapis.com/ajax/libs/jquery/1.11.1/jquery.min.js"></script>
   <script>
       if (!window.jQuery) {
           console.error("jQuery CDN is down.")
           document.write('<script src="<%=Url.Content("~/Content/assets/js/jquery.min.js") %>"><\/script>');
       }
        </script>
        <script src="http://maxcdn.bootstrapcdn.com/bootstrap/3.2.0/js/bootstrap.min.js"></script>
        <script>
            if (!$.fn.modal) {
                console.error("Bootstrap CDN is down.")
                document.write('<script src="<%=Url.Content("~/Content/assets/js/bootstrap.min.js") %>"><\/script>');
            }
    </script>
    <script src="<%=Url.Content("~/Content/assets/js/kendo.all.min.js") %>"></script>
    <script src="<%=Url.Content("~/Content/assets/js/wslib_master.js") %>"></script>
    <script src="<%=Url.Content("~/Content/assets/js/wsplugin_master.js") %>"></script>
    <script src="<%=Url.Content("~/Content/assets/js/ws_global_initialization_administration.js") %>"></script>
    <script src="<%=Url.Content("~/Content/assets/js/ws_common.js") %>"></script>
    <script src="<%=Url.Content("~/Content/assets/js/chosen.jquery.min.js") %>"></script>
    <!--<script src="assets/js/chosen.jquery.min.js"></script>-->
    <script>
        var dropdownhtml = undefined;
        var keydata = undefined;
        var THEKEYTYPE = undefined;
        var THEKEYSCOPE = undefined;
        var UNSAVEDDATA = false;
        $(document).ready(function () {
            ws_showProgressBar();
            ws_initializeWebApp("/admin/GetAllWebApp", $('#select-webapp'), OnLoad);
            $("#select-webapp").change(function () {
                ws_showProgressBar();
                if ((UNSAVEDDATA == true) || (isKeyBeingEdited() == true) || (isAddRowVisible() == true)) {
                    var message = '<%=Resources.Resource.WFAdminWeb_Page_KeyEditPage_PageDirty %>';
                    if (window.confirm(message) == false) {
                        ws_initializeWebApp("/admin/GetAllWebApp", $('#select-webapp'), function () {
                            ws_hideProgressBar();
                        });

                        return false;
                    }
                }

                SetupLinks();
            });

            function isKeyBeingEdited() {
                var theRows = $('#table-key').find('tr.js-administration-editconfiguration-value-item');
                var isRowinEditMode = false;
                $.each(theRows, function (k, v) {
                    var displayFormDiv = $(v).find('div.js-administration-editconfiguration-value-display:last');
                    if (displayFormDiv.is(':visible') == false) {
                        isRowinEditMode = true;
                    }
                });

                return isRowinEditMode;
            }

            function isAddRowVisible() {
                return $('#td-dropdown-value').find('div.js-addnewvalue-toggle-view-slave-1:last').is(':visible');
            }

            function OnLoad() {
                GetKey();
                return false;
            }


            $("#btnCancel").click(function () {
                ws_showProgressBar();
                if ((UNSAVEDDATA == true) || (isKeyBeingEdited() == true) || (isAddRowVisible() == true)) {
                    var message = '<%=Resources.Resource.WFAdminWeb_Page_KeyEditPage_PageDirty %>';
                    if (window.confirm(message) == false) {
                        ws_hideProgressBar();
                        return false;
                    }
                }
                window.location.href = '/KeyConfiguration/Index?server=' + $('#select-webapp').val();
                return false;
            });

            $("#btnSave").click(function () {
                wsLib_destroyBootstrapAlert($('#js-notice-message'));
                ws_showProgressBar();
                var theRows = $('#table-key').find('tr.js-administration-editconfiguration-value-item');

                if ((isKeyBeingEdited() == true) || (isAddRowVisible() == true)) {
                    var message = '<%=Resources.Resource.WFAdminWeb_Page_KeyEditPage_PageDirty %>';
                    if (window.confirm(message) == false) {
                        ws_hideProgressBar();
                        return false;
                    }
                }
                var tt = $('#table-key').find('tr.js-administration-editconfiguration-value-item');
                var siteguids = [];
                var webguids = [];
                var listguids = [];
                var types = [];
                var values = [];
                $.each(tt, function (k, v) {
                    var tr = $(v);
                    siteguids.push(tr.attr('siteguid'));
                    webguids.push(tr.attr('webguid'));
                    listguids.push(tr.attr('listguid'));
                    types.push(tr.attr('type'));
                    values.push(tr.find('div.js-administration-editconfiguration-value-display:last').text());
                });

                $.ajax({
                    url: '/KeyConfiguration/UpdateKey',
					type: 'POST',
                    data: { server: $('#select-webapp').val(),
                        name: $("#keyname").html(),
                        siteguids: siteguids,
                        webguids: webguids,
                        listguids: listguids,
                        values: values
                    },
                    cache: false,
                    traditional: true,
                    success: function (data) {
                        UNSAVEDDATA = false;
                        window.location.href = '/KeyConfiguration/Index?server=' + $('#select-webapp').val();
                        return false;
                    },
                    error: function (xhr, status, error) {
                        ws_hideProgressBar();
                        if (xhr.statusText != null && xhr.statusText != undefined) {
                            wsLib_createBootstrapAlert($('#js-notice-message'), xhr.statusText, "error", true);
                        }
                    }
                });
            });
        });
    </script>
    <script>
        function PopulateDropDown() {
            ws_ajaxCall('/keyconfiguration/GetKeyDropdownStr', { server: $('#select-webapp').val() }, function (data) {
                var xml = $(loadXMLString(data));
                var str = MakeStructure(xml);
                $('#td-dropDown').html('');
                $('#td-dropDown').html(str);

                var keyScope = $("#keyscope").html().toLowerCase();
                if (keyScope == 'global') {
                    $('#td-dropDown').find('a[type=Site]').addClass('js-menu-inactive').on('click.preventInactiveEvents');
                    $('#td-dropDown').find('a[type=List]').addClass('js-menu-inactive').on('click.preventInactiveEvents');
                }
                else if (keyScope == 'site') {
                    $('#td-dropDown').find('a[type=List]').addClass('js-menu-inactive').on('click.preventInactiveEvents'); ;
                }

                if (keydata != undefined && keydata != null) {
                    var xmlDocument = $(loadXMLString(keydata));
                    var keys = xmlDocument.find("Key").find("PossibleValues");
                    $('#td-dropdown-value').append(renderSlave(xmlDocument.find("Key").attr("Type"), keys));
                    var keys = xmlDocument.find("Key").find("KeyAssignment");
                    if (keys != undefined && keys != null && keys.length > 0) {
                        $.each(keys, function (k, v) {
                            v = $(v);
                            var assignedTo = v.attr('AssignedTo');
                            var siteguid = (v.attr('SiteGUID') == null || v.attr('SiteGUID') == undefined) ? '' : v.attr('SiteGUID').toString();
                            var webguid = (v.attr('WebGUID') == null || v.attr('WebGUID') == undefined) ? '' : v.attr('WebGUID').toString();
                            var listguid = (v.attr('ListGUID') == null || v.attr('ListGUID') == undefined) ? '' : v.attr('ListGUID').toString();
                            var type;
                            if (assignedTo.toLowerCase() == 'global') {
                                type = 'Global';
                            }
                            else if ($.trim(listguid).length == 0 || $.trim(listguid).toLowerCase() == 'all') {
                                type = "Site";
                            }
                            else {
                                type = "List";
                            }
                            $('#td-dropDown').find('ul.dropdown-menu').find('a[type="' + type + '"][listguid="' + listguid + '"][webguid="' + webguid + '"][siteguid="' + siteguid + '"]').addClass('js-menu-inactive').on('click.preventInactiveEvents'); ;
                        });
                    }
                }

                ready();
                var $editConfigurationAddNewValueSelect = $('#js-administration-editconfiguration-addnewvalue-select');
                var $editConfigurationAddNewValueSelectA = $('#js-administration-editconfiguration-addnewvalue-select .dropdown-menu a');

                $editConfigurationAddNewValueSelectA.on('click', function (event) {
                    event.preventDefault();

                    var $this = $(this);
                    if ($this.hasClass('js-menu-inactive')) {
                        return false;
                    }
                    var type = $this.attr('type');
                    var siteguid = $this.attr('siteguid');
                    var webguid = $this.attr('webguid');
                    var listguid = $this.attr('listguid');
                    function generateValueTypeLabel($whichLink) {
                        var currentText = $whichLink.text();

                        if (currentText === '') {
                            return currentText;
                        }
                        else {
                            return generateValueTypeLabel($whichLink.closest('ul').siblings('a').not('.dropdown-toggle')) + currentText;
                        }
                    }

                    var typeName = generateValueTypeLabel($this);
                    var addNewValueSelected = ($this.attr('activedata'));
                    $editConfigurationAddNewValueSelect.data('activedata', addNewValueSelected);
                    $this.closest('.dropdown')
                                             .children('.dropdown-toggle')
                                             .children('.js-administration-editconfiguration-addnewvalue-select-display')
                                             .text(typeName)
                    						 .attr('type', type)
                    						 .attr('siteguid', siteguid)
                    						 .attr('webguid', webguid)
                    						 .attr('listguid', listguid)
                                             .data('selected-value-type', {
                                                 type: typeName
                                             });
                });
               ws_hideProgressBar();
            }, CallBackFunctionFailure, null);
        }

        function GetKey() {
            $('#table-key > tbody tr.js-administration-editconfiguration-value-item').remove();
            var server = decodeURI(wsPlugin_getURLParameter('server'));
            var keyname = decodeURI(wsPlugin_getURLParameter('k'));

            ws_ajaxCall('/keyconfiguration/GetKey', { server: $('#select-webapp').val(),
                keyname: keyname
            }
                    , CallBackSuccess, CallBackFunctionFailure, null);
        }

        function CallBackSuccess(data) {
            if (data.Key != undefined && data.Key != null) {
                keys = data.Key;
                keydata = data.Key;
                var xmlDocument = $(loadXMLString(keys)).find('Key');
                $("#keyname").text(xmlDocument.attr("Name"));
                $("#keydescription").text(xmlDocument.attr("Description"));
                $("#keytype").text(xmlDocument.attr("Type"));
                $("#keyscope").text(xmlDocument.attr("Scope"));
                THEKEYSCOPE = xmlDocument.attr("Scope").toLowerCase();
                THEKEYTYPE = xmlDocument.attr("Type").toLowerCase();
                var keys = xmlDocument.find("KeyAssignment");
                if (keys != undefined && keys != null && keys.length > 0) {
                    $.each(keys, function (k, v) {
                        var row = CreateRow($(v));
                        $("#table-key > tbody tr.row-add").first().before(row);
                    });

                    $('.js-chosen-target').toggleClass('js-chosen-target js-chosen-target-active')
                                    .chosen({
                                        width: "50%"
                                    });
                }
            }

            PopulateDropDown();
        }

        function CreateRow(v) {
            var siteguid = (v.attr('SiteGUID') == null || v.attr('SiteGUID') == undefined) ? '' : v.attr('SiteGUID').toString();
            var webguid = (v.attr('WebGUID') == null || v.attr('WebGUID') == undefined) ? '' : v.attr('WebGUID').toString();
            var listguid = (v.attr('ListGUID') == null || v.attr('ListGUID') == undefined) ? '' : v.attr('ListGUID').toString();
            var theValue = v.attr("Value");
            var type;
            if ($.trim(siteguid).length == 0 && $.trim(webguid).length == 0) {
                type = 'Global';
            }
            else if ($.trim(listguid).length == 0 || listguid.toLowerCase() == "all") {
                type = "Site";
            }
            else {
                type = "List";
            }

            var markup = '<tr class="js-administration-editconfiguration-value-item" type="' + type + '" siteguid="' + siteguid + '" webguid="' + webguid + '" listguid="' + listguid + '"> ' +
                             '      <td>' +
                             '          <div class="js-administration-editconfiguration-value-display contain-long-word">' + v.attr("AssignedTo") + '</div>' +
                             '          <div class="js-administration-editconfiguration-value-form contain-long-word js-initial-hide" style="display: none;"> ' + v.attr("AssignedTo") + '</div>' +
                             '      </td>' +
                             '      <td>' +
                             '          <div class="pull-right">' +
                             '              <div><a class="js-administration-editconfiguration-value-edittoggle" href="#"><i class="icon-edit">&nbsp;&nbsp;</i></a><a class="js-administration-editconfiguration-value-deleterow" href="#"><i class="icon-trash">&nbsp;&nbsp;</i></a></div>' +
                             '              <div class="update-actions js-initial-hide" style="display: none;"><button id="btnSave" class="js-administration-editconfiguration-value-editsave js-administration-editconfiguration-value-edittoggle btn btn-primary"><span>Save</span></button><button id="btnCancel" class="js-administration-editconfiguration-value-edittoggle btn"><span>Cancel</span></button></div>' +
                             '          </div>' +
                             '          <div class="js-administration-editconfiguration-value-display">' + EscapeSpecialCharacters(theValue) + '</div>' +
                             '          <div class="js-administration-editconfiguration-value-form js-initial-hide" style="display: none;">';

            var type = $(v.context.parentNode).attr("Type");
            if (type == "radio") {
                markup += ' <ul class="checkbox-group inline-list">';
                var possibleValuesNode = $(v.context.parentNode).find("PossibleValues").find("radio");
                if (possibleValuesNode != null && possibleValuesNode != undefined) {
				var unique = Math.floor((Math.random() * 1000) + 1);
                    for (var i = 0; i < possibleValuesNode.length; i++) {
                        var attr = $(possibleValuesNode[i]).attr("value");
                        if (attr != null && attr != undefined) {
                            var checked = '';
                            if (attr.toLowerCase() == theValue.toLowerCase()) {
                                checked = ' checked="checked"';
                            }
							
                            markup += '<li><label><input type="radio" name="boolean_item_TEST' + unique + '"' + checked + '><span>' + (attr) + '</span></label></li>';
                        }
                    }
                }

                markup += '</ul>';
            }
            else if (type == "select" || type == "singleselectlist") {
                markup += '<select class="input-mid">';

                var possibleValuesNode = $(v.context.parentNode).find("PossibleValues").find("radio");
                if (possibleValuesNode != null && possibleValuesNode != undefined) {
                    for (var i = 0; i < possibleValuesNode.length; i++) {
                        var attr = $(possibleValuesNode[i]).attr("value");
                        if (attr != null && attr != undefined) {
                            var selected = '';
                            if (attr.toLowerCase() == theValue.toLowerCase()) {
                                selected = ' selected="selected"';
                            }

                            markup += '<option' + selected + '>' + attr + '</option>';
                        }
                    }
                }

                markup += '</select>';
            }
            else if (type == "multiselect" || type == "multiselectlist" || type == "check") {
                var theValues = theValue.toLowerCase().split(',');
                markup += '<select class="js-chosen-target input-mid" multiple tabindex="3" data-placeholder="Select">';
                var possibleValuesNode = $(v.context.parentNode).find("PossibleValues").find("check");
                if (possibleValuesNode != null && possibleValuesNode != undefined) {
                    for (var i = 0; i < possibleValuesNode.length; i++) {
                        selected = '';
                        var attr = $(possibleValuesNode[i]).attr("value");
                        if (attr != null && attr != undefined) {
                            var selected = '';
                            if ($.inArray(attr.toLowerCase(), theValues, 0) != -1) {
                                selected = ' selected="selected"';
                            }

                            markup += '<option' + selected + '>' + attr + '</option>';
                        }
                    }
                }

                markup += '</select>';
            }
            else if (type == "text") {
                markup += '<textarea  class="js-form-item input-mid">' + EscapeSpecialCharacters(theValue) + '</textarea>';
            }
            else {
                markup += '<input type="text" class="input-mid" value="' + EscapeSpecialCharacters(theValue) + '" />';
            }

            markup += '</div></td></tr>';

            return markup;
        }


        function CallBackFunctionFailure(xhr, status, error, callbackdata) {
            ws_hideProgressBar();
            if (xhr.statusText != null && xhr.statusText != undefined) {
                wsLib_createBootstrapAlert($('#js-notice-message'), xhr.statusText, "error", true);
            }
        }

        var valueType = 0;
        function MakeStructure(xml) {
            var html = '<div id="js-administration-editconfiguration-addnewvalue-select" class="js-dropdowntree-target dropdown-tree-menu input-max">' +
                               '<div class="dropdown">';
            $.each(xml.find('options').children('option'), function (k, v) {
                var node = $(v);
                if (node.attr("Name").toString().toLowerCase() == 'all') {
                    html +=
                                                            '<a class="dropdown-toggle" data-toggle="dropdown" href="#">' +
                                                            '<span class="dropdown-toggle-symbol"></span>' +
                                                            '<span class="js-administration-editconfiguration-addnewvalue-select-display" type="all" listguid="" webguid="" siteguid="">Select</span>' +
                                                            '</a>' +
                                                            '<ul class="dropdown-menu">';
                    /* html += '<li class="js-administration-dropdowntree-group">' +
                    '<a class="js-addnewvalue-toggle-view-master-0" data-corresponding-value-type="-1"  activedata="-1" href="#" type="All" siteguid="" webguid="" listguid=""><span>Select</span></a>' +
                    '</li>';*/
                }
                else if (node.attr("Name").toString().toLowerCase() == 'global') {
                    html += '<li class="js-administration-dropdowntree-group">' +
                                    '<a class="js-addnewvalue-toggle-view-master-1" data-corresponding-value-type="10001" activedata="' + valueType++ + '" href="#" type="Global" siteguid="" webguid="" listguid=""><span>Global</span></a>' +
                                    '</li>   ';
                }
                else if (node.attr("Type").toString().toLowerCase() == 'site') {
                    if (THEKEYSCOPE != undefined && THEKEYSCOPE == 'global') {
                        return;
                    }

                    var name = node.attr("Name");
                    var siteguid = node.attr("SiteGUID");
                    var webguid = node.attr("WebGUID");
                    var listguid = node.attr("ListGUID");
                    var type = node.attr("Type");
                    var count = (node.attr("Count") == "") ? "0" : node.attr("Count");
                    html += '<li class="js-administration-dropdowntree-group">' +
                                    '<a type="Site" siteguid="' + siteguid + '" webguid="' + webguid + '" listguid="' + listguid + '" class="js-addnewvalue-toggle-view-master-1" data-corresponding-value-type="10001" activedata="' + valueType++ + '" href="#"><span><b>' + name + '/</b></span></a>';
                    var childnodes = node.children('option');
                    if (childnodes != null && childnodes != undefined && childnodes.length > 0) {
                        html += '<ul>';
                        html += TraverseChildren(childnodes);
                        html += '</ul>';
                    }

                    html += '</li>';
                }
            });

            html += '</ul></div>' +
                        '</div>';
            if (dropdownhtml == undefined) {
                dropdownhtml = html;
            }

            return html;
        }

        function TraverseChildren(children) {
            var html = '';
            if (children.length > 0) {
                for (var i = 0; i < children.length; i++) {
                    var node = $(children[i]);
                    var name = node.attr("Name");
                    var siteguid = node.attr("SiteGUID");
                    var webguid = node.attr("WebGUID");
                    var listguid = node.attr("ListGUID");
                    var type = node.attr("Type");
                    if (type.toLowerCase() == "list") {
                        if (THEKEYSCOPE != undefined && THEKEYSCOPE != 'list') {
                            continue;
                        }
                    }
                    if (type.toLowerCase() == "site") {
                        html += '<li class="js-administration-dropdowntree-group">' +
                                    '<a type="Site"  siteguid="' + siteguid + '" webguid="' + webguid + '" listguid="' + listguid + '" class="js-addnewvalue-toggle-view-master-1" data-corresponding-value-type="10001" activedata="' + valueType++ + '"  href="#"><span><b>' + name + '/</b></span></a>';
                    }
                    else {
                        html += '<li class="js-administration-dropdowntree-group">';
                        html += '<a type="List"  siteguid="' + siteguid + '" webguid="' + webguid + '" listguid="' + listguid + '" class="js-addnewvalue-toggle-view-master-1" data-corresponding-value-type="10001" activedata="' + valueType++ + '" href="#"><span>' + name + '</span></a>';
                    }

                    if (type.toLowerCase() == "site") {
                        var childnodes = node.children('option');
                        if (childnodes != null && childnodes != undefined && childnodes.length > 0) {
                            html += '<ul>';
                            html += TraverseChildren(childnodes);
                            html += '</ul>';
                        }
                    }

                    html += '</li>';
                }
            }

            return html;
        }

        function renderSlave(type, possibleValues) {
            var theReturn;
            switch (type) {
                case "text":
                    theReturn = '<div class="js-addnewvalue-toggle-view-slave-1 js-initial-hide" data-corresponding-value-type="10001"><textarea class="js-form-item input-mid"' +
                        ' "placeholder="String"></textarea></div>';
                    break;
                case "string":
                case "integer":
                case "timespan":
                    theReturn = '<div class="js-addnewvalue-toggle-view-slave-1 js-initial-hide" data-corresponding-value-type="10001"><input type="text" class="form-control input-mid"' +
                        ' "placeholder="String" /></div>';
                    break;
                case "radio":
                    var options = '';
                    possibleValues = possibleValues.find('radio');
                    $.each(possibleValues, function (k, v) {
                        var value = $(v).attr('value');
                        var selected = '';
                        if (value.toLowerCase() == 'false') {
                            selected = 'checked="checked"';
                        }

                        options += '<li><label><input type="radio" ' + selected + ' name="TEMP_boolean_datatype"><span>' + (value) + '</span></label>';
                        '</li>';
                    });
                    theReturn = '<div class="js-addnewvalue-toggle-view-slave-1 js-initial-hide" data-corresponding-value-type="10001"><ul class="checkbox-group inline-list">' +
                                options +
                                '</ul></div>';
                    break;
                case "select":
                case "singleselectlist":
                    var options = '';
                    possibleValues = possibleValues.find('radio');
                    $.each(possibleValues, function (k, v) {
                        var value = $(v).attr('value');
                        options += '<option>' + (value) + '</option>';
                        '</li>';
                    });
                    theReturn = '<div class="js-addnewvalue-toggle-view-slave-1 js-initial-hide" data-corresponding-value-type="10001"><select class="input-mid">' +
                               options +
                               '</select></div>';
                    break;
                case "multiselectlist":
                case "multiselect":
                case "check":
                    var options = '';
                    possibleValues = possibleValues.find('check');
                    $.each(possibleValues, function (k, v) {
                        var value = $(v).attr('value');
                        options += '<option>' + (value) + '</option>';
                    });
                    theReturn = ' <div class="js-addnewvalue-toggle-view-slave-1 js-initial-hide" data-corresponding-value-type="10001">' +
                        '<select class="js-chosen-target input-mid" multiple tabindex="3" data-placeholder="Select">' +
                        options +
                        '</select></div>';
                    break;
            }

            return theReturn;
        }
    </script>
    <script>
        function EscapeSpecialCharacters(input) {
            if (input != null && input != undefined) {
				try{
					return input.replace(/&/g, '&amp;').replace(/"/g, '&quot;').replace(/</g, "&lt;").replace(/>/g, "&gt;");
				}catch(e)
				{
					return input;
				}
            }
        }
        function ready() {
            (function () {
                $('.js-chosen-target').toggleClass('js-chosen-target js-chosen-target-active')
                                    .chosen({
                                        width: "50%"
                                    });

                var numberOfValueTypes = 1; // ### ATTENTION - This number should be the amount of types of Values that exist in this form.



                var $editConfigurationValue = $('#js-administration-editconfiguration-value');
                var $editConfigurationAddNewValueSelect = $('#js-administration-editconfiguration-addnewvalue-select');

                $editConfigurationAddNewValueSelect.find('a.js-menu-inactive').on('click.preventInactiveEvents', function (event) {
                    event.stopImmediatePropagation();
                    event.preventDefault();
                });

                wsLib_toggleViews("createwith", 2, "radio", "no", 200);
                wsLib_toggleViews("rowadd", 2, "default");
                wsLib_toggleViews("addnewvalue", (3), "default", "no");

                $editConfigurationAddNewValueSelect.on('click.scrollToItem', '.dropdown-toggle', function (event) {
                    event.preventDefault();
                    $('#td-dropDown .dropdown-menu a').removeClass('itemselected');
                    var $currentDropdownTreeSelectTarget = $('.js-dropdowntree-target');
                    var $currentDropdownMenu = $currentDropdownTreeSelectTarget.find('.dropdown-menu');
                    $currentDropdownMenu.css('width', $currentDropdownTreeSelectTarget.width() + 'px');
                    var activedata = $editConfigurationAddNewValueSelect.data('activedata');
                    if (activedata !== undefined) {
                        setTimeout(function () {
                            var container = $editConfigurationAddNewValueSelect.find('.dropdown-menu');
                            if (activedata != -1) {
                                var scrollTo = $(container).find('a').filter('[activedata="' + activedata + '"]').first();
                                if (scrollTo != null && scrollTo != undefined) {
                                    scrollTo.addClass('itemselected');
                                    scrollTo = scrollTo.closest('li.js-administration-dropdowntree-group');
                                    $(container).animate({
                                        scrollTop: scrollTo.offset().top - container.offset().top + container.scrollTop()
                                    });
                                }
                            }
                            else {
                                $(container).scrollTop(0);
                            }
                        }, 1);
                    }

                }).on('click.toggleAddNewValue', '.dropdown-menu a', function (event) {
                    event.preventDefault();

                    var $this = $(this);
                    function generateValueTypeLabel($whichLink) {
                        var currentText = $whichLink.text();

                        if (currentText === '') {
                            return '' + currentText + '';
                        }
                        else {
                            return generateValueTypeLabel($whichLink.closest('ul').siblings('a').not('.dropdown-toggle')) + '' + currentText + '';
                        }
                    }

                    var typeName = generateValueTypeLabel($this);



                    $this.closest('.dropdown')
                         .children('.dropdown-toggle')
                         .children('.js-administration-editconfiguration-addnewvalue-select-display')
                         .text(typeName)
                         .data('selected-value-type', {
                             type: typeName
                         });

                    var addNewValueSelected = parseInt($this.data('corresponding-value-type'));
                    var valueSelected = parseInt($this.attr('activedata'));
                    $editConfigurationAddNewValueSelect.data('activedata', valueSelected);

                    $this.closest('tr.row-add')
                         .children('td')
                         .eq(1)
                         .children('div')
                         .removeClass('js-form-active')
                         .filter('[data-corresponding-value-type="' + addNewValueSelected + '"]')
                         .addClass('js-form-active');
                });

                $editConfigurationValue.off('click.editToggle')
                                              .off('click.editSave')
                                              .off('click.deleteRow')
                                              .off('click.addRow')
                                              .on('click.editToggle', '.js-administration-editconfiguration-value-edittoggle', function (event) {
                                                  event.preventDefault();

                                                  var $currentParameterItem = $(this).closest('.js-administration-editconfiguration-value-item');

                                                  $currentParameterItem.children('td').find('.js-administration-editconfiguration-value-edittoggle').closest('div').toggle();

                                                  $currentParameterItem.find('.js-administration-editconfiguration-value-display').toggle();
                                                  $currentParameterItem.find('.js-administration-editconfiguration-value-form').toggle();
                                              }).on('click.editSave', '.js-administration-editconfiguration-value-editsave', function (event) {
                                                  event.preventDefault();

                                                  $(this).closest('tr').find('.js-administration-editconfiguration-value-form').find('input, select, textarea').each(function () {
                                                      var $currentInput = $(this);
                                                      var $currentDisplay = $currentInput.closest('.js-administration-editconfiguration-value-form')
                                                           .siblings('.js-administration-editconfiguration-value-display');

                                                      if ($currentInput.attr('type') === 'checkbox') {
                                                          $currentDisplay.text(($currentInput.prop('checked') + ""));
                                                      }
                                                      else if ($currentInput.attr('type') === 'radio') {
                                                          $currentDisplay.text((!$currentInput.prop('checked') + ""));
                                                      }
                                                      else if ($currentInput.is('select.js-chosen-target-active')) {
                                                          var value = (($currentInput.val() == null || $currentInput.val() == undefined) ? '' : $currentInput.val());
                                                          var currentChosenValuesString = ($.trim(value) != '' ? value.join() : value);

                                                          setTimeout(function () {
                                                              $currentDisplay.html(currentChosenValuesString);
                                                          }, 1);
                                                      }
                                                      else if ($currentInput.is('select')) {
                                                          $currentDisplay.text(($currentInput.val() == null || $currentInput.val() == undefined) ? '' : $currentInput.val());
                                                      }
                                                      else {
                                                          $currentDisplay.text(($currentInput.val() == null || $currentInput.val() == undefined) ? '' : $currentInput.val());
                                                      }

                                                      UNSAVEDDATA = true;
                                                  });
                                              }).on('click.deleteRow', '.js-administration-editconfiguration-value-deleterow', function (event) {
                                                  event.preventDefault();
                                                  UNSAVEDDATA = true;
                                                  var curRow = $(this).closest('tr');
                                                  $(this).off('click.preventInactiveEvents');
                                                  $('#td-dropDown').find('ul.dropdown-menu').find('a[type="' + curRow.attr('type') + '"][listguid="' + curRow.attr('listguid') + '"][webguid="' + curRow.attr('webguid') + '"][siteguid="' + curRow.attr('siteguid') + '"]').removeClass('js-menu-inactive').off('click.preventInactiveEvents'); ;
                                                  curRow.remove();
                                              }).on('click.addRow', '.js-administration-editconfiguration-value-addrow', function (event) {
                                                  event.preventDefault();
                                                  UNSAVEDDATA = true;
                                                  var selectedValueType = $editConfigurationAddNewValueSelect.children('.dropdown')
                                                                                    .children('.dropdown-toggle')
                                                                                    .children('.js-administration-editconfiguration-addnewvalue-select-display');
                                                  var selectedValueTypeLabel = $(selectedValueType).data('selected-value-type');
                                                  $(selectedValueType).data('selected-value-type', '');
                                                  if (selectedValueTypeLabel != '') {
                                                      var currentRowHTML = '';
                                                      var currentRowData = [];

                                                      $(this).closest('tr.row-add')
                                                   .children('td')
                                                   .children('div.js-form-active')
                                                   .find('input, select, textarea').each(function (index) {
                                                       var $currentInput = $(this);

                                                       if ($currentInput.attr('type') === 'checkbox') {
                                                           currentRowData.push({
                                                               index: index,
                                                               data: $currentInput.prop('checked'),
                                                               dataDisplay: ($currentInput.prop('checked') + ""),
                                                               type: "checkbox",
                                                               HTML: $currentInput
                                                           });

                                                           $currentInput.prop('checked', false);
                                                       }
                                                       else if ($currentInput.attr('type') === 'radio') {
                                                           currentRowData.push({
                                                               index: index,
                                                               data: $currentInput.prop('checked'),
                                                               dataDisplay: ($currentInput.prop('checked') + ""),
                                                               type: "radio",
                                                               HTML: $currentInput
                                                           });

                                                           $currentInput.prop('checked', true);
                                                       }
                                                       else if ($currentInput.is('select.js-chosen-target-active')) {
                                                           $currentInput.find(':selected').attr('selected', 'selected');

                                                           currentRowData.push({
                                                               index: index,
                                                               data: $currentInput.val(),
                                                               dataDisplay: $currentInput.val(),
                                                               type: "select.js-chosen-target-active",
                                                               HTML: $currentInput.clone()
                                                           });

                                                           $currentInput.find('option')
                                                                 .prop('selected', false)
                                                                 .removeAttr('selected');

                                                           $currentInput.trigger('chosen:updated');
                                                       }
                                                       else if ($currentInput.is('select')) {
                                                           $currentInput.find(':selected').attr('selected', 'selected');

                                                           currentRowData.push({
                                                               index: index,
                                                               data: $currentInput.val(),
                                                               dataDisplay: $currentInput.val(),
                                                               type: "select",
                                                               HTML: $currentInput.clone()
                                                           });

                                                           $currentInput.find(':selected').removeAttr('selected');
                                                       }
                                                       else {
                                                           currentRowData.push({
                                                               index: index,
                                                               data: $currentInput.val(),
                                                               dataDisplay: $currentInput.val(),
                                                               type: "text",
                                                               HTML: $currentInput
                                                           });

                                                           $currentInput.val('');
                                                       }
                                                   });

                                                      var currentPlugData = {
                                                          scope: selectedValueTypeLabel.type,
                                                          value: ((currentRowData[0].data == null || currentRowData[0].data == undefined) ? '' : EscapeSpecialCharacters(currentRowData[0].data)),
                                                          valueDisplay: ((currentRowData[0].dataDisplay == null || currentRowData[0].dataDisplay == undefined) ? '' : EscapeSpecialCharacters(currentRowData[0].dataDisplay)),
                                                          type: currentRowData[0].type,
                                                          HTML: currentRowData[0].HTML
                                                      };


                                                      var span = $(this).closest('tr').find('#js-administration-editconfiguration-addnewvalue-select').find('div.dropdown > a.dropdown-toggle > span.js-administration-editconfiguration-addnewvalue-select-display');

                                                      $('#td-dropDown').find('ul.dropdown-menu').find('a[type="' + span.attr('type') + '"][listguid="' + span.attr('listguid') + '"][webguid="' + span.attr('webguid') + '"][siteguid="' + span.attr('siteguid') + '"]').addClass('js-menu-inactive').on('click.preventInactiveEvents');
                                                      var data = ' type="' + span.attr('type') + '" listguid="' + span.attr('listguid') + '" webguid="' + span.attr('webguid') + '" siteguid="' + span.attr('siteguid') + '"'
                                                      span.attr('type', '');
                                                      span.attr('listguid', '');
                                                      span.attr('webguid', '');
                                                      span.attr('siteguid', '');
                                                      span.html('Select');
                                                      currentRowHTML += '<tr class="js-administration-editconfiguration-value-item" ' + data + '>';
                                                      currentRowHTML += '<td>';
                                                      currentRowHTML += '<div class="js-administration-editconfiguration-value-display contain-long-word">' + currentPlugData.scope + '</div>';
                                                      currentRowHTML += '<div class="js-administration-editconfiguration-value-form contain-long-word js-initial-hide" style="display: none;">';

                                                      currentRowHTML += currentPlugData.scope;

                                                      currentRowHTML += '</div>';
                                                      currentRowHTML += '</td>';
                                                      currentRowHTML += '<td>';
                                                      currentRowHTML += '<div class="pull-right">';
                                                      currentRowHTML += '<div>';
                                                      currentRowHTML += '<a class="js-administration-editconfiguration-value-edittoggle" href="#"><i class="icon-edit">&nbsp;&nbsp;</i></a>';
                                                      currentRowHTML += '<a class="js-administration-editconfiguration-value-deleterow" href="#"><i class="icon-trash">&nbsp;&nbsp;</i></a>';
                                                      currentRowHTML += '</div>';
                                                      currentRowHTML += '<div class="update-actions js-initial-hide" style="display: none;">';
                                                      currentRowHTML += '<button class="js-administration-editconfiguration-value-editsave js-administration-editconfiguration-value-edittoggle btn btn-primary"><span>Save</span></button>';
                                                      currentRowHTML += '<button class="js-administration-editconfiguration-value-edittoggle btn"><span>Cancel</span></button>';
                                                      currentRowHTML += '</div>';
                                                      currentRowHTML += '</div>';
                                                      currentRowHTML += '<div class="js-administration-editconfiguration-value-display">' + currentPlugData.valueDisplay + '</div>';
                                                      currentRowHTML += '<div class="js-administration-editconfiguration-value-form js-initial-hide" style="display: none;">';

                                                      if (currentPlugData.type === 'checkbox') {
                                                          currentRowHTML += '<ul class="checkbox-group">';
                                                          currentRowHTML += '<li>';
                                                          currentRowHTML += '<label>';
                                                          currentRowHTML += '<input type="checkbox"' + (currentPlugData.value ? 'checked="checked"' : '') + '>';
                                                          currentRowHTML += '</label>';
                                                          currentRowHTML += '</li>';
                                                          currentRowHTML += '</ul>';
                                                      }
                                                      else if (currentPlugData.type === 'radio') {
                                                          var valueItemLength = $editConfigurationValue.find('.js-administration-editconfiguration-value-item').length;

                                                          currentRowHTML += '<ul class="checkbox-group inline-list">';
                                                          currentRowHTML += '<li>';
                                                          currentRowHTML += '<label>';
                                                          currentRowHTML += '<input type="radio" name="boolean_item_' + valueItemLength + '"' + (currentPlugData.value ? ' checked="checked"' : ' ') + '>';
                                                          currentRowHTML += '<span>True</span>';
                                                          currentRowHTML += '</label>';
                                                          currentRowHTML += '</li>';
                                                          currentRowHTML += '<li>';
                                                          currentRowHTML += '<label>';
                                                          currentRowHTML += '<input type="radio" name="boolean_item_' + valueItemLength + '"' + (currentPlugData.value ? ' ' : ' checked="checked"') + '>';
                                                          currentRowHTML += '<span>False</span>';
                                                          currentRowHTML += '</label>';
                                                          currentRowHTML += '</li>';
                                                          currentRowHTML += '</ul>';
                                                      }
                                                      else if (currentPlugData.type === 'select.js-chosen-target-active') {
                                                          currentRowHTML += '<select class="js-chosen-target input-mid" multiple tabindex="3" data-placeholder="Select">';
                                                          currentRowHTML += currentPlugData.HTML.html();
                                                          currentRowHTML += '</select>';
                                                      }
                                                      else if (currentPlugData.type === 'select') {
                                                          currentRowHTML += '<select class="input-mid">';
                                                          currentRowHTML += currentPlugData.HTML.html();
                                                          currentRowHTML += '</select>';
                                                      }
                                                      else if (currentPlugData.type === 'text') {
                                                          currentRowHTML += '<textarea class="js-form-item input-mid">' + (currentPlugData.value) + '</textarea>';
                                                      }
                                                      else {
                                                          currentRowHTML += '<input type="text" class="input-mid" value="' + currentPlugData.value + '">';
                                                      }

                                                      currentRowHTML += '</div>';
                                                      currentRowHTML += '</td>';
                                                      currentRowHTML += '</tr>';

                                                      $editConfigurationValue.find('.row-add').first().before(currentRowHTML);



                                                      $('.js-chosen-target').toggleClass('js-chosen-target js-chosen-target-active')
                                                    .chosen({
                                                        width: "50%"
                                                    });
                                                  }

                                                  $('#td-dropdown-value').find('div.js-addnewvalue-toggle-view-slave-1:last').toggle();
                                                  $('.js-dropdowntree-target').first().data('activedata', -1);
                                              });
            })();
        }
        // Hoa's code
            
    </script>
</asp:Content>

