﻿<%@ Page Title="Licenses" Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage" %>

<asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
	Licenses
</asp:Content>

<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
 <div class="container-alert">
                    <div id="js-alert-licensekey-copied" class="alert alert-success alert-dismissible js-initial-hide" role="alert">
                        License key has been copied to clipboard.
                    </div>
                </div>
                <div class="row-fluid">
                    <div class="span12">
                        <ul id="breadcrumbs">
                            <li><a href="/Home">Administration</a> &rsaquo;</li>
                            <li>Licenses</li>
                        </ul>
                        <ul id="secnav">
                            <li class="active">
                                <h1>Licenses</h1>
                            </li>
                        </ul>
                    </div>
                </div>
                <div class="row-fluid">
                    <div class="span12">
                        <table class="js-table table table-striped table-bordered" id="table-license">
                            <thead>
                                <tr>
                                    <th>
                                        
                                            Host Name
                                        
                                    </th>
                                    <th>
                                        
                                            Company
                                       
                                    </th>
                                    <th>
                                        
                                            Process
                                        
                                    </th>
                                    <th>
                                        
                                            Expiry Date
                                        
                                    </th>
                                    <th>
                                        
                                            Environment
                                        
                                    </th>
                                    <th>
                                        
                                            Key
                                        
                                    </th>
                                    <th class="no-sort">
                                        &nbsp;
                                    </th>
                                </tr>
                            </thead>
                            <tbody id="table-body-license"></tbody>
                        </table>
                        <div>
                            <form>
                                <fieldset>
                                   <div class="control-group">
                                        <span id="js-notice-message"></span>
                                    </div>
                                    <div class="form-textandbutton" id="div-control">
                                        <input type="text" id="input-licensekey" class="form-control input-mid" placeholder="New license number" validation-type="required" required-message="License key should not be empty."/>
                                        <button id="btn-add" class="btn btn-primary"><span>Add</span></button>
                                    </div>
                                </fieldset>
                            </form>
                        </div>
                    </div>
                    <!-- /div .span8 -->
                </div>
                 
                 <div class="modal fade js-initial-hide" id="js-modal-copymenu">
                    <div class="modal-dialog">
                        <div class="modal-content">
                            <div class="modal-header">
                                <button type="button" class="close" data-dismiss="modal"><span aria-hidden="true">&times;</span></button>
                                <h4 class="modal-title">Copy License Key</h4>
                                <div class="js-zeroclipboard-unavailable-notice">
                                    Select and copy the license key to your clipboard.
                                </div>
                            </div>
                            <div class="modal-body">
                                <textarea class="js-link-copy-target input-max"></textarea>
                            </div>
                            <div class="modal-footer js-initial-hide">
                                <button type="button" class="btn btn-primary js-link-copy" data-dismiss="modal"><span>Copy</span></button>
                                <button type="button" class="btn btn-default" data-dismiss="modal"><span>Cancel</span></button>
                            </div>
                        </div>
                    </div>
                </div>
                <script src="http://ajax.googleapis.com/ajax/libs/jquery/1.11.1/jquery.min.js"></script>
        <script>
            if (!window.jQuery) {
                console.error("jQuery CDN is down.")
                document.write('<script src="<%=Url.Content("~/Content/assets/js/jquery.min.js") %>"><\/script>');
            }
        </script>
        <script src="http://maxcdn.bootstrapcdn.com/bootstrap/3.2.0/js/bootstrap.min.js"></script>
        <script>
            if (!$.fn.modal) {
                console.error("Bootstrap CDN is down.")
                document.write('<script src="<%=Url.Content("~/Content/assets/js/bootstrap.min.js") %>"><\/script>');
            }
        </script>
        <script src="<%=Url.Content("~/Content/assets/js/kendo.all.min.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/chosen.jquery.min.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/ZeroClipboard.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/wslib_master.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/wsplugin_master.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/ws_common.js") %>"></script>
        <script>

            $("#btn-add").click(function () {
                if (!validateClientSide("div-control")) {

                    return false;
                }

                ws_showProgressBar();
                var licenseKey = $("#input-licensekey").val();
                ws_ajaxCall('/license/Add', { key: licenseKey }, add, onError, null);
                return false;
            });

            function add(data, callbackdata) {
                $("#table-license > tbody tr").remove();
                $.each(data, function (key, value) {
                    var row = createRow(value);
                    $("#table-license > tbody:last").append(row);
                    attachEvents($("#table-license > tbody:last > tr:last"));
                });

                $('#input-licensekey').val('');
                wsLib_createBootstrapAlert($('#js-notice-message'), '<%=Resources.Resource.WFAdminWeb_Page_LicensePage_LicenseAdded %>', "success", true);
                ws_hideProgressBar();
            }

            $(document).ready(function () {

                ws_showProgressBar();
                ws_initializeWebApp('/admin/getallwebapp', $('#select-webapp'), function () {
                    ws_ajaxCall('/license/getall', null, onLoad, onError, null);
                });

                $("#select-webapp").change(function () {
                    SetupLinks();
                });
            });

            function onLoad(data, callbackdata) {
                $.each(data, function (key, value) {
                    var row = createRow(value);
                    $("#table-license > tbody:last").append(row);
                    attachEvents($("#table-license > tbody:last > tr:last"));
                });

                ws_hideProgressBar();
            }

            function createRow(rowData) {
                var row = '<tr><td>' + rowData.HostName + '</td><td>' + rowData.Company + '</td><td>' + rowData.Processes + '</td><td>' + rowData.Expiration + '</td><td>' + rowData.Environment + '</td><td class="license-key"><a href="#" class="js-modal-licensekey-target" data-toggle="modal" data-target="#js-modal-copymenu" data-ws-licensekey="' + rowData.Key + '"><span>#####...</span></a></td><td><a href="#"><i class="icon-trash"></i></a></td></tr>';

                return row;
            }

            function attachEvents(row) {
                $(row).find(".icon-trash").click(function () {
                    if (!confirm('Are you sure you want to remove the selected license.')) { 
                        return false;
                    }

                    ws_showProgressBar();
                    var hostName = $(row).find("td:first").html();
                    ws_ajaxCall('/license/delete', { hostName: hostName }, trash, onError, row);
                });

                $(row).find('a.js-tooltip-target').tooltip({
                    html: true,
                    trigger: 'click',
                    animation: true
                });
            }

            function trash(data, callbackdata) {
                $(callbackdata).remove();
                wsLib_createBootstrapAlert($('#js-notice-message'), '<%=Resources.Resource.WFAdminWeb_Page_LicensePage_LicenseDeleted %>', "success", true);
                ws_hideProgressBar();
            }

            function onError(xhr, status, error, callbackdata) {
                if (xhr.statusText != null && xhr.statusText != undefined) {
                    wsLib_createBootstrapAlert($('#js-notice-message'), xhr.statusText, "error", true);
                }
                else {
                    wsLib_createBootstrapAlert($('#js-notice-message'), xhr.responseText, "error", true);
                }

                ws_hideProgressBar();
            }

            (function () {
                var $licenseKeyCopiedAlert = $('#js-alert-licensekey-copied');
                var $copyTextModal = $('#js-modal-copymenu');
                var $copyTextTarget = $copyTextModal.find('.js-link-copy-target');
                var $copyTextUnavailableNotice = $copyTextModal.find('.js-zeroclipboard-unavailable-notice');

                $('body').on('click', '.js-modal-licensekey-target', function (event) {
                    event.preventDefault();

                    $copyTextTarget.val($(this).data('ws-licensekey'));
                });

                ZeroClipboard.config({
                    swfPath: "assets/swf/ZeroClipboard.swf"
                });

                var currentCopyPlugin = new ZeroClipboard($('.js-link-copy'));

                currentCopyPlugin.on('ready', function (event) {
                    $copyTextModal.find('.js-link-copy').parent().show();
                    $copyTextUnavailableNotice.hide();

                    currentCopyPlugin.on('copy', function (event) {
                        var clipboard = event.clipboardData;

                        clipboard.setData("text/plain", $copyTextTarget.val());

                        $licenseKeyCopiedAlert.css('display', 'inline-block');

                        setTimeout(function () {
                            $licenseKeyCopiedAlert.slideUp();
                        }, 3000);
                    });
                });
            })();
        </script>
</asp:Content>
