﻿<%@ Page Title="Logging" Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage" %>

<asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
	Logging
</asp:Content>

<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
 <div class="row-fluid">
                    <div class="span12">
                        <ul id="breadcrumbs">
                            <li><a href="/Home">Administration</a> &rsaquo;</li>
                            <li>Logging</li>
                            <li class="related-links">
								<ul>
									<li class="related-label">Related:</li>
									<li class="link"><a href="/LogViewer">Log File Viewer</a></li>
								</ul>
							</li>
                        </ul>
                        <ul id="secnav">
                            <li class="active">
                                <h1>Logging</h1>
                            </li>
                        </ul>
                    </div>
                </div>
                <div class="row-fluid">
                    <div class="span8">
                    	<div class="settings-info">
                            <form class="form-horizontal">
                                <fieldset>
                                    <div class="control-group">
                                        <label class="control-label"><%=Resources.Resource.WFAdminWeb_Page_Logging_Title %></label>
                                        <div class="controls">
                                            <ul class="checkbox-group">
                                                <li>
                                                    <label>
                                                        <input type="checkbox" id="check-core" value="false"/>
                                                        <span>
                                                            CORE -- <%=Resources.Resource.WFAdminWeb_Page_Logging_CoreLoggingDescription %>
                                                        </span>
                                                    </label>
                                                </li>
                                                <li>
                                                    <label>
                                                        <input id="check-svservice" type="checkbox" value="false"/>
                                                        <span>
                                                            SVSERVICE -- <%=Resources.Resource.WFAdminWeb_Page_Logging_SVServiceLoggingDescription %>
                                                        </span>
                                                    </label>
                                                </li>
                                                <li>
                                                    <label>
                                                        <input id="check-timer" type="checkbox" value="false"/>
                                                        <span>
                                                            TIMER -- <%=Resources.Resource.WFAdminWeb_Page_Logging_TimerLoggingDescription %>
                                                        </span>
                                                    </label>
                                                </li>
                                                <li>
                                                    <label>
                                                        <input id="check-CA" type="checkbox" value="false"/>
                                                        <span>
                                                            CENTRAL ADMIN -- <%=Resources.Resource.WFAdminWeb_Page_Logging_CALoggingDescription %>
                                                        </span>
                                                    </label>
                                                </li>
                                                <li>
                                                    <label>
                                                        <input  id="check-SVADM" type="checkbox" value="false"/>
                                                        <span>
                                                            SVADM -- <%=Resources.Resource.WFAdminWeb_Page_Logging_SVAdmLoggingDescription %>
                                                        </span>
                                                    </label>
                                                </li>
                                            </ul>
                                        </div>
                                    </div>
                                    <div class="control-group">
                                        <label class="control-label"><%=Resources.Resource.WFAdminWeb_Page_Logging_LoggingLevelTitle %></label>
                                        <div class="controls">
                                            <div>
                                            <select  id="select-level" class="input-onethird" value="false">
                                                 <option value="Debug">
                                                    Debug
                                                </option>
                                                <option value="Info">
                                                    Info
                                                </option>
                                                <option value="Warn">
                                                    Warn
                                                </option>
                                                <option value="Error">
                                                    Error
                                                </option>
                                            </select>
                                            <span><%=Resources.Resource.WFAdminWeb_Page_Logging_LoggingLevelDescription %></span>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="control-group">
                                        <label class="control-label"><%=Resources.Resource.WFAdminWeb_Page_Logging_LoggingRetentionTitle %></label>
                                        <div class="controls">
                                            <ul class="checkbox-group inline-list">
                                                <li>
                                                    <label>
                                                        <input id="radio-append" type="radio" name="TEMPNAME-logretention" checked="checked" value="true"/>
                                                        <span>
                                                            <%=Resources.Resource.WFAdminWeb_Page_Logging_AppendToCurrentLogsTitle %>
                                                        </span>
                                                    </label>
                                                </li>
                                                <li>
                                                    <label>
                                                        <input id="radio-clear" type="radio" name="TEMPNAME-logretention" value="false"/>
                                                        <span>
                                                            <%=Resources.Resource.WFAdminWeb_Page_Logging_DeleteCurrentLogsTitle %>
                                                        </span>
                                                    </label>
                                                </li>
                                            </ul>
                                        </div>
                                    </div>
                                    <!--
                                    <div class="control-group">
                                        <label class="control-label">Logging Scope</label>
                                        <div class="controls">
                                            <ul class="checkbox-group inline-list">
                                                <li>
                                                    <label>
                                                        <input id="radio-currentFrontEnd" type="radio" name="TEMPNAME-loggingscope" checked="checked" value="true">
                                                        <span>
                                                            Current Front-End
                                                        </span>
                                                    </label>
                                                </li>
                                                <li>
                                                    <label>
                                                        <input id="radio-allFrontEnd" type="radio" name="TEMPNAME-loggingscope" value="false">
                                                        <span>
                                                            All Front-Ends
                                                        </span>
                                                    </label>
                                                </li>
                                            </ul>
                                        </div>
                                    </div>
                                    -->
                                    <div id="js-label-moreoptions" class="fewer-options">
                                   		<a class="js-container-moreoptions-trigger" href="javascript:void(0)">More Options</a>
                                               <div id="js-container-moreoptions" class="js-initial-hide">
                                   		<div class="control-group">
                                        	<label class="control-label">Additional Options</label>
	                                        <div class="controls">
	                                            <ul class="checkbox-group">
	                                                <li>
	                                                    <label>
	                                                        <input  id="check-stackTrace" type="checkbox" value="false"/>
	                                                        <span>
	                                                              <%=Resources.Resource.WFAdminWeb_Page_Logging_IncludeStackTraceTitle %>
	                                                        </span>
	                                                    </label>
	                                                    <div class="help-block">
	                                                       <%=Resources.Resource.WFAdminWeb_Page_Logging_IncludeStackTraceDescription %>
	                                                    </div>
	                                                </li>
	                                                <li>
	                                                    <label>
	                                                        <input  id="check-asyncLogging" type="checkbox" value="false"/>
	                                                        <span>
	                                                            <%=Resources.Resource.WFAdminWeb_Page_Logging_AsynchronousLogging %>
	                                                        </span>
	                                                    </label>
	                                                    <div class="help-block">
	                                                         <%=Resources.Resource.WFAdminWeb_Page_Logging_LogInSeparateThreadDescription %>.
	                                                    </div>
	                                                </li>
	                                            </ul>
	                                        </div>
                                   		</div>
                                   		<div class="control-group">
	                                        <label class="control-label"><%=Resources.Resource.WFAdminWeb_Page_Logging_IncludeOnlySpecificClasses %></label>
	                                        <div class="controls form-textandbutton">
	                                        	<input id="input-Classes" type="text" class="form-control input-block-level input-max" placeholder="e.g. WFAdminWeb.Models.Logging" />
                                                 <div class="help-block">
	                                                      <%=Resources.Resource.WFAdminWeb_Page_Logging_IncludeOnlySpecificClassesDescription %>
	                                              </div>
	                                        </div>
	                                    </div>
                                                </div>
                                    </div>
                                    <!--/fewer-options--> 
                                    <div class="control-group">
                                        <span id="js-notice-message"></span>
                                    </div>
                                    <div class="form-actions  top-line">
                                        <button id="btn-add" type="submit" class="btn btn-primary"><span>Save</span></button>
                                        <button class="btn" id="btnCancel"><span>Cancel</span></button>
                                    </div>
                                </fieldset>
                            </form>
                        </div>
                    </div>
                    <!-- /div .span8 -->
                </div>
                <script src="http://ajax.googleapis.com/ajax/libs/jquery/1.11.1/jquery.min.js"></script>
        <script>
            if (!window.jQuery) {
                console.error("jQuery CDN is down.")
                document.write('<script src="<%=Url.Content("~/Content/assets/js/jquery.min.js") %>"><\/script>');
            }
        </script>
        <script src="http://maxcdn.bootstrapcdn.com/bootstrap/3.2.0/js/bootstrap.min.js"></script>
        <script>
            if (!$.fn.modal) {
                console.error("Bootstrap CDN is down.")
                document.write('<script src="<%=Url.Content("~/Content/assets/js/bootstrap.min.js") %>"><\/script>');
            }
        </script>
        <script src="../../Content/assets/js/kendo.all.min.js"></script>
        <script src="../../Content/assets/js/wslib_master.js"></script>
        <script src="../../Content/assets/js/wsplugin_master.js"></script>
        <script src="../../Content/assets/js/ws_global_initialization_administration.js"></script>
          <script src="../../Content/assets/js/ws_common.js"></script>
        <script>
            $(document).ready(function () {
                ws_initializeWebApp('/admin/GetAllWebApp', $('#select-webapp'), function () {
                    var webappUrl = $('#select-webapp').val();
                    ws_ajaxCall('/logging/GetData', { server: webappUrl }, function (data, successData) {
                        if (data[0] != null && data[0] != 'undefined') {
                            $("#check-core").prop('checked', data[0].Core);
                            $("#check-svservice").prop('checked', data[0].SVService);
                            $("#check-timer").prop('checked', data[0].Timer);
                            $("#check-CA").prop('checked', data[0].CA);
                            $("#check-SVADM").prop('checked', data[0].SVAdm);
                            if (data[0].LogRetention) {
                                $("#radio-append").prop('checked', true);
                                $("#radio-clear").prop('checked', false);
                            }
                            else {
                                $("#radio-clear").prop('checked', true);
                                $("#radio-append").prop('checked', false);
                            }
                            // $("#radio-currentFrontEnd").prop('checked', data[0].LoggingScope);
                            $("#check-stackTrace").prop('checked', data[0].StackTrace);
                            $("#check-asyncLogging").prop('checked', data[0].AsyncLogging);
                            $("#input-Classes").val(data[0].LoggingClasses);
                            $("#select-level").val(data[0].LoggingLevel);
                        } 
                    }, null, null);
                });

                $("#select-webapp").change(function () {
                    SetupLinks();
                });

                $("#btnCancel").click(function () {
                    window.location.href = '/Home/index?server=' + $("#select-webapp").val();
                    return false;
                });
            });

            $("#btn-add").click(function () {
                ws_showProgressBar();
                var webappUrl = $("#select-webapp").val();
                var isCore = $("#check-core").prop('checked');
                var isTimer = $("#check-timer").prop('checked');
                var isSVService = $("#check-svservice").prop('checked');
                var isCA = $("#check-CA").prop('checked');
                var isSVAdm = $("#check-SVADM").prop('checked');
                var loggingLevel = $("#select-level").val();
                var logRetention = $("#radio-append").prop('checked');
                //  var loggingScope = $("#radio-currentFrontEnd").prop('checked');
                var stackTrace = $("#check-stackTrace").prop('checked');
                var asyncLogging = $("#check-asyncLogging").prop('checked');
                var loggingClasses = $("#input-Classes").val();
                var data = { webappUrl: webappUrl, isCore: isCore, isTimer: isTimer, isSVService: isSVService, isSVAdm: isSVAdm, isCA: isCA,
                    loggingLevel: loggingLevel, logRetention: logRetention, stackTrace: stackTrace,
                    asyncLogging: asyncLogging, loggingClasses: loggingClasses
                };

                ws_ajaxCall('/logging/Add', data, function (successData) {
                    window.location.href = "/LogViewer?server=" + webappUrl;
                    //wsLib_createBootstrapAlert($('#js-notice-message'), "Successfully added logging.", "success", true);
                    //ws_hideProgressBar();

                }, function (xhr, status, error) {
                    wsLib_createBootstrapAlert($('#js-notice-message'), "Some error occurred while adding logging.", "error", true);
                    ws_hideProgressBar();

                }, null);
                return false;
            });
        </script>
</asp:Content>
