﻿<%@ Page Title="Archive Obsolete Workflow Solution" Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage" %>

<asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
	Archive Obsolete Workflow Solution
</asp:Content>

<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
 <div class="row-fluid">
                    <div class="span12">
                        <ul id="breadcrumbs">
                            <li><a href="/home">Administration</a> &rsaquo;</li>
                            <li><a href="/Scheduler">Scheduler</a> &rsaquo;</li>
                            <li>Archive Obsolete Workflow Solution</li>
                            <li class="related-links">
                                <ul>
                                    <li class="related-label">Related:</li>
                                    <li class="link"><a href="/Scheduler">Scheduler</a></li>
                                    <li class="link"><a href="/Scheduler/MarkInactiveProcesses">Mark Inactive Processes</a></li>
                                    <li class="link"><a href="/Scheduler/PurgeBackgroundJobs">Purge Background Jobs</a></li>
                                    <li class="link"><a href="/Scheduler/PurgeProcessData">Purge Process Data</a></li>
                                </ul>
                            </li>
                        </ul>
                        <ul id="secnav">
                            <li class="active">
                                <h1>Archive Obsolete Workflow Solution</h1>
                            </li>
                        </ul>
                    </div>
                </div>
                <div class="row-fluid">
                    <div class="span8">
                        <div class="settings-info">
                            <form class="form-horizontal" id="form-control-container">
                                <fieldset>
                                    <div class="control-group">
                                        <label class="control-label">Source Site <span class="required">*</span></label>
                                        <div class="controls">
                                            <select class="input-max" id="sourceSiteDropDown" validation-type="required" required-message="Source Site is a required field.">
                                                <option value="N/A">Select</option>
                                            </select>
                                        </div>
                                    </div>
                                    <div class="control-group">
                                        <label class="control-label">Archive</label>
                                        <div class="controls">
                                            <ul class="checkbox-group inline-list">
                                                <li>
                                                    <label>
                                                    <input class="js-archive-toggle-view-master-0" id="archiveNowRadio" type="radio" name="TEMPNAME-logretention" checked="checked"  check-text="now" autocomplete="off"/>
                                                    <span>Now</span>
                                                    </label>
                                                </li>
                                                <li>
                                                    <label>
                                                    <input class="js-archive-toggle-view-master-1" id="archiveScheduleRadio" type="radio" name="TEMPNAME-logretention"  check-text="Schedule" autocomplete="off"/>
                                                    <span>Schedule</span>
                                                    </label>
                                                </li>
                                            </ul>
                                        </div>
                                    </div>
                                    <div class="js-archive-toggle-view-slave-1 control-group js-initial-hide">
                                        <label class="control-label">Day <span class="required">*</span></label>
                                        <div class="controls">
                                            <select class="js-chosen-target input-onethirds" id="archiveScheduleDayDropDown" validation-type="required" required-message="Schedule Day is a required field.">
                                                <option value="N/A">Select Option</option>
                                                <option value="1">First Day of the month</option>
                                                <option value="100">Last Day of the month</option>
                                                <option value="2">2nd</option>
                                                <option value="3">3rd</option>
                                                <option value="4">4th</option>
                                                <option value="5">5th</option>
                                                <option value="6">6th</option>
                                                <option value="7">7th</option>
                                                <option value="8">8th</option>
                                                <option value="9">9th</option>
                                                <option value="10">10th</option>
                                                <option value="11">11th</option>
                                                <option value="12">12th</option>
                                                <option value="13">13th</option>
                                                <option value="14">14th</option>
                                                <option value="15">15th</option>
                                                <option value="16">16th</option>
                                                <option value="17">17th</option>
                                                <option value="18">18th</option>
                                                <option value="19">19th</option>
                                                <option value="20">20th</option>
                                                <option value="21">21st</option>
                                                <option value="22">22nd</option>
                                                <option value="23">23rd</option>
                                                <option value="24">24th</option>
                                                <option value="25">25th</option>
                                                <option value="26">26th</option>
                                                <option value="27">27th</option>
                                                <option value="28">28th</option>
                                                <option value="29">29th</option>
                                                <option value="30">30th</option>
                                            </select>
                                        </div>
                                    </div>
                                    <div class="js-archive-toggle-view-slave-1 control-group js-initial-hide">
                                        <label class="control-label">Time <span class="required">*</span></label>
                                        <div class="controls ">
                                            <input type="text" id="archiveScheduleTimeDropDown" class="js-kendo-timepicker form-control input-onethirds" placeholder="HH:mm AM/PM" validation-type="required,regex" validation-regex="^([0-9]|1[0-2]):[0-5][0-9]\s(AM|PM)$" regex-message="Time should be in HH:MM AM/PM format"/>
                                        </div>
                                    </div>
                                    <div>
                                        <label class="control-label">User(s) to Notify </label>
                                        <div class="controls ">
                                            <input type="text" id="userToNotifyTextBox" class="form-control input-block-level" placeholder="e.g. user@winshuttle.com, user@email.com" validation-type="regex" validation-regex="^((\w+([-+.]\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*)\s*[,]{0,1}\s*)+$" regex-message="Email should be in the format abc@xyz.com."/>
                                        </div>
                                    </div>
                                    <div class="page-header clearfix">
                                        <h2>Destination</h2>
                                    </div>
                                    <div class="control-group">
                                        <label class="control-label">Server <span class="required">*</span></label>
                                        <div class="controls">
                                            <select class="input-max" id = "destinationServerDropDown" validation-type="required" required-message="Destination Server is a required field.">
                                                <option value="N/A">http://server/</option>
                                            </select>
                                        </div>
                                    </div>
                                    <div class="control-group">
                                        <label class="control-label">Site <span class="required">*</span></label>
                                        <div class="controls">
                                            <select class="input-max" id = "destinationSiteDropDown" validation-type="required" required-message="Destination Site is a required field.">
                                                <option value = "N/A">Select</option>
                                            </select>
                                        </div>
                                    </div>
                                    <div class="control-group">
                                        <label class="control-label">Document Library <span class="required">*</span></label>
                                        <div class="controls">
                                            <select class="input-max" id = "destinationLibraryDropDown" validation-type="required" required-message="Document Library is a required field.">
                                                <option value="N/A">Select</option>
                                            </select>
                                        </div>
                                    </div>
                                    <div class="control-group">
                                        <span id="js-notice-message"></span>
                                    </div>
                                         <div class="form-actions top-line">
                                        <button type="submit" class="btn btn-primary" id="btnSave"><span>Save</span></button>
                                        <button class="btn" id="btnCancel"><span>Cancel</span></button>
                                    </div>
                                </fieldset>
                            </form>
                        </div>
                    </div>
                    <!-- /div .span8 -->
                </div>
                <!-- /div .row-fluid -->
				<script src="http://ajax.googleapis.com/ajax/libs/jquery/1.11.1/jquery.min.js"></script>
       <script>
           if (!window.jQuery) {
               console.error("jQuery CDN is down.")
               document.write('<script src="<%=Url.Content("~/Content/assets/js/jquery.min.js") %>"><\/script>');
           }
        </script>
        <script src="http://maxcdn.bootstrapcdn.com/bootstrap/3.2.0/js/bootstrap.min.js"></script>
        <script>
            if (!$.fn.modal) {
                console.error("Bootstrap CDN is down.")
                document.write('<script src="<%=Url.Content("~/Content/assets/js/bootstrap.min.js") %>"><\/script>');
            }
        </script>
        <script src="/Content/assets/js/kendo.all.min.js"></script>
        <script src="/Content/assets/js/chosen.jquery.min.js"></script>
        <script src="/Content/assets/js/wslib_master.js"></script>
        <script src="/Content/assets/js/wsplugin_master.js"></script>
        <script src="/Content/assets/js/ws_global_initialization_administration.js"></script>
        <script src="/Content/assets/js/ws_common.js"></script>
        <script>
            var strTimestamp;   //Global Variable

            $('.js-chosen-target').chosen({
                width: "33.3333333333%",
                disable_search: true
            });

            wsLib_toggleViews("archive", 2, "radio", "no", 200);

            var ws_fillSite = function (url, target, callback, site) {

                ws_ajaxCall(url, null, function (data, callbackdata) {
                    $(target).find('option').remove();
                    var defaultValue = '<option value="N/A">Select</option>';
                    var options = getOption(data);

                    $(target).append($(defaultValue));                       //Appending Default Value
                    $(target).append($(options));

                    if (site != null) {
                        $(target).val(site);
                    }
                    // callback after this.
                    if (callback != null && callback != undefined) {
                        callback(data, callbackdata);
                    }
                }, null, null);

                function getOption(data) {
                    var option = '';

                    $.each(data, function (k, v) {
                        option += '<option value="' + v.URL + '">' + v.URL + '</option>';
                    });

                    return option;
                }
            }

            var ws_fillList = function (url, target, callback, list) {

                ws_ajaxCall(url, null, function (data, callbackdata) {
                    $(target).find('option').remove();
                    var defaultValue = '<option value="N/A">Select</option>';
                    var options = getOption(data);
                    $(target).append($(defaultValue));                       //Appending Default Value
                    $(target).append($(options));

                    if (list != null) {
                        $(target).val(list);
                    }

                    // callback after this.
                    if (callback != null && callback != undefined) {
                        callback(data, callbackdata);
                    }
                }, null, null);

                function getOption(data) {
                    var option = '';

                    $.each(data, function (k, v) {
                        option += '<option value="' + v.Name + '">' + v.Name + '</option>';
                    });

                    return option;
                }
            }

            var ws_FillDestinationSiteAndLibrary = function (site, list) {
                var selectedWebApp = $('#destinationServerDropDown').val();
                ws_fillSite("/admin/GetAllSites?server=" + selectedWebApp, $('#destinationSiteDropDown'), function (data, callbackdata) {
                    var selectedSite = $('#destinationSiteDropDown').val();
                    ws_fillList("/admin/GetAllDocLib?site=" + selectedSite, $('#destinationLibraryDropDown'), null, list);
                }, site);
            }

            var ws_FillSourceSite = function (site) {
                var selectedWebApp = $('#select-webapp').val();
                ws_fillSite("/admin/GetAllSites?server=" + selectedWebApp, $('#sourceSiteDropDown'), null, site);
            }

            $(document).ready(function () {
                ws_showProgressBar();
                ws_initializeWebApp("/admin/GetAllWebApp", $('#select-webapp'), function (data, callbackdata) {

                    var $id = wsPlugin_getURLParameter('id');
                    var $url = $('#select-webapp').val();

                    if ($id != null) {

                        ws_ajaxCall('/service/detail', { id: $id, url: $url }, function (data, callbackdata) {

                            var xml = data.Xml;
                            var xmlDocumentObj = loadXMLString(xml);
                            strTimestamp = data.TimeStamp;
                            var strStatus = data.Status;
                            var sourceSite = $(xmlDocumentObj).find("SourceSite").text();
                            var usersToNotify = $(xmlDocumentObj).find("UsersToNotify").text();
                            var destinationServer = $(xmlDocumentObj).find("DestinationServer").text();
                            var destinationSite = $(xmlDocumentObj).find("DestinationSite").text();
                            var destinationLibrary = $(xmlDocumentObj).find("DestinationLibrary").text();
                            var hostName = $(xmlDocumentObj).find("HostName").text();
                            var scheduleXml = $(xmlDocumentObj).find("ScheduleXml").text();

                            xmlDocumentObj = loadXMLString(scheduleXml);

                            var scheduleType = $(xmlDocumentObj).find("Type").text();
                            var scheduleDay = $(xmlDocumentObj).find("ScheduleDay").text();
                            var scheduleTime = $(xmlDocumentObj).find("ScheduleTime").text();

                            $("#select-webapp").val(hostName);                            
                            ws_FillSourceSite(sourceSite);
                            ws_initializeWebApp("/admin/GetAllWebApp", $('#destinationServerDropDown'), function (data, callbackdata) {
                                $('#destinationServerDropDown').val(destinationServer);
                                ws_FillDestinationSiteAndLibrary(destinationSite, destinationLibrary);
                            });

                            if (scheduleType == 'now') {
                                $('#archiveNowRadio').prop('checked', true).change();
                            }
                            else {
                                $('#archiveScheduleRadio').prop('checked', true).change();
                                $("#archiveScheduleDayDropDown").val(scheduleDay).trigger("chosen:updated");
                                $("#archiveScheduleTimeDropDown").val(scheduleTime);
                            }

                            $("#userToNotifyTextBox").val(usersToNotify);

                            if (strStatus != 'Pending') {
                                wsLib_createBootstrapAlert($('#js-notice-message'), "This job cannot be modified. As this is running or no more valid.", "error", false);
                                $("#btnSave").prop('disabled', 'disabled').addClass('btn-disabled');
                                ws_hideProgressBar();
                                return false;
                            }                           

                        }, null, null);
                        $('#select-webapp').prop("disabled", true);
                    }
                    else {
                        ws_initializeWebApp("/admin/GetAllWebApp", $('#select-webapp'), function (data, callbackdata) {
                            ws_FillSourceSite(null);
                        });

                        ws_initializeWebApp("/admin/GetAllWebApp", $('#destinationServerDropDown'), function (data, callbackdata) {
                            ws_FillDestinationSiteAndLibrary(null, null);
                        });
                    }
                    ws_hideProgressBar();
                });
            });


            $("#select-webapp").change(function () {
                SetupLinks();
            });

            $("#destinationServerDropDown").change(function () {
                ws_FillDestinationSiteAndLibrary(null, null);
            });

            $("#destinationSiteDropDown").change(function () {
                var selectedSite = $('#destinationSiteDropDown').val();
                ws_fillList("/admin/GetAllDocLib?site=" + selectedSite, $('#destinationLibraryDropDown'), null, null);
            });

            function CallBackFunctionSuccess(data, callbackdata) {
                window.location.href = '/Scheduler?server=' + $("#select-webapp").val();
            }

            function CallBackFunctionFailure(xhr, status, error, callbackdata) {
                ws_hideProgressBar();
                if (xhr.statusText != null && xhr.statusText != undefined) {
                    wsLib_createBootstrapAlert($('#js-notice-message'), xhr.statusText, "error", true);
                }
            }

            $("#btnCancel").click(function () {
                window.location.href = '/Scheduler?server=' + $("#select-webapp").val();
                return false;             
            });

            function ValidateScheduleDay() {
                $("#archiveScheduleDayDropDown_chosen-validationMessage").remove();
                val = $("#archiveScheduleDayDropDown").find("option:selected").val();
                if ($("#archiveScheduleDayDropDown_chosen").is(':visible') && val == "N/A") {
                    createSpanElement($("#archiveScheduleDayDropDown_chosen"), 'Schedule Day is a required field.', 'field-validation-error');
                    $("#archiveScheduleDayDropDown").on('change', function () {
                        if ($("#archiveScheduleDayDropDown").find("option:selected").val() == "N/A") {
                            $("#archiveScheduleDayDropDown_chosen-validationMessage").remove();
                            createSpanElement($("#archiveScheduleDayDropDown_chosen"), 'Schedule Day is a required field.', 'field-validation-error');
                        }
                        else {
                            $("#archiveScheduleDayDropDown_chosen-validationMessage").remove();
                        }
                    });
                    return false;
                }

                return true;
            }

            $("#btnSave").click(function () {
                var blnScheduleDayValdiation = ValidateScheduleDay();
                if (!validateClientSide('form-control-container') || !blnScheduleDayValdiation) {
                    return false;
                }

                var strSite, blnArchiveNow, strScheduleDay, strScheduleTime, strUserNotifyEmail, strScheduleType, strDestinationServer, strDestinationSite, strDestinationLibrary;

                //Getting Source details

                strSite = $("#sourceSiteDropDown").val();
                if (strSite.length == 0) {
                    return false;
                }


                //Getting Schedule Details
                strScheduleType = $("input[name=TEMPNAME-logretention]:checked").attr('check-text');
                blnArchiveNow = $("#archiveNowRadio").prop('checked');
                if (blnArchiveNow == false) {
                    strScheduleDay = $("#archiveScheduleDayDropDown").val();
                    if (strScheduleDay.length == 0) {
                        return false;
                    }
                    strScheduleTime = $("#archiveScheduleTimeDropDown").val();
                    if (strScheduleTime.length == 0) {
                        return false;
                    }
                }

                strUserNotifyEmail = $("#userToNotifyTextBox").val();

                //Getting Destination Details
                var strDestinationServer = $("#destinationServerDropDown").val();
                if (strDestinationServer.length == 0) {
                    return false;
                }

                var strDestinationSite = $("#destinationSiteDropDown").val();
                if (strDestinationSite.length == 0) {
                    return false;
                }

                var strDestinationLibrary = $("#destinationLibraryDropDown").val();
                if (strDestinationLibrary.length == 0) {
                    return false;
                }

               
                //Getting HostName
                var strHostName = $("#select-webapp").val();
                
                var $id = wsPlugin_getURLParameter('id');

                ws_showProgressBar();
                if ($id == null) {

                    ws_ajaxCall('/Scheduler/CreateArchiveSolutionServiceEntry',
                            {
                                sourceSite: strSite,
                                isArchiveNow: blnArchiveNow,
                                scheduleType: strScheduleType,
                                scheduleDay: strScheduleDay,
                                scheduleTime: strScheduleTime,
                                usersToNotify: strUserNotifyEmail,
                                destinationServer: strDestinationServer,
                                destinationSite: strDestinationSite,
                                destinationLibrary: strDestinationLibrary,
                                hostName: strHostName
                            },
                              CallBackFunctionSuccess, CallBackFunctionFailure,
                              null);
                }
                else {
                    ws_ajaxCall('/Scheduler/UpdateArchiveSolutionServiceEntry',
                            {
                                id: $id,
                                sourceSite: strSite,
                                isArchiveNow: blnArchiveNow,
                                scheduleType: strScheduleType,
                                scheduleDay: strScheduleDay,
                                scheduleTime: strScheduleTime,
                                usersToNotify: strUserNotifyEmail,
                                destinationServer: strDestinationServer,
                                destinationSite: strDestinationSite,
                                destinationLibrary: strDestinationLibrary,
                                hostName: strHostName,
                                timeStamp: strTimestamp
                            },
                              CallBackFunctionSuccess, CallBackFunctionFailure,
                              null);

                }
                return false;
            });
        </script>
</asp:Content>
