﻿<%@ Page Title="Purge Background Jobs" Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage" %>

<asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
	Purge Background Jobs
</asp:Content>

<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
<div class="row-fluid">
                    <div class="span12">
                        <ul id="breadcrumbs">
                            <li><a href="/Home">Administration</a> &rsaquo;</li>
                            <li><a href="/Scheduler">Scheduler</a> &rsaquo;</li>
                            <li>Purge Background Jobs</li>
                            <li class="related-links">
								<ul>
									<li class="related-label">Related:</li>
									<li class="link"><a href="/Scheduler">Scheduler</a></li>
									<li class="link"><a href="/Scheduler/MarkInactiveProcesses">Mark Inactive Processes</a></li>
									<li class="link"><a href="/Scheduler/PurgeProcessData">Purge Process Data</a></li>
									<li class="link"><a href="/Scheduler/ArchiveObsoleteWorkflowSolution">Archive Obsolete Workflow Solution</a></li>
									<li class="link"><a href="/Job">Background Processes</a></li>
								</ul>
							</li>
                        </ul>
                        <ul id="secnav">
                            <li class="active">
                                <h1>Purge Background Jobs</h1>
                            </li>
                        </ul>
                    </div>
                </div>
                <div class="row-fluid">
                    <div class="span8">    
                         <div class="settings-info">
                            <form class="form-horizontal" id="form-control-container">
                                <fieldset>
                                    <div class="control-group">
                                        <label class="control-label">Status(es) to Purge <span class="required">*</span></label>
                                        <div class="controls">
                                            <ul class="checkbox-group" >
                                                <li>
                                                    <label>
                                                        <input type="checkbox" id="statusCompletechkBox" checked="checked"/>
                                                        <span id="CompleteCheckBoxLabel">
                                                            COMPLETE
                                                        </span>
                                                    </label>
                                                </li>
                                                <li>
                                                    <label>
                                                        <input type="checkbox" id="statusErrorchkBox"/>
                                                        <span>
                                                            ERROR
                                                        </span>
                                                    </label>
                                                </li>
                                                <li>
                                                    <label>
                                                        <input type="checkbox" id="statusPendingchkBox"/>
                                                        <span>
                                                            PENDING
                                                        </span>
                                                    </label>
                                                </li>
                                            </ul>
                                        </div>
                                    </div>
                                    
                                    <div class="control-group">
                                        <label class="control-label">Begin Purging</label>
                                        <div class="controls">
                                            <ul class="checkbox-group inline-list">
                                                <li>
                                                    <label>
                                                    <input class="js-logretention-toggle-view-master-0" type="radio" id="purgeNowRadio" name="TEMPNAME-logretention" checked="checked" check-text="now" autocomplete="off"/>
                                                    <span>
                                                    Now
                                                    </span>
                                                    </label>
                                                </li>
                                                <li>
                                                    <label>
                                                    <input class="js-logretention-toggle-view-master-1" type="radio" id="purgeScheduleRadio" name="TEMPNAME-logretention" check-text="schedule" autocomplete="off"/>
                                                    <span>
                                                    Schedule
                                                    </span>
                                                    </label>
                                                </li>
                                            </ul>
                                        </div>
                                    </div>
                                    <div class="control-group js-logretention-toggle-view-slave-1 js-initial-hide">
                                        <label class="control-label">Day <span class="required">*</span></label>
                                        <div class="controls">
                                            <select class="js-chosen-target input-onethirds" id="purgeScheduleDayDropDown" >
                                                <option value="N/A">Select Option</option>
                                                <option value="1">First Day of the month</option>
                                                <option value="100">Last Day of the month</option>
                                                <option value="2">2nd</option>
                                                <option value="3">3rd</option>
                                                <option value="4">4th</option>
                                                <option value="5">5th</option>
                                                <option value="6">6th</option>
                                                <option value="7">7th</option>
                                                <option value="8">8th</option>
                                                <option value="9">9th</option>
                                                <option value="10">10th</option>
                                                <option value="11">11th</option>
                                                <option value="12">12th</option>
                                                <option value="13">13th</option>
                                                <option value="14">14th</option>
                                                <option value="15">15th</option>
                                                <option value="16">16th</option>
                                                <option value="17">17th</option>
                                                <option value="18">18th</option>
                                                <option value="19">19th</option>
                                                <option value="20">20th</option>
                                                <option value="21">21st</option>
                                                <option value="22">22nd</option>
                                                <option value="23">23rd</option>
                                                <option value="24">24th</option>
                                                <option value="25">25th</option>
                                                <option value="26">26th</option>
                                                <option value="27">27th</option>
                                                <option value="28">28th</option>
                                                <option value="29">29th</option>
                                                <option value="30">30th</option>
                                            </select>
                                        </div>
                                    </div>
                                    <div class="control-group js-logretention-toggle-view-slave-1 js-initial-hide">
                                        <label class="control-label">Time <span class="required">*</span></label>
                                        <div class="controls ">
                                            <input type="text" id="purgeScheduleTimeDropDown" class="js-kendo-timepicker form-control input-onethirds" placeholder="HH:mm AM/PM" validation-type="required,regex" validation-regex="^([0-9]|1[0-2]):[0-5][0-9]\s(AM|PM)$" regex-message="Time should be in HH:MM AM/PM format"/>
                                        </div>
                                    </div>
                                    
                                    <div class="control-group">
                                        <label class="control-label">Purge Duration (minutes)<span class="required">*</span></label>
                                        <div class="controls ">
                                        	<input type="text" id="purgeDurationDropDown" placeholder="-1" validation-type="required,regex" required-message="Purge duration is a required field." regex-message="Value should be numeric, between 1 to 999 or -1." validation-regex="^(-1|[1-9][0-9]{0,2})$"/>
                                            <div class="help-block">Specify -1 to purge all records with selected criteria.</div>
                                        </div>
                                    </div>

                               		<div class="control-group">
                                        <label class="control-label">User(s) to Notify</label>
                                        <div class="controls ">
                                        	<input type="text" id="usersToNotifyTextBox" class="form-control input-block-level"  placeholder="e.g. user@winshuttle.com, user@email.com" validation-type="regex" validation-regex="^((\w+([-+.]\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*)\s*[,]{0,1}\s*)+$" regex-message="Email should be in the format abc@xyz.com."/>
                                        </div>
                                    </div>
	                                
                                    <div class="control-group">
                                        <span id="js-notice-message"></span>
                                    </div>

                                    <div class="form-actions top-line">
                                        <button type="submit" id="btnSave" class="btn btn-primary"><span>Save</span></button>                                        
                                        <button class="btn" id="btnCancel"><span>Cancel</span></button>
                                    </div>
                                    
                                </fieldset>
                            </form>
                        </div>
                        
                    </div><!-- /div .span8 -->
                </div><!-- /div .row-fluid -->
				<script src="http://ajax.googleapis.com/ajax/libs/jquery/1.11.1/jquery.min.js"></script>
        <script>
            if (!window.jQuery) {
                console.error("jQuery CDN is down.")
                document.write('<script src="<%=Url.Content("~/Content/assets/js/jquery.min.js") %>"><\/script>');
            }
        </script>
        <script src="http://maxcdn.bootstrapcdn.com/bootstrap/3.2.0/js/bootstrap.min.js"></script>
        <script>
            if (!$.fn.modal) {
                console.error("Bootstrap CDN is down.")
                document.write('<script src="<%=Url.Content("~/Content/assets/js/bootstrap.min.js") %>"><\/script>');
            }
        </script>
        <script src="/Content/assets/js/kendo.all.min.js"></script>
        <script src="/Content/assets/js/chosen.jquery.min.js"></script>
        <script src="/Content/assets/js/wslib_master.js"></script>
        <script src="/Content/assets/js/wsplugin_master.js"></script>
        <script src="/Content/assets/js/ws_global_initialization_administration.js"></script>
        <script src="/Content/assets/js/ws_common.js"></script>
        <script>
            var strTimestamp;   //Global Variable

            wsLib_toggleViews("logretention", 2, "radio", "no", 200);

            $('.js-chosen-target').chosen({
                width: "33.3333333333%",
                disable_search: true
            });

            $(document).ready(function () {
                ws_showProgressBar();
                ws_initializeWebApp('/admin/getallwebapp', $('#select-webapp'), function () {
                    var $id = wsPlugin_getURLParameter('id');
                    var $url = $('#select-webapp').val();
                    if ($id != null) {
                        ws_ajaxCall('/service/detail', { id: $id, url: $url }, function (data, callbackdata) {

                            var xml = data.Xml;
                            var xmlDocumentObj = loadXMLString(xml);
                            strTimestamp = data.TimeStamp;
                            var strStatus = data.Status;
                            var isComplete = $(xmlDocumentObj).find("Complete").text();
                            var isPending = $(xmlDocumentObj).find("Pending").text();
                            var isError = $(xmlDocumentObj).find("Error").text();
                            var usersToNotify = $(xmlDocumentObj).find("UsersToNotify").text();
                            var purgeDuration = $(xmlDocumentObj).find("PurgeDuration").text();
                            var hostName = $(xmlDocumentObj).find("HostName").text();
                            var scheduleXml = $(xmlDocumentObj).find("ScheduleXml").text();

                            xmlDocumentObj = loadXMLString(scheduleXml);
                            var scheduleType = $(xmlDocumentObj).find("Type").text();
                            var scheduleDay = $(xmlDocumentObj).find("ScheduleDay").text();
                            var scheduleTime = $(xmlDocumentObj).find("ScheduleTime").text();

                            $("#statusCompletechkBox").attr('checked', isComplete.toLowerCase() === 'true');
                            $("#statusPendingchkBox").attr('checked', isPending.toLowerCase() === 'true');
                            $("#statusErrorchkBox").attr('checked', isError.toLowerCase() === 'true');
                            if (scheduleType == 'now') {
                                $('#purgeNowRadio').prop('checked', true).change();
                            }
                            else {
                                $('#purgeScheduleRadio').prop('checked', true).change();
                                $("#purgeScheduleDayDropDown").val(scheduleDay).trigger("chosen:updated");
                                $("#purgeScheduleTimeDropDown").val(scheduleTime);
                            }

                            $("#usersToNotifyTextBox").val(usersToNotify);
                            $("#purgeDurationDropDown").val(purgeDuration);
                            $("#select-webapp").val(hostName);
                            if (strStatus != 'Pending') {
                                wsLib_createBootstrapAlert($('#js-notice-message'), "This job cannot be modified. As this is running or no more valid.", "error", false);
                                $("#btnSave").prop('disabled', 'disabled').addClass('btn-disabled');
                                ws_hideProgressBar();
                                return false;
                            }

                        }, null, null);
                        $('#select-webapp').prop("disabled", true);
                    }
                    ws_hideProgressBar();
                });

                $("#select-webapp").change(function () {
                    SetupLinks();
                });
            });

            function CallBackFunctionSuccess(data, callbackdata) {
                window.location.href = '/Scheduler?server=' + $("#select-webapp").val();
            }

            function CallBackFunctionFailure(xhr, status, error, callbackdata) {
                ws_hideProgressBar();
                if (xhr.statusText != null && xhr.statusText != undefined) {
                    wsLib_createBootstrapAlert($('#js-notice-message'), xhr.statusText, "error", true);
                }
            }

            //Function to show confirmation dialog box
            var ws_confirmationDialogBox = function () {
                var result = false;
                var kendoWindow = $("<div />").kendoWindow({
                    title: "Confirm",
                    resizable: false,
                    modal: true
                });

                kendoWindow.data("kendoWindow")
                .content($("#pending-confirmation").html())
                .center().open();

                kendoWindow
                .find(".pending-confirm,.pending-cancel")
                .click(function () {
                    if ($(this).hasClass("pending-confirm")) {
                        CreateUpdateEntry();
                    }
                    kendoWindow.data("kendoWindow").close();
                })
            .end()

                return result;
            }

            function ValidateStatusToPurgeCheckBoxes() {
                $("#CompleteCheckBoxLabel-validationMessage").remove();
                if (!$("#statusCompletechkBox").prop('checked') && !$("#statusPendingchkBox").prop('checked') && !$("#statusErrorchkBox").prop('checked')) {
                    createSpanElement($("#CompleteCheckBoxLabel"), 'Atleast one option is required.', 'field-validation-error');
                    return false;
                }

                return true;
            }

            function ValidateScheduleDay() {
                $("#purgeScheduleDayDropDown_chosen-validationMessage").remove();
                val = $("#purgeScheduleDayDropDown").find("option:selected").val();
                if ($("#purgeScheduleDayDropDown_chosen").is(':visible') && val == "N/A") {
                    createSpanElement($("#purgeScheduleDayDropDown_chosen"), 'Schedule Day is a required field.', 'field-validation-error');
                    $("#purgeScheduleDayDropDown").on('change', function () {
                        if ($("#purgeScheduleDayDropDown").find("option:selected").val() == "N/A") {
                            $("#purgeScheduleDayDropDown_chosen-validationMessage").remove();
                            createSpanElement($("#purgeScheduleDayDropDown_chosen"), 'Schedule Day is a required field.', 'field-validation-error');
                        }
                        else {
                            $("#purgeScheduleDayDropDown_chosen-validationMessage").remove();
                        }
                    });
                    return false;
                }

                return true;
            }


            $("#btnCancel").click(function () {
                window.location.href = '/Scheduler?server=' + $("#select-webapp").val();
                return false;
            });

            $("#btnSave").click(function () {
                var blnScheduleDayValdiation = ValidateScheduleDay();
                var blncheckBoxValidationResult = ValidateStatusToPurgeCheckBoxes();
                if (!validateClientSide('form-control-container') || !blncheckBoxValidationResult || !blnScheduleDayValdiation) {
                    return false;
                }
                var blnPending = $("#statusPendingchkBox").prop('checked');
                if (blnPending) {
                    ws_confirmationDialogBox();
                    return false;
                }

                CreateUpdateEntry();
                return false;
            });

            function CreateUpdateEntry() {
                var blnComplete, blnPending, blnError, blnPurgeNow, strScheduleType, strScheduleDay, strScheduleTime, strUserNotifyEmail, intPurgeDuration;
                blnComplete = $("#statusCompletechkBox").prop('checked');
                blnPending = $("#statusPendingchkBox").prop('checked');
                blnError = $("#statusErrorchkBox").prop('checked');
                strScheduleType = $("input[name=TEMPNAME-logretention]:checked").attr('check-text');
                blnPurgeNow = $("#purgeNowRadio").prop('checked');
                if (blnPurgeNow == false) {
                    strScheduleDay = $("#purgeScheduleDayDropDown").val();
                    strScheduleTime = $("#purgeScheduleTimeDropDown").val();
                }

                strUserNotifyEmail = $("#usersToNotifyTextBox").val();
                intPurgeDuration = $("#purgeDurationDropDown").val();
                var strHostName = $("#select-webapp").val();

                var $id = wsPlugin_getURLParameter('id');
                ws_showProgressBar();
                if ($id == null) {
                    ws_ajaxCall('/Scheduler/CreatePurgeServiceEntry',
                            {
                                isStatusComplete: blnComplete,
                                isStatusPending: blnPending,
                                isStatusError: blnError,
                                isPurgeNow: blnPurgeNow,
                                scheduleType: strScheduleType,
                                scheduleDay: strScheduleDay,
                                scheduleTime: strScheduleTime,
                                usersToNotify: strUserNotifyEmail,
                                purgeDuration: intPurgeDuration,
                                hostName: strHostName
                            },
                              CallBackFunctionSuccess, CallBackFunctionFailure,
                              null);
                }
                else {
                    ws_ajaxCall('/Scheduler/UpdatePurgeServiceEntry',
                            {
                                id: $id,
                                isStatusComplete: blnComplete,
                                isStatusPending: blnPending,
                                isStatusError: blnError,
                                isPurgeNow: blnPurgeNow,
                                scheduleType: strScheduleType,
                                scheduleDay: strScheduleDay,
                                scheduleTime: strScheduleTime,
                                usersToNotify: strUserNotifyEmail,
                                purgeDuration: intPurgeDuration,
                                hostName: strHostName,
                                timeStamp: strTimestamp
                            },
                              CallBackFunctionSuccess, CallBackFunctionFailure,
                              null);
                }
            }

        </script>
        <script id="pending-confirmation" type="text/x-kendo-template">
        <p class="pending-message">This operation will purge all pending SVService jobs and may affect currently running processes. Do you want to continue? </p>
		<div align='center'>
		<ul class="pagination">
		<li>
        <button class="pending-confirm k-button">Yes</button>
		</li>
		<li>
        <button class="pending-cancel k-button">No</button>
		</li>
		<ul>
		</div>
        </script>
</asp:Content>
