﻿<%@ Page Title="Add Plugin" Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage" %>

<asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
	Add Plugin
</asp:Content>

<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
 <div class="row-fluid">
                    <div class="span12">
                        <ul id="breadcrumbs">
                            <li><a href="/Home">Administration</a> &rsaquo;</li>
                            <li><a href="/ServerConfig">Workflow Design Configuration</a> &rsaquo;</li>
                            <li><a href="/ServerConfig/Plugins">Plugins</a> &rsaquo;</li>
                            <li>Add Plugin</li>
                            <li class="related-links">
                                <ul>
                                    <li class="related-label">Related Tasks:</li>
                                    <li class="link"><a href="/ServerConfig">Workflow Design Configuration</a></li>
                                    <li class="link"><a href="/ServerConfig/ParticipantResolvers">Participant Resolvers</a></li>
                                    <li class="link"><a href="/ServerConfig/FormControls">Form Controls</a></li>
                                </ul>
                            </li>
                        </ul>
                        <ul id="secnav">
                            <li class="active">
                                <h1>Add Plugin</h1>
                            </li>
                        </ul>
                    </div>
                </div>
                <form class="form-horizontal">
                    <div class="row-fluid">
                        <div class="span8">
                            <div class="settings-info">
                                <fieldset class="form-horizontal">
                                    <div class="control-group">
                                        <label class="control-label">Name <span class="required">*</span></label>
                                        <div class="controls " id="div-plugin-name">
                                            <input type="text" id="input-plugin-name" validation-type="required" required-message="Plugin name is a required field." class="form-control input-block-level input-max" placeholder="">
                                        </div>
                                    </div>
                                    <div class="control-group">
                                        <label class="control-label">Create with</label>
                                        <div class="controls">
                                            <ul class="checkbox-group inline-list">
                                                <li>
                                                    <label>
                                                    <input type="radio" class="js-createwith-toggle-view-master-0 js-administration-newplugin-checkparametersvisibility" name="TEMP_create_with" value="xml" checked="checked" data-finalsavecancel-alwaysshow="true"/>
                                                    <span>XML</span>
                                                    <!--
                                                    <a class="tooltip-help js-tooltip-target" href="#">[?]</a> 
                                                    -->
                                                    </label>
                                                </li>
                                                <li>
                                                    <label>
                                                    <input type="radio" class="js-createwith-toggle-view-master-1 js-administration-newplugin-checkparametersvisibility" name="TEMP_create_with" value="designer" />
                                                    <span>Plugin Designer</span>
                                                    <!--
                                                    <a class="tooltip-help js-tooltip-target" href="#">[?]</a> 
                                                    -->
                                                    </label>
                                                </li>
                                            </ul>
                                        </div>
                                    </div>
                                    
                                    <!--if xml choses-->
                                    <div class="control-group js-createwith-toggle-view-slave-0">
                                        <label class="control-label">XML <span class="required">*</span></label>
                                        <div class="controls " id="div-plugin-xml">
                                            <textarea id="input-plugin-xml" class="js-transform-formexpand input-block-level" validation-type="required" required-message="Plugin xml is a required field."></textarea>
                                        </div>
                                    </div>
                                    
                                    <!--if plugin designer chosen-->
                                    
                                    
                                    
                                    <div class="js-createwith-toggle-view-slave-1 js-initial-hide" id="div-plugin-controls">
                                        
                                        <div class="control-group">
                                            <label class="control-label">Plugin Description <span class="required">*</span></label>
                                            <div class="controls ">
                                            <div>
                                                <textarea id="input-plugin-description" class="input-block-level" validation-type="required" required-message="Plugin description is a required field."></textarea>
                                            </div>
                                            </div>
                                        </div>
                                        <div class="control-group">
                                            <label class="control-label">Assembly <span class="required">*</span></label>
                                            <div class="controls ">
                                                <input type="text" id="input-plugin-assembly" class="form-control input-block-level input-max" placeholder="" validation-type="required" required-message="Assembly name is a required field."/>
                                            </div>
                                        </div>
                                        <div class="control-group">
                                            <label class="control-label">Plugin Class <span class="required">*</span></label>
                                            <div class="controls ">
                                                <input type="text" id="input-plugin-class" class="form-control input-block-level input-max" placeholder="" validation-type="required" required-message="Plugin Class is a required field."/>
                                            </div>
                                        </div>
                                        <div class="control-group">
                                            <label class="control-label">Validator Class</label>
                                            <div class="controls ">
                                                <input type="text" id="input-plugin-validator" class="form-control input-block-level input-max" value="WFDesigner.Validator.PluginValidatorStandardImpl" placeholder="WFDesigner.Validator.PluginValidatorStandardImpl"/>
                                            </div>
                                        </div>
                                        <div class="control-group">
                                            <label class="control-label">Parameter Names <span class="required">*</span></label>
                                            <div class="controls ">
                                                <input type="text" id="input-plugin-paramName" class="form-control input-block-level input-max" placeholder="" validation-type="required" required-message="Parameter Name is a required field."/>
                                            </div>
                                        </div>
                                        <div class="control-group">
                                            <label class="control-label">Validator Arguments</label>
                                            <div class="controls ">
                                                <input type="text" id="input-plugin-validatorArgs" class="form-control input-block-level input-max" placeholder=""/>
                                            </div>
                                        </div>
                                        <div class="control-group">
                                            <label class="control-label">Async Allowed</label>
                                            <div class="controls ">
                                                <input type="checkbox" name="input-plugin-asyncAllowed" id="input-plugin-asyncAllowed" class="js-form-item"/>
                                            </div>
                                        </div>
                                    </div>
                                    
                                    
                                </fieldset>
                            </div>
                        </div>
                        <!-- /div .span8 -->
                    </div>
                    
                    
                    
                    <div class="js-createwith-toggle-view-slave-1 js-initial-hide">
                        <h2>Parameters</h2>

                        <div id="js-administration-pluginnew-parameters-list" class="row-fluid js-initial-hide">
                            <div class="span8">
                                <table class="table table-striped table-bordered table-addedit-form">
                                    <thead>
                                        <tr>
                                            <th><a href="#">Name</a></th>
                                            <th><a href="#">Description</a></th>
                                            <th><a href="#">Occurrence</a></th>
                                            <th><a href="#">Type</a></th>
                                            <th><a href="#">Required</a></th>
                                            <th><a href="#">Variant</a></th>
                                            <th><a href="#">Validator</a></th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        <!-- add new value -->
                                        <tr class="row-add">
                                            <td colspan="7"><a class="js-administration-pluginnew-parameters-list-addnewvalue" href="#">Add New Value</a></td>
                                        </tr>
                                    </tbody>
                                </table>
                            </div>
                        </div>

                        <div class="row-fluid">
                            <div class="span8">
                                <table class="table table-striped table-bordered">
                                    <thead>
                                        <tr>
                                            <th>Add Parameter</th>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        <tr>
                                            <td>
                                                <div class="settings-info">
                                                    <fieldset id="js-administration-pluginnew-parameters" class="form-horizontal">
                                                    <div id="div-parameter-controls">
                                                        <div class="control-group">
                                                            <label class="control-label">Parameter Name <span class="required">*</span></label>
                                                            <div class="controls ">
                                                                <input type="text" name="parameter_name" id="parameter_name" class="js-form-item form-control input-block-level input-max" placeholder="" validation-type="required" required-message="Parameter name is a required field."/>
                                                            </div>
                                                        </div>
                                                        <div class="control-group">
                                                            <div class="controls ">
                                                                <label>
                                                                <input type="checkbox" name="editable" class="js-form-item"/>
                                                                Editable
                                                                </label>
                                                            </div>
                                                        </div>
                                                        <div class="control-group">
                                                            <label class="control-label">Parameter Description <span class="required">*</span></label>
                                                            <div class="controls ">
                                                            <div>
                                                                <textarea name="parameter_description" id="parameter_description" class="js-form-item input-block-level" validation-type="required" required-message="Parameter Description is a required field."></textarea>
                                                            </div>
                                                            </div>
                                                        </div>
                                                        <div class="control-group">
                                                            <label class="control-label">Occurrence <span class="required">*</span></label>
                                                            <div class="controls ">
                                                                <input name="occurrence" type="text" id="occurrence" class="js-form-item form-control input-onethirds" placeholder="" validation-type="required,regex" required-message="Occurence is a required field." validation-regex="^[0-9]*$" regex-message="Occurence can be numeric only."/>
                                                            </div>
                                                        </div>
                                                        <div class="control-group">
                                                            <label class="control-label">Data Type <span class="required">*</span></label>
                                                            <div class="controls">
                                                                <select name="data_type" id="data_type" class="js-form-item input-onethirds">
                                                                    <option value="string">String</option>
                                                                    <option value="formfield">Form Field</option>
                                                                    <option value="multilinestring">Multiline String</option>
                                                                    <option value="formview">Form View</option>
                                                                    <option value="boolean">Boolean</option>
                                                                    <option value="formfieldxpath">Form Field XPath</option>
                                                                </select>
                                                            </div>
                                                        </div>
                                                        </div>
                                                        
                                                        <div class="settings-info">
                                                            <h2>Validators</h2>
                                                            <br />
                                                            <table class="table table-striped table-bordered table-addedit-form">
                                                                <thead>
                                                                    <tr>
                                                                        <th width="22%">Message</th>
                                                                        <th width="%">Regular Expression</th>
                                                                    </tr>
                                                                </thead>
                                                                <tbody id="js-administration-pluginnew-parameters-validators" class="js-form-item" data-inner-content="true" name="validators">

                                                                    <tr class="js-rowadd-toggle-view-slave-1 row-add">
                                                                        <td colspan="2"><a class="js-rowadd-toggle-view-master-0" href="#">Add Validator Section</a></td>
                                                                    </tr>
                                                                    <tr class="js-rowadd-toggle-view-slave-0 row-add js-initial-hide" id="row-validator-controls">
                                                                        <td>
                                                                            <input type="text" id="valiadtor-message" class="form-control input-max" placeholder="Message"/>
                                                                        </td>
                                                                        <td>
                                                                            <input type="text" id="validator-regex" class="form-control input-mid" placeholder="Regular Expression" />

                                                                            <div class="add-actions">
                                                                                <button class="js-administration-pluginnew-parameters-validators-addrow js-button-disabled js-rowadd-toggle-view-master-1 btn btn-primary js-initial-hide"><span>Add</span></button>
                                                                                <button class="js-rowadd-toggle-view-master-1 btn "><span>Cancel</span></button>
                                                                            </div>
                                                                        </td>
                                                                    </tr>

                                                                </tbody>
                                                            </table>



                                                            <div id="js-label-moreoptions" class="fewer-options">
                                                                <a href="#" class="js-container-moreoptions-trigger">More Options</a>
                                                                <div id="js-container-moreoptions" class="js-initial-hide">
                                                                    <div class="control-group">
                                                                        <label class="control-label">List of Values</label>
                                                                        <div class="controls form-textandbutton">
                                                                            <input type="text" name="list_of_values" class="js-form-item form-control input-max" placeholder="semi-colon deliniated"/>
                                                                        </div>
                                                                    </div>
                                                                    <div class="control-group">
                                                                        <label class="control-label">Default VAlue</label>
                                                                        <div class="controls form-textandbutton">
                                                                            <input type="text" name="default_value" class="js-form-item form-control input-max" placeholder=""/>
                                                                        </div>
                                                                    </div>
                                                                    <div class="control-group">
                                                                        <label class="control-label">Include Running</label>
                                                                        <div class="controls">
                                                                            <ul class="checkbox-group">
                                                                                <li>
                                                                                    <label>
                                                                                    <input type="checkbox" name="required_parameter" class="js-form-item"/>
                                                                                    Required Parameter
                                                                                    </label>
                                                                                </li>
                                                                                <li>
                                                                                    <label>
                                                                                    <input type="checkbox" name="variant" class="js-form-item"/>
                                                                                    Variant
                                                                                    </label>
                                                                                </li>
                                                                            </ul>
                                                                        </div>
                                                                    </div>
                                                                </div>
                                                            </div>
                                                        </div>
                                                        <div class="js-administration-pluginnew-parameters-action-addrow form-actions top-line">
                                                            <button class="js-form-button-add js-administration-newplugin-checkparametersvisibility btn btn-primary"><span>Add</span></button>
                                                            <button class="js-form-button-cancel js-administration-newplugin-checkparametersvisibility btn"><span>Cancel</span></button>
                                                        </div>
                                                        <div class="js-administration-pluginnew-parameters-action-editrow form-actions top-line">
                                                            <button class="js-form-button-update js-administration-newplugin-checkparametersvisibility btn btn-primary"><span>Update</span></button>
                                                            <button class="js-form-button-cancel js-administration-newplugin-checkparametersvisibility btn"><span>Cancel</span></button>
                                                        </div>
                                                    </fieldset>
                                                </div>
                                            </td>
                                        </tr>
                                    </tbody>
                                </table>
                            </div>
                        </div>
                    </div>
                    
                    
                    
                    <div id="js-administration-newplugin-finalsavecancel" class="row-fluid">
                        <div class="span8">
                             <div class="control-group">
                                <span id="js-notice-message"></span>
                            </div>
                            <div class="form-actions top-line">
                                <button id="js-debug-submitdata" class="btn btn-primary"><span>Save</span></button>
                                <button id="btn-plugin-cancel" class="btn"><span>Cancel</span></button>
                            </div>
                        </div>
                    </div>
                </form>
				
        <script src="http://ajax.googleapis.com/ajax/libs/jquery/1.11.1/jquery.min.js"></script>
        <script>
            if (!window.jQuery) {
                console.error("jQuery CDN is down.")
                document.write('<script src="<%=Url.Content("~/Content/assets/js/jquery.min.js") %>"><\/script>');
            }
        </script>
        <script src="http://maxcdn.bootstrapcdn.com/bootstrap/3.2.0/js/bootstrap.min.js"></script>
        <script>
            if (!$.fn.modal) {
                console.error("Bootstrap CDN is down.")
                document.write('<script src="<%=Url.Content("~/Content/assets/js/bootstrap.min.js") %>"><\/script>');
            }
        </script>
        <script src="<%=Url.Content("~/Content/assets/js/kendo.all.min.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/wslib_master.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/wsplugin_master.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/ws_global_initialization_administration.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/ws_common.js") %>"></script>
        <script>
            (function () {
                wsLib_toggleViews("rowadd", 2, "default");



                var parametersData = [];
				var verificationRowAddTimer;

                var $finalSaveCancelContainer = $('#js-administration-newplugin-finalsavecancel');



                function createValidatorsTableRowHTML(whichPlugData) {
                    var currentRowHTML = '';

                    currentRowHTML += '<tr class="js-administration-pluginnew-parameters-validators-item row-add">';
                    currentRowHTML += '<td>';
                    currentRowHTML += '<div class="js-administration-pluginnew-parameters-validators-display">' + whichPlugData.message + '</div>';
                    currentRowHTML += '<div class="js-administration-pluginnew-parameters-validators-form js-initial-hide" style="display: none;">';
                    currentRowHTML += '<input type="text" value="' + whichPlugData.message + '" class="input-max">';
                    currentRowHTML += '</div>';
                    currentRowHTML += '</td>';
                    currentRowHTML += '<td>';
                    currentRowHTML += '<div class="pull-right">';
                    currentRowHTML += '<div>';
                    currentRowHTML += '<a class="js-administration-pluginnew-parameters-validators-edittoggle" href="#"><i class="icon-edit">&nbsp;&nbsp;</i></a>';
                    currentRowHTML += '<a class="js-administration-pluginnew-parameters-validators-deleterow" href="#"><i class="icon-trash">&nbsp;&nbsp;</i></a>';
                    currentRowHTML += '</div>';
                    currentRowHTML += '<div class="update-actions js-initial-hide" style="display: none;">';
                    currentRowHTML += '<button class="js-administration-pluginnew-parameters-validators-editsave js-administration-pluginnew-parameters-validators-edittoggle btn btn-primary"><span>Save</span></button>';
                    currentRowHTML += '<button class="js-administration-pluginnew-parameters-validators-edittoggle btn"><span>Cancel</span></button>';
                    currentRowHTML += '</div>';
                    currentRowHTML += '</div>';
                    currentRowHTML += '<div class="js-administration-pluginnew-parameters-validators-display">' + whichPlugData.regularExpression + '</div>';
                    currentRowHTML += '<div class="js-administration-pluginnew-parameters-validators-form js-initial-hide" style="display: none;">';
                    currentRowHTML += '<input type="text" value="' + whichPlugData.regularExpression + '" class="input-mid">';
                    currentRowHTML += '</div>';
                    currentRowHTML += '</td>';
                    currentRowHTML += '</tr>';

                    var $currentRowHTML = $(currentRowHTML);

                    $currentRowHTML.data('validator-content', $.extend({}, {}, whichPlugData));

                    return $currentRowHTML;
                }



                function updateParametersData(isSaveButton) {
                    parametersData = [];

                    $parameterList.find('table')
                                  .children('tbody')
                                  .find('.js-administration-newplugin-parameters-datarow')
                                  .each(function () {
                                      parametersData.push($(this).data('parameter-content'));
                                  });

                    $finalSaveCancelContainer.fadeIn();

                    if ($parameterList.is(':visible')) {
                        $finalSaveCancelContainer.find('.form-actions').removeClass('top-line');
                    }
                    else {
                        $finalSaveCancelContainer.find('.form-actions').addClass('top-line');
                    }
                }



                function defaultMoreOptions() {
                    var $moreOptionsTrigger = $('#js-label-moreoptions').find('.js-container-moreoptions-trigger');

                    if ($moreOptionsTrigger.text() === 'Less Options') {
                        $moreOptionsTrigger.trigger('click');
                    }
                }



                var $pluginNewParametersValidators = $('#js-administration-pluginnew-parameters-validators');

                $pluginNewParametersValidators.off('click.editToggle')
                                              .off('click.editSave')
                                              .off('click.deleteRow')
                                              .off('click.addRow')
                                              .on('click.editToggle', '.js-administration-pluginnew-parameters-validators-edittoggle', function (event) {
                                                  event.preventDefault();
                                                  
                                                  var $currentParameterItem = $(this).closest('.js-administration-pluginnew-parameters-validators-item');

                                                  $currentParameterItem.children('td').find('.js-administration-pluginnew-parameters-validators-edittoggle').closest('div').toggle();

                                                  $currentParameterItem.find('.js-administration-pluginnew-parameters-validators-display').toggle();
                                                  $currentParameterItem.find('.js-administration-pluginnew-parameters-validators-form').toggle();
                                              }).on('click.editSave', '.js-administration-pluginnew-parameters-validators-editsave', function (event) {
                                                  event.preventDefault();
                                                  
                                                  var updatedPlugData = {};
                                                  var formType = ['message', 'regularExpression'];

                                                  $(this).closest('tr').find('.js-administration-pluginnew-parameters-validators-form').find('input').each(function (index) {
                                                      var $currentInput = $(this);
                                                      var $currentDisplay = $currentInput.closest('.js-administration-pluginnew-parameters-validators-form').siblings('.js-administration-pluginnew-parameters-validators-display');

                                                      if ($currentInput.attr('type') === 'checkbox') {
                                                          $currentDisplay.text($currentInput.prop('checked'));

                                                          updatedPlugData[formType[index]] = $currentInput.prop('checked');
                                                      }
                                                      else {
                                                          $currentDisplay.text($currentInput.val());

                                                          updatedPlugData[formType[index]] = $currentInput.val();
                                                      }
                                                  });

                                                  $(this).closest('.js-administration-pluginnew-parameters-validators-item').data('validator-content', $.extend({}, {}, updatedPlugData));

                                              }).on('click.deleteRow', '.js-administration-pluginnew-parameters-validators-deleterow', function (event) {
                                                  event.preventDefault();
                                                  
                                                  $(this).closest('tr').remove();
                                              }).on('click.addRow', '.js-administration-pluginnew-parameters-validators-addrow.js-button-enabled', function (event) {
                                                  event.preventDefault();
                                                  
                                                  var currentRowData = [];

                                                  $(this).fadeOut()
																   .closest('.row-add')
																   .find('input')
																   .each(function(index) {
                                                      var $currentInput = $(this);

                                                      if ($currentInput.attr('type') === 'checkbox') {
                                                          currentRowData.push({
                                                              index: index,
                                                              data: $currentInput.prop('checked')
                                                          });

                                                          $currentInput.prop('checked', false);
                                                      }
                                                      else {
                                                          currentRowData.push({
                                                              index: index,
                                                              data: $currentInput.val()
                                                          });

                                                          $currentInput.val('');
                                                      }
                                                  });

                                                  var currentPlugData = {
                                                      message: currentRowData[0].data,
                                                      regularExpression: currentRowData[1].data
                                                  };

                                                  var $generatedRowHTML = createValidatorsTableRowHTML(currentPlugData);

                                                  $pluginNewParametersValidators.find('.row-add').first().before($generatedRowHTML);
                                              }).on('keyup.checkFormItems', 'tr.row-add input', function() {
														var $closestRowAddSubmitForm = $(this).closest('tr.row-add');
														
														clearTimeout(verificationRowAddTimer);
														
														verificationRowAddTimer = setTimeout(function() {
															var isFullyFilled = true;
															
															$closestRowAddSubmitForm.find('input').each(function() {
																if($(this).val() == "") {
																	isFullyFilled = false;
																}
															});
															
															if(isFullyFilled) {
															    $closestRowAddSubmitForm.find('.js-administration-pluginnew-parameters-validators-addrow, .js-administration-pluginnew-parameters-validators-editsave')
																						.fadeIn()
																						.removeClass('js-button-disabled')
																						.addClass('js-button-enabled');
															}
															else {
															    $closestRowAddSubmitForm.find('.js-administration-pluginnew-parameters-validators-addrow, .js-administration-pluginnew-parameters-validators-editsave')
																						.fadeOut()
																						.removeClass('js-button-enabled')
																						.addClass('js-button-disabled');
															}
														}, 500);
													});





                wsLib_toggleViews("createwith", 2, "radio", "no", 200);

                var $parameters = $('#js-administration-pluginnew-parameters');
                var $parameterList = $('#js-administration-pluginnew-parameters-list');



                function checkFormType($whichFormItem, possibleResults) {
                    if ($whichFormItem.data('inner-content')) {
                        return possibleResults.innerContent;
                    }
                    else if ($whichFormItem.attr('type') === 'checkbox') {
                        return possibleResults.checkbox;
                    }
                    else {
                        return possibleResults.defaultItem;
                    }
                }



                function createParametersTableRowHTML() {
                    var parameterData = {};

                    $parameters.find('.js-form-item').each(function () {
                        var $this = $(this);

                        parameterData[$this.attr('name')] = checkFormType($this, {
                            innerContent: (function () {
                                var formData = [];

                                $this.find('tr.js-administration-pluginnew-parameters-validators-item').each(function (index) {
                                    formData.push($(this).data('validator-content'));
                                });

                                return formData;
                            })(),
                            checkbox: $this.prop('checked'),
                            defaultItem: $this.val()
                        });
                    });

                    var currentParametersRowHTML = '<tr class="js-administration-newplugin-parameters-datarow">';

                    currentParametersRowHTML += '<td>' + parameterData['parameter_name'] + '</td>';
                    currentParametersRowHTML += '<td>' + parameterData['parameter_description'] + '</td>';
                    currentParametersRowHTML += '<td>' + parameterData['occurrence'] + '</td>';
                    currentParametersRowHTML += '<td>' + parameterData['data_type'] + '</td>';
                    currentParametersRowHTML += '<td>' + parameterData['required_parameter'] + '</td>';
                    currentParametersRowHTML += '<td>' + parameterData['variant'] + '</td>';
                    currentParametersRowHTML += '<td>';
                    currentParametersRowHTML += 'Validator';
                    currentParametersRowHTML += '<div class="pull-right"><a href="#"><i class="js-administration-newplugin-parameters-datarow-edit icon-edit"></i></a><a href="#"><i class="js-administration-newplugin-parameters-datarow-delete icon-trash"></i></a></div>';
                    currentParametersRowHTML += '</td>';

                    currentParametersRowHTML += '</tr>';

                    var $currentParametersRow = $(currentParametersRowHTML);

                    $currentParametersRow.data('parameter-content', $.extend({}, {}, parameterData));

                    return $currentParametersRow;
                }



                $parameters.on('click.addParameter', '.js-administration-pluginnew-parameters-action-addrow .js-form-button-add', function (event) {
                    event.preventDefault();

                    if (!validateClientSide('div-parameter-controls')) {
                        event.stopImmediatePropagation();
                        return false;
                    }

                    var $currentAddRowHTML = createParametersTableRowHTML();

                    $parameterList.find('table').children('tbody').children('.row-add').before($currentAddRowHTML);
                }).on('click.editParameter', '.js-administration-pluginnew-parameters-action-editrow .js-form-button-update', function (event) {
                    event.preventDefault();

                    if (!validateClientSide('div-parameter-controls')) {
                        event.stopImmediatePropagation();
                        return false;
                    }

                    var $currentEditRowHTML = createParametersTableRowHTML();

                    $parameterList.find('table')
                                  .children('tbody')
                                  .find('.js-form-edit-active')
                                  .replaceWith($currentEditRowHTML);
                }).on('click.clearParametersFields', '.js-form-button-add, .js-form-button-update, .js-form-button-cancel', function (event, isAutoClear) {
                    event.preventDefault();

                    $parameters.closest('table').closest('.row-fluid').slideUp(function () {
                        $parameters.removeClass('js-form-editmode').find('.js-form-item').each(function () {
                            var $this = $(this);

                            $this.removeClass('input-validation-error');
                            $('#' + $this.attr('span-id')).remove();

                            // do not clear value for select element.
                            if ($this.prop('type') == 'select-one') {
                                $this.find('option:eq(0)').attr('selected', true);
                                return;
                            }

                            var removalTask = checkFormType($this, {
                                innerContent: function () {
                                    $this.find('tr.js-administration-pluginnew-parameters-validators-item').remove();
                                },
                                checkbox: function () {
                                    $this.prop('checked', false);
                                },
                                defaultItem: function () {
                                    $this.val('');
                                }
                            });



                            removalTask();
                        });

                        $pluginNewParametersValidators.find('.row-add').find('input').each(function () {
                            $(this).val('');
                        });

                        $parameterList.fadeIn()
                                      .find('table')
                                      .children('tbody')
                                      .find('.js-form-edit-active')
                                      .removeClass('js-form-edit-active');

                        if (!isAutoClear) {
                            updateParametersData();
                        }
                    });
                });



                $parameterList.find('table')
                              .children('tbody')
                              .on('click.editDataRow', '.js-administration-newplugin-parameters-datarow .js-administration-newplugin-parameters-datarow-edit', function (event) {
                                  event.preventDefault();

                                  var $targetRow = $(this).closest('.js-administration-newplugin-parameters-datarow');

                                  var targetRowData = $targetRow.data('parameter-content');

                                  $finalSaveCancelContainer.fadeOut();

                                  $parameters.find('.js-form-item').each(function () {
                                      var $this = $(this);

                                      var editTask = checkFormType($this, {
                                          innerContent: function () {
                                              var $validatorsHTML = [];

                                              for (var i = 0; i < targetRowData.validators.length; i++) {
                                                  $validatorsHTML.push(createValidatorsTableRowHTML(targetRowData.validators[i]));
                                              }

                                              $pluginNewParametersValidators.find('.row-add').first().before($validatorsHTML);
                                          },
                                          checkbox: function () {
                                              $this.prop('checked', targetRowData[$this.attr('name')]);
                                          },
                                          defaultItem: function () {
                                              $this.val(targetRowData[$this.attr('name')]);
                                          }
                                      });

                                      editTask();
                                  });

                                  $parameterList.fadeOut(function () {
                                      defaultMoreOptions();

                                      $parameters.addClass('js-form-editmode')
                                   .closest('table')
                                   .closest('.row-fluid')
                                   .slideDown();

                                      $targetRow.addClass('js-form-edit-active');
                                  });
                              }).on('click.deleteDataRow', '.js-administration-newplugin-parameters-datarow .js-administration-newplugin-parameters-datarow-delete', function (event) {
                                  event.preventDefault();

                                  $(this).closest('.js-administration-newplugin-parameters-datarow').fadeOut(function () {
                                      $(this).remove();

                                      updateParametersData();
                                  });
                              }).on('click.addNewValue', '.js-administration-pluginnew-parameters-list-addnewvalue', function (event) {
                                  event.preventDefault();

                                  $finalSaveCancelContainer.fadeOut();

                                  defaultMoreOptions();

                                  $parameters.closest('table').closest('.row-fluid').slideDown();
                              });



                $('.js-administration-newplugin-checkparametersvisibility').on('click', function () {
                    updateParametersData();

                    if ($(this).data('finalsavecancel-alwaysshow')) {
                        if (parametersData.length > 0) {
                            $parameters.find('.js-form-button-cancel')
                                       .first()
                                       .trigger('click.clearParametersFields', true);
                        }

                        $finalSaveCancelContainer.fadeIn()
                                                 .find('.form-actions')
                                                 .addClass('top-line');
                    }
                    else if (parametersData.length === 0 && $parameters.closest('table').closest('.row-fluid').is(':visible')) {
                        $finalSaveCancelContainer.stop().fadeOut();
                    }
                });



                $('#js-debug-submitdata').on('click', function (event) {
                    event.preventDefault();

                    updateParametersData(true);

                    wsLib_console(parametersData);
                });
            })();

            $(document).ready(function () {
                ws_showProgressBar();
                ws_initializeWebApp('/admin/getallwebapp', $('#select-webapp'), function () {
                    ws_hideProgressBar();
                });

                $("#select-webapp").change(function () {
                    SetupLinks();
                });

                $('#js-debug-submitdata').on("click", function () {

                    if (!validateClientSide('div-plugin-name')) {
                        return false;
                    }

                    var validate = true;
                    var option = $('[name="TEMP_create_with"]:checked').val();
                    var xml = '';
                    if (option == 'xml') {
                        validate = validateClientSide('div-plugin-xml');
                    }
                    else if (option == 'designer') {
                        validate = validateClientSide('div-plugin-controls');
                    }

                    if (!validate) {
                        return false;
                    }

                    ws_showProgressBar();
                    savePlugin();
                });

                $('#btn-plugin-cancel').on('click', function () {
                    var webapp = $('#select-webapp').val();
                    window.location.href = "plugins?server=" + webapp;
                    return false;
                });
            });

            function savePlugin() {

                // call api - /serverconfig/addplugin
                if (!validateParameterList()) {
                    ws_hideProgressBar();
                    return false;
                }

                var webapp = $('#select-webapp option:selected').val();
                var pluginData = getPluginData();
                $.ajax({
                    type: 'POST',
                    url: '/serverconfig/addplugin',
                    data: { url: webapp, metadata: pluginData.xml, name: pluginData.name },
                    success: function (data) {
                        onSuccess(data, null);

                    },
                    error: function (xhr, status, error) {
                        onError(xhr, status, error);

                    }
                });
            }

            function onSuccess(data, callbackData) {
                var webapp = $('#select-webapp').val();
                window.location.href = "plugins?server=" + webapp;
                ws_hideProgressBar();
            }

            function onError(xhr, status, error) {
                if (xhr.statusText != null && xhr.statusText != undefined) {
                    wsLib_createBootstrapAlert($('#js-notice-message'), xhr.statusText, "error", true);
                }
                else {
                    wsLib_createBootstrapAlert($('#js-notice-message'), xhr.responseText, "error", true);
                }

                ws_hideProgressBar();
            }

            function getPluginData() {

                var option = $('[name="TEMP_create_with"]:checked').val();
                var xml = '';
                if (option == 'xml') {
                    xml = $('#input-plugin-xml').val();
                }
                else if (option == 'designer') {
                    xml = createPluginXml();
                }

                return { name: $('#input-plugin-name').val(), xml: xml };
            }

            function createPluginXml() {

                var $parameterList = $('#js-administration-pluginnew-parameters-list');

                var variants = '';
                var parameterXml = '<Parameters>';
                $.each($parameterList.find('table tbody tr.js-administration-newplugin-parameters-datarow'), function (key, value) {
                    var targetRowData = $(value).data('parameter-content');

                    if (targetRowData.variant) {
                        variants += targetRowData.parameter_name + ',';
                    }

                    parameterXml += '<Parameter Occurence="' + targetRowData.occurrence + '" Description="' + targetRowData.parameter_description + '" Datatype="' + targetRowData.data_type + '" Value="' + targetRowData.default_value + '" Name="' + targetRowData.parameter_name + '" ListOfValues="' + targetRowData.list_of_values + '" EditableName="' + targetRowData.editable + '" Required="' + targetRowData.required_parameter + '">';

                    parameterXml += '<Validators>';
                    for (var i = 0; i < targetRowData.validators.length; i++) {
                        var validator = targetRowData.validators[i];
                        parameterXml += '<Validator Message="' + validator.message + '" RegularExpression="' + ws_encodeSpecialHTMLChars(validator.regularExpression) + '" />';
                    }

                    parameterXml += '</Validators></Parameter>'

                });
                parameterXml += '</Parameters>';

                var name = $('#input-plugin-name').val();
                var desc = $('#input-plugin-description').val();
                var assembly = $('#input-plugin-assembly').val();
                var pluginClass = $('#input-plugin-class').val();
                var validator = $('#input-plugin-validator').val();
                var validatorArgs = $('#input-plugin-validatorArgs').val();
                var paramName = $('#input-plugin-paramName').val();
                var asyncAllowed = $('#input-plugin-asyncAllowed').prop('checked');

                var xml = '<Plugin Name="' + name + '" Description="' + desc + '" Assembly="' + assembly + '" Class="' + pluginClass + '" ValidatorClass="' + validator + '" ParmNames="' + paramName + '" ValidatorArguments="' + validatorArgs + '" Variants="' + variants.slice(0, -1) + '"';

                if (asyncAllowed) {
                    xml += ' ASyncAllowed="true" >';
                }
                else {
                    xml += ' >';
                }

                xml += parameterXml;
                xml += '</Plugin>';

                return xml;
            }

            function validateParameterList() {

                var option = $('[name="TEMP_create_with"]:checked').val();
                var xml = '';
                if (option != 'designer') {
                    return true;
                }

                var paramNameList = $('#input-plugin-paramName').val().split(',');
                var status = true;

                if (paramNameList.length > 0) {
                    var $parameterList = $('#js-administration-pluginnew-parameters-list');
                    $.each(paramNameList, function (key, value) {

                        var row = $parameterList.find('table tbody tr.js-administration-newplugin-parameters-datarow').filter(function () {
                            var targetRowData = $(this).data('parameter-content');
                            return (targetRowData.parameter_name == value);
                        });

                        if (row.length == 0) {
                            wsLib_createBootstrapAlert($('#js-notice-message'), 'The parameter name "' + value + '" could not be found in the list of parameters. Either add this parameter name to the parameter list, or remove it from the parameter names.', "error", true);
                            status = false;
                            return false;
                        }
                    });
                }

                return status;
            }
        </script>
</asp:Content>
