﻿<%@ Page Title="Edit Form Control" Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage" %>

<asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
	Edit Form Control
</asp:Content>

<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
<div class="row-fluid">
                    <div class="span12">
                        <ul id="breadcrumbs">
                            <li><a href="/Home">Administration</a> &rsaquo;</li>
                            <li><a href="/ServerConfig">Workflow Design Configuration</a> &rsaquo;</li>
                            <li><a href="/ServerConfig/FormControls">Form Controls</a> &rsaquo;</li>
                            <li>Edit Form Control</li>
                            <li class="related-links">
                                <ul>
                                    <li class="related-label">Related Tasks:</li>
                                    <li class="link"><a href="/ServerConfig/FormControls">Form Controls</a></li>
                                    <li class="link"><a href="/ServerConfig/Index">Workflow Design Configuration</a></li>
                                    <li class="link"><a href="/ServerConfig/Plugins">Plugins</a></li>
                                    <li class="link"><a href="/ServerConfig/ParticipantResolvers">Participant Resolvers</a></li>
                                </ul>
                            </li>
                        </ul>
                        <ul id="secnav">
                            <li class="active">
                                <h1>Edit Form Control</h1>
                            </li>
                        </ul>
                    </div>
                </div>
                <div class="row-fluid" id="validate-section">
                    <div class="span8">
                        <div class="settings-info">
                            <form>
                                <fieldset class="form-horizontal">
                                    <div class="control-group">
                                        <label class="control-label">Name <span class="required">*</span></label>
                                        <div class="controls">
                                            <input readonly type="text" id="txtControlName" class="form-control input-block-level input-max" placeholder=""/>
                                        </div>
                                    </div>
                                    <div class="control-group">
                                        <label class="control-label">Create with</label>
                                        <div class="controls">
                                            <ul class="checkbox-group inline-list">
                                                <li>
                                                    <label>
                                                    <input type="radio" class="js-administration-topline-toggle js-createwith-toggle-view-master-0" data-administration-topline="true" name="TEMP_RENAMETHIS_create_with" checked="checked"/>
                                                    <span>XML</span>
                                                    </label>
                                                </li>
                                                <li>
                                                    <label>
                                                    <input type="radio" class="js-administration-topline-toggle js-createwith-toggle-view-master-1" data-administration-topline="false" name="TEMP_RENAMETHIS_create_with"/>
                                                    <span>Form Control Designer</span>
                                                    </label>
                                                </li>
                                            </ul>
                                        </div>
                                    </div>
                                    <!--if xml choses-->
                                    <div class="control-group js-createwith-toggle-view-slave-0">
                                        <label class="control-label">XML <span class="required">*</span></label>
                                        <div class="controls ">
                                            <textarea id="txtXML" validation-type="required" required-message="Please enter the Form Control XML." class="js-transform-formexpand input-block-level" rows="5"></textarea>
                                        </div>
                                    </div>
                                    <!--if form control designer chosen-->
                                    <div class="control-group js-createwith-toggle-view-slave-1 js-initial-hide">
                                        <label class="control-label">Class ID <span class="required">*</span></label>
                                        <div class="controls ">
                                            <input readonly type="text" id="txtClsId" class="form-control input-block-level input-max" placeholder=""/>
                                            <input type="hidden" id="hiddenclsid" value="" />
                                        </div>
                                    </div>
                                </fieldset>
                            </form>
                        </div>
                    </div>
                    <!-- /div .span8 -->
                </div>
                <div class="row-fluid js-createwith-toggle-view-slave-1 js-initial-hide">
                    <div class="span8">
                        <h2>Variants</h2>
                        <table class="table table-striped table-bordered table-addedit-form">
                            <thead>
                                <tr>
                                    <th><a href="#">Name</a></th>
                                </tr>
                            </thead>
                            <tbody id="js-administration-formcontrol-variants">
                                <tr class="js-rowadd-toggle-view-slave-1 row-add">
                                    <td colspan="2"><a class="js-rowadd-toggle-view-master-0" href="#">Add Variant</a></td>
                                </tr>
                                <tr class="js-rowadd-toggle-view-slave-0 row-add js-initial-hide">
                                    <td>
                                        <div class="controls">
                                            <input type="text" class="form-control input-twothirds" placeholder="DataSourceName"/>
                                        </div>
                                        <div class="add-actions">
                                            <button class="js-administration-formcontrol-variants-addrow js-rowadd-toggle-view-master-1 btn btn-primary"><span>Add</span></button>
                                            <button class="js-rowadd-toggle-view-master-1 btn"><span>Cancel</span></button>
                                        </div>
                                    </td>
                                </tr>
                            </tbody>
                        </table>
                    </div>
                </div>
                <div class="row-fluid">
                    <div class="span8">
                        <fieldset class="form-horizontal">
                            <div class="js-administration-topline-target form-actions top-line">
                            <div class="control-group">
                                        <span id="js-notice-message"></span>
                                    </div>
                                <button type="submit" id="btnSave" class="btn btn-primary"><span>Save</span></button>
                                <button class="btn" id="btnCancel"><span>Cancel</span></button>
                            </div>
                        </fieldset>
                    </div>
                </div>
				<script src="http://ajax.googleapis.com/ajax/libs/jquery/1.11.1/jquery.min.js"></script>
        <script>
            if (!window.jQuery) {
                console.error("jQuery CDN is down.")
                document.write('<script src="<%=Url.Content("~/Content/assets/js/jquery.min.js") %>"><\/script>');
            }
        </script>
        <script src="http://maxcdn.bootstrapcdn.com/bootstrap/3.2.0/js/bootstrap.min.js"></script>
        <script>
            if (!$.fn.modal) {
                console.error("Bootstrap CDN is down.")
                document.write('<script src="<%=Url.Content("~/Content/assets/js/bootstrap.min.js") %>"><\/script>');
            }
        </script>
        <script src="<%=Url.Content("~/Content/assets/js/kendo.all.min.js")%>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/wslib_master.js")%>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/wsplugin_master.js")%>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/ws_global_initialization_administration.js")%>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/ws_common.js")%>"></script>
        <script>
            (function () {
                wsLib_toggleViews("createwith", 2, "radio", "no", 200);
                wsLib_toggleViews("rowadd", 2, "default");



                $('input.js-administration-topline-toggle').on('click.toggleTopline', function () {
                    if ($(this).data('administration-topline')) {
                        $('div.js-administration-topline-target').addClass('top-line');
                    }
                    else {
                        $('div.js-administration-topline-target').removeClass('top-line');
                    }
                });



                var $formControlVariants = $('#js-administration-formcontrol-variants');

                $formControlVariants.off('click.editToggle')
                                              .off('click.editSave')
                                              .off('click.deleteRow')
                                              .off('click.addRow')
                                              .on('click.editToggle', '.js-administration-formcontrol-variants-edittoggle', function (event) {
                                                  event.preventDefault();

                                                  var $currentParameterItem = $(this).closest('.js-administration-formcontrol-variants-item');
                                                  if ($(event.target).text() == "Cancel") {
                                                      $currentParameterItem.children('td').find('.js-administration-formcontrol-variants-edittoggle').closest('div').toggle();
                                                      var txtName = $currentParameterItem.find('input[type="text"]:eq(0)');
                                                      $(txtName).val(($currentParameterItem.find('.js-administration-formcontrol-variants-display:eq(0)')).html());
                                                      $currentParameterItem.find('.js-administration-formcontrol-variants-display').toggle();
                                                      $currentParameterItem.find('.js-administration-formcontrol-variants-form').toggle();
                                                      event.stopImmediatePropagation();
                                                      return false;
                                                  }

                                                  var txtName = $currentParameterItem.find('input[type="text"]:eq(0)');
                                                  if (txtName.is(':visible')) {
                                                      if ($.trim(txtName.val()).length > 0) {
                                                          $currentParameterItem.children('td').find('.js-administration-formcontrol-variants-edittoggle').closest('div').toggle();
                                                          $currentParameterItem.find('.js-administration-formcontrol-variants-display').toggle();
                                                          $currentParameterItem.find('.js-administration-formcontrol-variants-form').toggle();
                                                      }
                                                      else {
                                                          event.stopImmediatePropagation();
                                                          return false;
                                                      }
                                                  }
                                                  else {
                                                      $currentParameterItem.children('td').find('.js-administration-formcontrol-variants-edittoggle').closest('div').toggle();
                                                      $currentParameterItem.find('.js-administration-formcontrol-variants-display').toggle();
                                                      $currentParameterItem.find('.js-administration-formcontrol-variants-form').toggle();
                                                  }
                                              }).on('click.editSave', '.js-administration-formcontrol-variants-editsave', function (event) {
                                                  event.preventDefault();

                                                  $(this).closest('tr').find('.js-administration-formcontrol-variants-form').find('input').each(function () {
                                                      var $currentInput = $(this);
                                                      var $currentDisplay = $currentInput.closest('.js-administration-formcontrol-variants-form').siblings('.js-administration-formcontrol-variants-display');

                                                      if ($currentInput.attr('type') === 'checkbox') {
                                                          $currentDisplay.text($currentInput.prop('checked'));
                                                      }
                                                      else {
                                                          $currentDisplay.text($currentInput.val());
                                                      }
                                                      
                                                      UNSAVEDDATA = true;
                                                  });
                                              }).on('click.deleteRow', '.js-administration-formcontrol-variants-deleterow', function (event) {
                                                  event.preventDefault();
                                                  UNSAVEDDATA = true;
                                                  $(this).closest('tr').remove();
                                              }).on('click.addRow', '.js-administration-formcontrol-variants-addrow', function (event) {
                                                  event.preventDefault();

                                                  var currentRowHTML = '';
                                                  var currentRowData = [];

                                                  $(this).closest('.row-add').find('input').each(function (index) {
                                                      var $currentInput = $(this);

                                                      if ($currentInput.attr('type') === 'checkbox') {
                                                          currentRowData.push({
                                                              index: index,
                                                              data: $currentInput.prop('checked')
                                                          });

                                                          $currentInput.prop('checked', false);
                                                      }
                                                      else {
                                                          currentRowData.push({
                                                              index: index,
                                                              data: $.trim($currentInput.val())
                                                          });

                                                          $currentInput.val('');
                                                      }
                                                  });

                                                  if (currentRowData[0].data != undefined && $.trim(currentRowData[0].data).length > 0) {
                                                      var currentPlugData = {
                                                          name: currentRowData[0].data
                                                      };

                                                      currentRowHTML += '<tr class="js-administration-formcontrol-variants-item">';
                                                      currentRowHTML += '<td>';
                                                      currentRowHTML += '<div class="pull-right">';
                                                      currentRowHTML += '<div>';
                                                      currentRowHTML += '<a class="js-administration-formcontrol-variants-edittoggle" href="#"><i class="icon-edit">&nbsp;&nbsp;</i></a>';
                                                      currentRowHTML += '<a class="js-administration-formcontrol-variants-deleterow" href="#"><i class="icon-trash">&nbsp;&nbsp;</i></a>';
                                                      currentRowHTML += '</div>';
                                                      currentRowHTML += '<div class="update-actions js-initial-hide" style="display: none;">';
                                                      currentRowHTML += '<button class="js-administration-formcontrol-variants-editsave js-administration-formcontrol-variants-edittoggle btn btn-primary"><span>Save</span></button>';
                                                      currentRowHTML += '<button class="js-administration-formcontrol-variants-edittoggle btn"><span>Cancel</span></button>';
                                                      currentRowHTML += '</div>';
                                                      currentRowHTML += '</div>';
                                                      currentRowHTML += '<div class="js-administration-formcontrol-variants-display">' + currentPlugData.name + '</div>';
                                                      currentRowHTML += '<div class="js-administration-formcontrol-variants-form js-initial-hide" style="display: none;">';
                                                      currentRowHTML += '<input type="text" class="input-twothirds" value="' + currentPlugData.name + '">';
                                                      currentRowHTML += '</div>';
                                                      currentRowHTML += '</td>';
                                                      currentRowHTML += '</tr>';

                                                      $formControlVariants.find('.row-add').first().before(currentRowHTML);
                                                      UNSAVEDDATA = true;
                                                  }
                                              });
            })();
        </script>
         <script>
             var UNSAVEDDATA = false;
             var UNSAVEDDATATXT = false;
             var XML = undefined;
                var theID = undefined;
                $(document).ready(function () {
                    ws_showProgressBar();
                    ws_initializeWebApp("/admin/GetAllWebApp", $('#select-webapp'), OnLoad);

                    $('#txtXML').change(function () {
                        var $this = $(this);
                        if (XML == undefined) {
                            UNSAVEDDATATXT = true;
                        }
                        else if (XML != $this.val()) {
                            UNSAVEDDATATXT = true;
                        }
                        else {
                            UNSAVEDDATATXT = false;
                        }
                    });

                    $('#select-webapp').change(function () {
                        wsLib_destroyBootstrapAlert($('#js-notice-message'));
                        if (UNSAVEDDATA == true || UNSAVEDDATATXT == true) {
                            if (window.confirm('Unsaved data will be lost. Do you want to continue ?') == false) {

                                return false;
                            }
                        }

                        SetupLinks();
                    });



                    $('#btnSave').click(function () {
                        wsLib_destroyBootstrapAlert($('#js-notice-message'));
                        SaveData();
                        return false;
                    });

                    $("#btnCancel").click(function () {
                        wsLib_destroyBootstrapAlert($('#js-notice-message'));
                        var isDirty = false;
                        var isXML = ($('.js-createwith-toggle-view-slave-0').css('display') == "block");
                        if (isXML == true) {
                            isDirty = UNSAVEDDATATXT;
                        }
                        else {
                            isDirty = UNSAVEDDATA;
                        }


                        if (isDirty == true) {
                            if (window.confirm('Unsaved data will be lost. Do you want to continue ?') == true) {
                                window.location.href = '/ServerConfig/FormControls?server=' + $('#select-webapp').val();
                            }
                        }
                        else {
                            window.location.href = '/ServerConfig/FormControls?server=' + $('#select-webapp').val();
                        }

                        return false;
                    });
                });

                function OnLoad() {
                    LoadData();
                    return false;
                }

                function LoadData() {
                    ws_showProgressBar();
                    $('tr.js-administration-formcontrol-variants-item').remove();
                    ws_ajaxCall("/ServerConfig/GetInfoPathControl", { server: $('#select-webapp').val(),
                        name: wsPlugin_getURLParameter('name')
                    }, CallBackSuccess, CallBackFailure, null);
                    return false;
                }

                function CallBackFailure(xhr, status, error, callbackdata) {
                    ws_hideProgressBar();
                    if (xhr.statusText != null && xhr.statusText != undefined) {
                        wsLib_createBootstrapAlert($('#js-notice-message'), xhr.statusText, "error", true);
                    }
                }

                function CallBackSuccess(data) {
                    if (data != null && data != undefined && data.length > 0) {
                        if (data[0].MetaData != null && data[0].MetaData != undefined) {
                            theID = data[0].ID;
                            var xmlDoc = loadXMLString(data[0].MetaData);
                            if (xmlDoc != null && xmlDoc != undefined) {
                                var $rootElement = $(xmlDoc).find('Control');
                                $('#txtControlName').val($rootElement.attr('Name'));
                                $('#txtClsId').val($rootElement.attr('ClsId'));
                                $('#hiddenclsid').val($rootElement.attr('ClsId'));
                                $('#txtXML').val(data[0].MetaData);
                                XML = data[0].MetaData;
                                $.each($rootElement.attr("Variants").split(","), function (index, value) {
                                    if ($.trim(value).length > 0) {
                                        var $participantResolverParameters = $('#js-administration-formcontrol-variants');
                                        $participantResolverParameters.find('.row-add').first().before(CreateRow(value));
                                    }
                                });
                            }
                        }
                    }
                    ws_hideProgressBar();
                    return false;
                }


                function CreateRow(paramName) {
                    var currentRowHTML = '';
                    currentRowHTML += '<tr class="js-administration-formcontrol-variants-item">';
                    currentRowHTML += '<td>';
                    currentRowHTML += '<div class="pull-right">';
                    currentRowHTML += '<div>';
                    currentRowHTML += '<a class="js-administration-formcontrol-variants-edittoggle" href="#"><i class="icon-edit">&nbsp;&nbsp;</i></a>';
                    currentRowHTML += '<a class="js-administration-formcontrol-variants-deleterow" href="#"><i class="icon-trash">&nbsp;&nbsp;</i></a>';
                    currentRowHTML += '</div>';
                    currentRowHTML += '<div class="update-actions js-initial-hide" style="display: none;">';
                    currentRowHTML += '<button class="js-administration-formcontrol-variants-editsave js-administration-formcontrol-variants-edittoggle btn btn-primary"><span>Save</span></button>';
                    currentRowHTML += '<button class="js-administration-formcontrol-variants-edittoggle btn"><span>Cancel</span></button>';
                    currentRowHTML += '</div>';
                    currentRowHTML += '</div>';
                    currentRowHTML += '<div class="js-administration-formcontrol-variants-display">' + paramName + '</div>';
                    currentRowHTML += '<div class="js-administration-formcontrol-variants-form js-initial-hide" style="display: none;">';
                    currentRowHTML += '<input type="text" class="input-twothirds" value="' + paramName + '">';
                    currentRowHTML += '</div>';
                    currentRowHTML += '</td>';
                    currentRowHTML += '</tr>';


                    return currentRowHTML;
                }

                function SaveData() {
                    //
                    ws_showProgressBar();
                    var theControlXML = undefined;
                    var name = null;
                    var clsid = null;
                    var variants = null;
                    if (!validateClientSide('validate-section')) {
                        ws_hideProgressBar();
                        return false;
                    }

                    if (ValidateParameters() == true) {
                        var isXML = ($('.js-createwith-toggle-view-slave-0').css('display') == "block");
                        if (isXML) {
                            var theControlXML = $.trim($('#txtXML').val());
                            if (isValidXMLString(theControlXML)) {
                                var xmlDoc = loadXMLString(theControlXML);
                                name = $.trim((xmlDoc.documentElement.getAttribute('Name')));
                                clsid = $.trim((xmlDoc.documentElement.getAttribute('ClsId')));
                                variants = $.trim(xmlDoc.documentElement.getAttribute('Variants'));
                            }
                        }
                        else {
                            name = $.trim($('#txtControlName').val());
                            clsid = $.trim($('#txtClsId').val());
                            var variant = $('#js-administration-formcontrol-variants div.js-administration-formcontrol-variants-display');
                            var values = new Array();
                            if (variant.length > 0) {
                                for (var i = 0; i < variant.length; i++) {
                                    values.push($.trim($(variant[i]).html()));
                                }
                                variants = values.join(",");
                            }
                        }

                        ws_ajaxCall("/ServerConfig/UpdateInfoPathControl", { server: $('#select-webapp').val(),
                            id: theID,
                            variants: variants,
                            clsid: clsid,
                            name: name,
                            status: 1
                        }, function () {
                            window.location.href = "/ServerConfig/FormControls?server=" + $('#select-webapp').val();
                        },
                                    CallBackFailure, null);
                    }
                    else {
                        ws_hideProgressBar();
                    }

                    return false;
                }

                var errorMessage = new Array();
                function ValidateParameters() {
                    errorMessage = new Array();
                    var guidRegex = /\b[a-fA-F0-9]{8}(?:-[a-fA-F0-9]{4}){3}-[a-fA-F0-9]{12}\b/;
                    var isXML = ($('.js-createwith-toggle-view-slave-0').css('display') == "block");
                    if (isXML) {
                        var theControlXML = $.trim($('#txtXML').val());
                        if (isValidXMLString(theControlXML)) {
                            var xmlDoc = loadXMLString(theControlXML);
                            if (xmlDoc != null && xmlDoc != undefined) {
                                var $rootElement = $(xmlDoc).find('Control');
                                if ($rootElement != null && $rootElement.length > 0) {
                                    var name = $.trim($rootElement.attr('Name'));
                                    var clsid = $.trim($rootElement.attr('ClsId'));
                                    var variants = $.trim($rootElement.attr('Variants'));
                                    var txtname = $.trim($('#txtControlName').val());
                                    if (name == undefined || name.length <= 0) {
                                        errorMessage.push('Name parameter is either not specified or is empty in the XML.');
                                    }

                                    if ($.trim(txtname) == '' || txtname !== name) {
                                        errorMessage.push('Name of the Form Control is either not specified or does not match the name in the XML.');
                                    }

                                    if (clsid == undefined || clsid.length <= 0) {
                                        errorMessage.push('ClsId parameter is either not specified or is empty in the XML.');
                                    }
                                    else if (clsid.match(guidRegex) == undefined) {
                                        errorMessage.push('ClsId parameter is not in the correct format in the XML.');
                                    }
                                    else {
                                        var hiddenclsid = $('#hiddenclsid').val();
                                        if (clsid != hiddenclsid) {
                                            errorMessage.push('ClsId parameter in the XML should not be changed.');
                                        }
                                    }

                                    if (variants != undefined) {
                                        if ($.trim(variants).length > 0) {
                                            var array = variants.split(",");
                                            if (array.length > 0) {
                                                var foundBlank = false;
                                                for (var i = 0; i < array.length; i++) {
                                                    if ($.trim(array[i]).length <= 0) {
                                                        foundBlank = true;
                                                    }
                                                }

                                                if (foundBlank) {
                                                    errorMessage.push('Variant List of the Form Control is not valid(It should be either empty, or a comma separated list of values).');
                                                }
                                            }
                                            else {
                                                errorMessage.push('Unknown Error');
                                                wsLib_createBootstrapAlert($('#js-notice-message'), errorMessage.join(' '), "error", true);
                                                return false;
                                            }
                                        }
                                    }
                                }
                                else {
                                    wsLib_createBootstrapAlert($('#js-notice-message'), 'Form Control XML is invalid.', "error", true);
                                    return false;
                                }
                            }

                            if (errorMessage.length > 0) {
                                wsLib_createBootstrapAlert($('#js-notice-message'), errorMessage.join(' '), "error", true);
                                return false;
                            }
                        }
                        else {
                            wsLib_createBootstrapAlert($('#js-notice-message'), 'Form Control XML is invalid.', "error", true);
                            return false;
                        }
                    }

                    return true;
                }
        </script>
</asp:Content>
