﻿<%@ Page Title="Edit Participant Resolver" Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage" %>

<asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
	Edit Participant Resolver
</asp:Content>

<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
 <div class="row-fluid">
                    <div class="span12">
                        <ul id="breadcrumbs">
                            <li><a href="/Home">Administration</a> &rsaquo;</li>
                            <li><a href="/ServerConfig">Workflow Design Configuration</a> &rsaquo;</li>
                            <li><a href="/ServerConfig/ParticipantResolvers">Participant Resolvers</a> &rsaquo;</li>
                            <li>Edit Participant Resolver</li>
                            <li class="related-links">
                                <ul>
                                    <li class="related-label">Related Tasks:</li>
                                    <li class="link"><a href="/ServerConfig/ParticipantResolvers">Participant Resolvers</a></li>
                                    <li class="link"><a href="/ServerConfig/Index">Workflow Design Configuration</a></li>
                                    <li class="link"><a href="/ServerConfig/Plugins">Plugins</a></li>
                                    <li class="link"><a href="/ServerConfig/FormControls">Form Controls</a></li>
                                </ul>
                            </li>
                        </ul>
                        <ul id="secnav">
                            <li class="active">
                                <h1>Edit Participant Resolver</h1>
                            </li>
                        </ul>
                    </div> 
                   
                <div class="row-fluid" id="validate-section">
                    <div class="span8">
                        <div class="settings-info">
                            <form class="form-horizontal">
                                <fieldset>
                                    <div class="control-group">
                                        <label class="control-label">Name <span class="required">*</span></label>
                                        <div class="controls ">
                                            <input readonly type="text" id="txtPRName" class="form-control input-block-level input-max"/>
                                        </div>
                                    </div>
                                    <div class="control-group">
                                        <label class="control-label">Create with</label>
                                        <div class="controls">
                                            <ul class="checkbox-group inline-list" id="optionList">
                                                <li>
                                                    <label>
                                                    <input type="radio" class="js-administration-topline-toggle js-createwith-toggle-view-master-0" data-administration-topline="true" name="TEMP_RENAMETHIS_create_with" checked="checked"/>
                                                    <span>XML</span>
                                                    </label>
                                                </li>
                                                <li>
                                                    <label>
                                                    <input type="radio" class="js-administration-topline-toggle js-createwith-toggle-view-master-1" data-administration-topline="false" name="TEMP_RENAMETHIS_create_with"/>
                                                    <span>Participant Resolver Designer</span>
                                                    </label>
                                                </li>
                                            </ul>
                                        </div>
                                    </div>
                                    <!--if xml choses-->
                                    <div class="control-group js-createwith-toggle-view-slave-0">
                                        <label class="control-label">XML <span class="required">*</span></label>
                                        <div class="controls ">
                                            <textarea validation-type="required" required-message="Please enter the Participant Resolver XML." id="txtXML" class="js-transform-formexpand input-block-level" rows="5"></textarea>
                                        </div>
                                    </div>
                                </fieldset>
                            </form>
                        </div>
                    </div>
                    <!-- /div .span8 -->
                </div>
                <div class="row-fluid js-createwith-toggle-view-slave-1 js-initial-hide">
                    <div class="span8">
                        <h2>Parameters</h2>
                        <table class="table table-striped table-bordered table-addedit-form">
                            <thead>
                                <tr>
                                    <th width="66.6666666666%"><a href="#">Name</a></th>
                                    <th><a href="#">Variant</a></th>
                                </tr>
                            </thead>
                            <tbody id="js-administration-participantresolver-parameters">                                
                                <tr class="js-rowadd-toggle-view-slave-1 row-add">
                                    <td colspan="2"><a class="js-rowadd-toggle-view-master-0" href="#">Add Parameter</a></td>
                                </tr>
                                <tr class="js-rowadd-toggle-view-slave-0 row-add js-initial-hide">
                                    <td>
                                        <input type="text" id="txtEditPRName" class="form-control input-max" placeholder="Variant Name"/>
                                    </td>
                                    <td>
                                        <div class="controls">
                                            <ul class="checkbox-group">
                                                <li>
                                                    <label>
                                                    <input type="checkbox"/>
                                                    </label>
                                                </li>
                                            </ul>
                                        </div>
                                        <div class="add-actions">
                                            <button class="js-administration-participantresolver-parameters-addrow js-rowadd-toggle-view-master-1 btn btn-primary"><span>Add</span></button>
                                            <button class="js-rowadd-toggle-view-master-1 btn ""><span>Cancel</span></button>
                                        </div>
                                    </td>
                                </tr>
                            </tbody>
                        </table>
                    </div>
                </div>
                <div class="row-fluid">
                    <div class="span8">
                        <fieldset class="form-horizontal">
                            <div class="js-administration-topline-target form-actions top-line">
                                    <div class="control-group">
                                        <span id="js-notice-message"></span>
                                    </div>
                                <button type="submit" id="btnSave" class="btn btn-primary"><span>Save</span></button>
                                <button class="btn" id="btnCancel"><span>Cancel</span></button>
                            </div>
                        </fieldset>
                    </div>
                </div>
			</div>              
        <script src="http://ajax.googleapis.com/ajax/libs/jquery/1.11.1/jquery.min.js"></script>
        <script>
            if (!window.jQuery) {
                console.error("jQuery CDN is down.")
                document.write('<script src="<%=Url.Content("~/Content/assets/js/jquery.min.js") %>"><\/script>');
            }
        </script>
        <script src="http://maxcdn.bootstrapcdn.com/bootstrap/3.2.0/js/bootstrap.min.js"></script>
        <script>
            if (!$.fn.modal) {
                console.error("Bootstrap CDN is down.")
                document.write('<script src="<%=Url.Content("~/Content/assets/js/bootstrap.min.js") %>"><\/script>');
            }
        </script>
        <script src="<%=Url.Content("~/Content/assets/js/kendo.all.min.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/wslib_master.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/wsplugin_master.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/ws_global_initialization_administration.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/ws_common.js") %>"></script>
        <script>
            (function () {
                wsLib_toggleViews("createwith", 2, "radio", "no", 200);
                wsLib_toggleViews("rowadd", 2, "default");



                $('input.js-administration-topline-toggle').on('click.toggleTopline', function () {
                    if ($(this).data('administration-topline')) {
                        $('div.js-administration-topline-target').addClass('top-line');
                    }
                    else {
                        $('div.js-administration-topline-target').removeClass('top-line');
                    }
                });



                var $participantResolverParameters = $('#js-administration-participantresolver-parameters');

                $participantResolverParameters.off('click.editToggle')
                                              .off('click.editSave')
                                              .off('click.deleteRow')
                                              .off('click.addRow')
                                              .on('click.editToggle', '.js-administration-participantresolver-parameters-edittoggle', function (event) {
                                                  event.preventDefault();
                                                  var $currentParameterItem = $(this).closest('.js-administration-participantresolver-parameters-item');
                                                  if ($(event.target).text() == "Cancel") {
                                                      $currentParameterItem.children('td').find('.js-administration-participantresolver-parameters-edittoggle').closest('div').toggle();
                                                      var txtName = $currentParameterItem.find('.input-max').first();
                                                      $(txtName).val(($currentParameterItem.find('.js-administration-participantresolver-parameters-display:eq(0)')).html());
                                                      var checkboxValue = $currentParameterItem.find('.js-administration-participantresolver-parameters-display:eq(1)');
                                                      if (checkboxValue != undefined && checkboxValue != null) {
                                                          var val = $(checkboxValue).html();
                                                          var checkBoxControl = $currentParameterItem.find('.js-administration-participantresolver-parameters-form:eq(1)').find('.checkbox-group input[type="checkbox"]');
                                                          if (val.toString().toLowerCase() == "true") {
                                                              $(checkBoxControl).attr("checked", "checked");
                                                          }
                                                          else {
                                                              $(checkBoxControl).removeAttr("checked");
                                                          }
                                                      }

                                                      $currentParameterItem.find('.js-administration-participantresolver-parameters-display').toggle();
                                                      $currentParameterItem.find('.js-administration-participantresolver-parameters-form').toggle();
                                                      event.stopImmediatePropagation();
                                                      return false;
                                                  }

                                                  var txtName = $currentParameterItem.find('.js-administration-participantresolver-parameters-form:eq(0)').find('.input-max');
                                                  if (txtName.is(':visible')) {
                                                      if ($.trim(txtName.val()).length > 0) {
                                                          $currentParameterItem.children('td').find('.js-administration-participantresolver-parameters-edittoggle').closest('div').toggle();
                                                          $currentParameterItem.find('.js-administration-participantresolver-parameters-display').toggle();
                                                          $currentParameterItem.find('.js-administration-participantresolver-parameters-form').toggle();
                                                      }
                                                      else {
                                                          event.stopImmediatePropagation();
                                                          return false;
                                                      }
                                                  }
                                                  else {
                                                      $currentParameterItem.children('td').find('.js-administration-participantresolver-parameters-edittoggle').closest('div').toggle();
                                                      $currentParameterItem.find('.js-administration-participantresolver-parameters-display').toggle();
                                                      $currentParameterItem.find('.js-administration-participantresolver-parameters-form').toggle();
                                                  }
                                              }).on('click.editSave', '.js-administration-participantresolver-parameters-editsave', function (event) {
                                                  event.preventDefault();

                                                  $(this).closest('tr').find('.js-administration-participantresolver-parameters-form').find('input').each(function () {
                                                      var $currentInput = $(this);
                                                      var $currentDisplay = $currentInput.closest('.js-administration-participantresolver-parameters-form').siblings('.js-administration-participantresolver-parameters-display');

                                                      if ($currentInput.attr('type') === 'checkbox') {
                                                          $currentDisplay.text($currentInput.prop('checked'));
                                                      }
                                                      else {
                                                          $currentDisplay.text($.trim($currentInput.val()));
                                                      }
                                                      UNSAVEDDATA = true;
                                                  });
                                              }).on('click.deleteRow', '.js-administration-participantresolver-parameters-deleterow', function (event) {
                                                  event.preventDefault();
                                                  UNSAVEDDATA = true;
                                                  $(this).closest('tr').remove();
                                              }).on('click.addRow', '.js-administration-participantresolver-parameters-addrow', function (event) {
                                                  event.preventDefault();

                                                  var currentRowHTML = '';
                                                  var currentRowData = [];

                                                  $(this).closest('.row-add').find('input').each(function (index) {
                                                      var $currentInput = $(this);

                                                      if ($currentInput.attr('type') === 'checkbox') {
                                                          currentRowData.push({
                                                              index: index,
                                                              data: $currentInput.prop('checked')
                                                          });

                                                          $currentInput.prop('checked', false);
                                                      }
                                                      else {
                                                          currentRowData.push({
                                                              index: index,
                                                              data: $.trim($currentInput.val())
                                                          });

                                                          $currentInput.val('');
                                                      }
                                                  });

                                                  var currentPlugData = {
                                                      name: currentRowData[0].data,
                                                      variant: currentRowData[1].data
                                                  };

                                                  if (currentPlugData.name != undefined && $.trim(currentPlugData.name).length > 0) {

                                                      currentRowHTML += '<tr class="js-administration-participantresolver-parameters-item">';
                                                      currentRowHTML += '<td>';
                                                      currentRowHTML += '<div class="js-administration-participantresolver-parameters-display">' + currentPlugData.name + '</div>';
                                                      currentRowHTML += '<div class="js-administration-participantresolver-parameters-form js-initial-hide" style="display: none;">';
                                                      currentRowHTML += '<input type="text" class="input-max" value="' + currentPlugData.name + '">';
                                                      currentRowHTML += '</div>';
                                                      currentRowHTML += '</td>';
                                                      currentRowHTML += '<td>';
                                                      currentRowHTML += '<div class="pull-right">';
                                                      currentRowHTML += '<div>';
                                                      currentRowHTML += '<a class="js-administration-participantresolver-parameters-edittoggle" href="#"><i class="icon-edit">&nbsp;&nbsp;</i></a>';
                                                      currentRowHTML += '<a class="js-administration-participantresolver-parameters-deleterow" href="#"><i class="icon-trash">&nbsp;&nbsp;</i></a>';
                                                      currentRowHTML += '</div>';
                                                      currentRowHTML += '<div class="update-actions js-initial-hide" style="display: none;">';
                                                      currentRowHTML += '<button class="js-administration-participantresolver-parameters-editsave js-administration-participantresolver-parameters-edittoggle btn btn-primary"><span>Save</span></button>';
                                                      currentRowHTML += '<button class="js-administration-participantresolver-parameters-edittoggle btn"><span>Cancel</span></button>';
                                                      currentRowHTML += '</div>';
                                                      currentRowHTML += '</div>';
                                                      currentRowHTML += '<div class="js-administration-participantresolver-parameters-display">' + currentPlugData.variant + '</div>';
                                                      currentRowHTML += '<div class="js-administration-participantresolver-parameters-form js-initial-hide" style="display: none;">';
                                                      currentRowHTML += '<ul class="checkbox-group">';
                                                      currentRowHTML += '<li>';
                                                      currentRowHTML += '<label>';
                                                      currentRowHTML += '<input type="checkbox"' + (currentPlugData.variant ? 'checked="checked"' : '') + '>';
                                                      currentRowHTML += '</label>';
                                                      currentRowHTML += '</li>';
                                                      currentRowHTML += '</ul>';
                                                      currentRowHTML += '</div>';
                                                      currentRowHTML += '</td>';
                                                      currentRowHTML += '</tr>';

                                                      $participantResolverParameters.find('.row-add').first().before(currentRowHTML);
                                                      UNSAVEDDATA = true;
                                                  }
                                              });
            })();
        </script>
        <script>
            var theID;
            var UNSAVEDDATA = false;
            var UNSAVEDDATATXT = false;
            var XML = undefined;
            $(document).ready(function () {
                ws_showProgressBar();
                ws_initializeWebApp("/admin/GetAllWebApp", $('#select-webapp'), OnLoad);

                $('#txtXML').change(function () {
                    var $this = $(this);
                    if (XML == undefined) {
                        UNSAVEDDATATXT = true;
                    }
                    else if (XML != $this.val()) {
                        UNSAVEDDATATXT = true;
                    }
                    else {
                        UNSAVEDDATATXT = false;
                    }
                });

                $('#select-webapp').change(function () {
                    wsLib_destroyBootstrapAlert($('#js-notice-message'));
                    if (UNSAVEDDATA == true || UNSAVEDDATATXT == true) {
                        if (window.confirm('Unsaved data will be lost. Do you want to continue ?') == false) {
                            return false;
                        }
                    }

                    SetupLinks();
                });

                $('#btnSave').click(function () {
                    wsLib_destroyBootstrapAlert($('#js-notice-message'));
                    SaveData();
                });


                $("#btnCancel").click(function () {
                    wsLib_destroyBootstrapAlert($('#js-notice-message'));
                    var isDirty = false;
                    var isXML = ($('.js-createwith-toggle-view-slave-0').css('display') == "block");
                    if (isXML == true) {
                        isDirty = UNSAVEDDATATXT;
                    }
                    else {
                        isDirty = UNSAVEDDATA;
                    }


                    if (isDirty == true) {
                        if (window.confirm('Unsaved data will be lost. Do you want to continue ?') == true) {
                            window.location.href = '/ServerConfig/ParticipantResolvers?server=' + $('#select-webapp').val();
                        }
                    }
                    else {
                        window.location.href = '/ServerConfig/ParticipantResolvers?server=' + $('#select-webapp').val();
                    }

                    return false;
                });
            });

            function SaveData() {
                //
                ws_showProgressBar();
                var theControlXML = undefined;
                var name = null;
                var params = '';
                var variants = '';
                var paramss = new Array();
                var variantss = new Array();
                if (!validateClientSide('validate-section')) {
                    ws_hideProgressBar();
                    return false;
                }

                if (ValidateParameters() == true) {
                    var isXML = ($('.js-createwith-toggle-view-slave-0').css('display') == "block");
                    if (isXML) {
                        var theControlXML = $.trim($('#txtXML').val());
                        if (isValidXMLString(theControlXML)) {
                            var xmlDoc = loadXMLString(theControlXML);
                            name = $.trim((xmlDoc.documentElement.getAttribute('Name')));
                            params = $.trim((xmlDoc.documentElement.getAttribute('ParmNames')));
                            variants = $.trim(xmlDoc.documentElement.getAttribute('Variants'));
                        }
                    }
                    else {
                        name = $.trim($('#txtPRName').val());
                        var parameter = $('.js-administration-participantresolver-parameters-item');
                        if (parameter.length > 0) {
                            for (var i = 0; i < parameter.length; i++) {
                                var paramname = $(parameter[i]).find('.js-administration-participantresolver-parameters-display').first().html();
                                paramss.push($.trim(paramname));
                                var isVariant = ($(parameter[i]).find('.js-administration-participantresolver-parameters-display').last().html().toLowerCase() == "true");
                                if (isVariant) {
                                    variantss.push($.trim(paramname));
                                }
                            }

                            params = paramss.join(",");
                            variants = variantss.join(",");
                        } 
                    }

                    ws_ajaxCall("/ServerConfig/UpdateParticipantResolver", { server: $('#select-webapp').val(),
                        id: theID,
                        variants: variants,
                        param: params,
                        name: name,
                        status: 1
                    }, function () {
                        window.location.href = "/ServerConfig/ParticipantResolvers?server=" + $('#select-webapp').val();
                    },
                                    CallBackFailure, null);
                }

                ws_hideProgressBar();
                return false;
            }

            function OnLoad() {
                LoadData();
                return false;
            }

            function LoadData() {
                ws_showProgressBar();
                $('tr.js-administration-participantresolver-parameters-item').remove();
                ws_ajaxCall("/ServerConfig/GetParticipantResolver", { server: $('#select-webapp').val(),
                    name: wsPlugin_getURLParameter('name')
                }, CallBackSuccess, CallBackFailure, null);
                return false;
            }

            function CallBackFailure(xhr, status, error, callbackdata) {
                ws_hideProgressBar();
                if (xhr.statusText != null && xhr.statusText != undefined) {
                    wsLib_createBootstrapAlert($('#js-notice-message'), xhr.statusText, "error", true);
                }
            }

            function CallBackSuccess(data) {
                if (data != null && data != undefined && data.length > 0) {
                    if (data[0].MetaData != null && data[0].MetaData != undefined) {
                        var xmlDoc = loadXMLString(data[0].MetaData);
                        if (xmlDoc != null && xmlDoc != undefined) {
                            var $rootElement = $(xmlDoc).find('ParticipantResolver');
                            if ($rootElement != null && $rootElement.length > 0) {
                                var name = $rootElement.attr('Name');
                                var params = $rootElement.attr('ParmNames');
                                var variants = $rootElement.attr('Variants');
                                theID = data[0].ID;
                                $('#txtPRName').val(name);
                                $('#txtXML').val(data[0].MetaData);
                                XML = data[0].MetaData;
                                var variants = variants;
                                var params = params;
                                var variantArray = [];
                                var paramArray = new Array();
                                if (variants != null && variants != undefined) {
                                    $.each(variants.split(","), function (index, value) {
                                        if ($.trim(value).length > 0) {
                                            variantArray[value] = 1;
                                        }
                                    });

                                }

                                if (params != null && params != undefined) {
                                    $.each(params.split(","), function (index, value) {
                                        if ($.trim(value).length > 0) {
                                            paramArray.push($.trim(value));
                                        }
                                    });
                                }

                                $.each(paramArray, function (index, value) {
                                    var $participantResolverParameters = $('#js-administration-participantresolver-parameters');
                                    $participantResolverParameters.find('.row-add').first().before(CreateRow(value, (variantArray[value] == 1 ? true : false)));
                                });
                            }
                            else {
                                wsLib_createBootstrapAlert($('#js-notice-message'), 'Participant Resolver XML is invalid.', "error", true);
                                return false;
                            }
                        }
                    }
                }

                ws_hideProgressBar();
                return false;
            }


            function CreateRow(paramName, isVariant) {
                var currentRowHTML = '';
                currentRowHTML += '<tr class="js-administration-participantresolver-parameters-item">';
                currentRowHTML += '<td>';
                currentRowHTML += '<div class="js-administration-participantresolver-parameters-display">' + paramName + '</div>';
                currentRowHTML += '<div class="js-administration-participantresolver-parameters-form js-initial-hide" style="display: none;">';
                currentRowHTML += '<input type="text" class="input-max" value="' + paramName + '">';
                currentRowHTML += '</div>';
                currentRowHTML += '</td>';
                currentRowHTML += '<td>';
                currentRowHTML += '<div class="pull-right">';
                currentRowHTML += '<div>';
                currentRowHTML += '<a class="js-administration-participantresolver-parameters-edittoggle" href="#"><i class="icon-edit">&nbsp;&nbsp;</i></a>';
                currentRowHTML += '<a class="js-administration-participantresolver-parameters-deleterow" href="#"><i class="icon-trash">&nbsp;&nbsp;</i></a>';
                currentRowHTML += '</div>';
                currentRowHTML += '<div class="update-actions js-initial-hide" style="display: none;">';
                currentRowHTML += '<button class="js-administration-participantresolver-parameters-editsave js-administration-participantresolver-parameters-edittoggle btn btn-primary"><span>Save</span></button>';
                currentRowHTML += '<button class="js-administration-participantresolver-parameters-edittoggle btn"><span>Cancel</span></button>';
                currentRowHTML += '</div>';
                currentRowHTML += '</div>';
                currentRowHTML += '<div class="js-administration-participantresolver-parameters-display">' + isVariant + '</div>';
                currentRowHTML += '<div class="js-administration-participantresolver-parameters-form js-initial-hide" style="display: none;">';
                currentRowHTML += '<ul class="checkbox-group">';
                currentRowHTML += '<li>';
                currentRowHTML += '<label>';
                currentRowHTML += '<input type="checkbox"' + (isVariant ? 'checked="checked"' : '') + '>';
                currentRowHTML += '</label>';
                currentRowHTML += '</li>';
                currentRowHTML += '</ul>';
                currentRowHTML += '</div>';
                currentRowHTML += '</td>';
                currentRowHTML += '</tr>';
                return currentRowHTML;
            }

            var errorMessage = new Array();
            function ValidateParameters() {
                errorMessage = new Array()
                var isXML = ($('.js-createwith-toggle-view-slave-0').css('display') == "block");
                if (isXML) {
                    var theControlXML = $.trim($('#txtXML').val());
                    if (isValidXMLString(theControlXML)) {
                        var xmlDoc = loadXMLString(theControlXML);
                        if (xmlDoc != null && xmlDoc != undefined) {
                            var $rootElement = $(xmlDoc).find('ParticipantResolver');
                            if ($rootElement != null && $rootElement.length > 0) {
                                var name = $.trim($rootElement.attr('Name'));
                                var params = $.trim($rootElement.attr('ParmNames'));
                                var variants = $.trim($rootElement.attr('Variants'));
                                var txtName = $.trim($('#txtPRName').val());
                                if (name == undefined || name.length <= 0) {
                                    errorMessage.push('Name parameter is either not specified or is empty in the XML.');
                                }

                                if (txtName == '' || txtName !== name) {
                                    errorMessage.push('Name of the Participant resolver is either not specified or does not match the name in the XML.');
                                }

                                if (params != undefined) {
                                    params = $.trim(params);
                                    if (params.length > 0) {
                                        var array = params.split(",");
                                        if (array.length > 0) {
                                            var foundBlank = false;
                                            for (var i = 0; i < array.length; i++) {
                                                if ($.trim(array[i]).length == 0) {
                                                    foundBlank = true;
                                                }
                                            }

                                            if (foundBlank) {
                                                errorMessage.push('Parameter List of the Participant resolver is not valid(It should be either empty, or a comma separated list of values).');
                                            }
                                        }
                                        else {
                                            errorMessage.push('Unknown Error');
                                        }
                                    }
                                }

                                if (variants != undefined && $.trim(variants).length > 0) {
                                    var array = variants.split(",");
                                    if (array.length > 0) {
                                        var foundBlank = false;
                                        for (var i = 0; i < array.length; i++) {
                                            if ($.trim(array[i]).length == 0) {
                                                foundBlank = true;
                                            }
                                        }

                                        if (foundBlank) {
                                            errorMessage.push('Variant List of the Participant resolver is not valid(It should be either empty, or a comma separated list of values).');
                                        }
                                    }
                                    else {
                                        errorMessage.push('Unknown Error');
                                    }
                                }
                            }
                            else {
                                wsLib_createBootstrapAlert($('#js-notice-message'), 'Participant Resolver XML is invalid.', "error", true);
                                return false;
                            }
                        }

                        if (errorMessage.length > 0) {
                            wsLib_createBootstrapAlert($('#js-notice-message'), errorMessage.join(' '), "error", true);
                            return false;
                        }
                    }
                    else {
                        wsLib_createBootstrapAlert($('#js-notice-message'), 'Participant Resolver XML is invalid.', "error", true);
                        return false;
                    }
                }                

                return true;
            }
        </script>
</asp:Content>
