﻿<%@ Page Title="Form Controls" Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage" %>

<asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
	Form Controls
</asp:Content>

<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
<div class="row-fluid">
                    <div class="span12">
                        <ul id="breadcrumbs">
                            <li><a href="/Home">Administration</a> &rsaquo;</li>
                            <li><a href="/ServerConfig">Workflow Design Configuration</a> &rsaquo;</li>
                            <li>Form Controls</li>
                            <li class="related-links">
                                <ul>
                                    <li class="related-label">Related Tasks:</li>
                                    <li class="link"><a href="/ServerConfig/Index">Workflow Design Configuration</a></li>
                                    <li class="link"><a href="/ServerConfig/Plugins">Plugins</a></li>
                                    <li class="link"><a href="/ServerConfig/ParticipantResolvers">Participant Resolvers</a></li>
                                </ul>
                            </li>
                        </ul>
                        <ul id="secnav">
                            <li class="pull-right">
                                <button id="btn-formcontrol-add" class="btn pull-right"><span>Add Form Control</span></button>
                            </li>
                            <li class="active">
                                <h1>Form Controls</h1>                                
                            </li>
                        </ul>
                    </div>                    
                </div>
                <div class="control-group">
                    <span id="js-notice-message">
                    
                    </span>
                </div>
                <div class="row-fluid">
                    <table class="table table-header">
                        <tbody>
                            <tr>
                                <td>
                                    <form>
                                        <div>
                                            <label>Name contains</label>
                                            <input type="text" id="txtNameControl" class="form-control input-large" placeholder=""/>
                                        </div>
                                        <div>
                                            <label>Definition contains</label>
                                            <input type="text" id="txtDefinitionControl" class="form-control input-large" placeholder=""/>
                                        </div>
                                        <div>
                                            <label>&nbsp;</label>
                                            <button class="btn btn-primary" id="btnSearch"><span>Search</span></button>
                                        </div>
                                    </form>
                                </td>
                            </tr>
                        </tbody>
                    </table>
                </div>
                <div class="row-fluid">
                    <div class="span12">
                        <table id="table-controls" class="table table-scheduler table-striped table-bordered">
                            <thead>
                                <tr class="table-menu">
                                    <th colspan="2">
                                        <div class="display">
                                            <span id='rowDisplay'></span>
                                            <select name="" id="pagesizedropdown" onchange="" class="input-small">
                                                <option selected="selected" value="10">10</option>
                                                <option value="20">20</option>
                                                <option value="50">50</option>
                                                <option value="100">100</option>
                                            </select>
                                            <a href="" onclick="ExportData();return false;">Export</a>
                                        </div>
                                    </th>
                                </tr>
                                <tr class="table-sort">
                                    <th sort-indicator="Ascending" class="sortup" sort-key="Name"><a href="#">Name</a></th>
                                    <th class="no-sort">Definition</th>
                                </tr>
                            </thead>
                            <tbody>
                                <tr>
                                    <td class="table-dropdown">
                                        <span>Lookup</span>
                                        <div class="btn-group">
                                            <a class="btn btn-action dropdown-toggle" data-toggle="dropdown" href="#"></a>
                                            <ul class="dropdown-menu">
                                                <li><a href="#">Edit</a></li>
                                                <li><a href="#">Delete</a></li>
                                            </ul>
                                        </div>
                                    </td>
                                    <td>&#60;xml code preview goes here&#62;</td>
                                </tr>                                
                            </tbody>
                        </table>
                       <div id="div-paging">
                            <ul id="pagination-elmt"class="pagination-sm"></ul>
                       </div>
                    </div>
                    <!-- /div .span8 -->
                </div>
				<script src="http://ajax.googleapis.com/ajax/libs/jquery/1.11.1/jquery.min.js"></script>
        <script>
            if (!window.jQuery) {
                console.error("jQuery CDN is down.")
                document.write('<script src="<%=Url.Content("~/Content/assets/js/jquery.min.js") %>"><\/script>');
            }
        </script>
        <script src="http://maxcdn.bootstrapcdn.com/bootstrap/3.2.0/js/bootstrap.min.js"></script>
        <script>
            if (!$.fn.modal) {
                console.error("Bootstrap CDN is down.")
                document.write('<script src="<%=Url.Content("~/Content/assets/js/bootstrap.min.js") %>"><\/script>');
            }
        </script>
        <script src="<%=Url.Content("~/Content/assets/js/kendo.all.min.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/chosen.jquery.min.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/wslib_master.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/wsplugin_master.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/ws_admincommands.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/ws_common.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/jquery.twbsPagination.min.js") %>"></script>
       <script>       
           var thePageCount;
           var theRecordCount;
           var orderSort = 'ASC';
           var pagenumber = 1;
           var _globalMessage = '<%=TempData["FormControlMessage"] %>';
           $('a.js-tooltip-target').tooltip({
               html: true,
               trigger: 'click',
               animation: true
           });

           $('body').on('click', '.js-tooltip-target', function (event) {
               event.stopPropagation();

               $('div.tooltip').not($(this).siblings('div.tooltip')).remove();
           });

           $(document).ready(function () {
               ws_showProgressBar();
               ws_initializeWebApp("/admin/GetAllWebApp", $('#select-webapp'), OnLoad);
               $("#btnSearch").click(function () {
                   wsLib_destroyBootstrapAlert($('#js-notice-message'));
                   pagenumber = 1;
                   _globalMessage = '';
                   LoadData(pagenumber);
                   return false;
               });

               BindEnterKeyEvent($("#txtNameControl, #txtDefinitionControl"), $("#btnSearch"));

               $('#select-webapp').change(function () {
                   SetupLinks();
               });

               $('#pagesizedropdown').change(function () {
                   wsLib_destroyBootstrapAlert($('#js-notice-message'));
                   pagenumber = 1;
                   _globalMessage = '';
                   LoadData(pagenumber);
                   return false;
               });

               $('#btn-formcontrol-add').on('click', function () {
                   window.location.href = "/ServerConfig/AddFormControl?server=" + $('#select-webapp').val();
                   return false;
               });

               ApplySorting();
           });

           function ExportData() {
               var url = '/ServerConfig/ExportControls?server=' + $('#select-webapp').val() + '&namefilter=' + $("#txtNameControl").val() +
                   '&descriptionfilter=' + $("#txtDefinitionControl").val();
               window.open(encodeURI(url), "_parent");
           }

           function OnLoad() {
               $("#txtNameControl").val("");
               $("#txtDefinitionControl").val("");
               pagenumber = 1;
               LoadData(pagenumber);
               return false;
           }

           function LoadData(pagenumber) {
               ws_showProgressBar();
               $('#table-controls > tbody tr').remove();
               ws_ajaxCall("/ServerConfig/GetAllInfoPathControls", { server: $('#select-webapp').val(),
                   pagesize: $('#pagesizedropdown').val(),
                   pagenumber: pagenumber,
                   namefilter: $("#txtNameControl").val(),
                   descfilter: $("#txtDefinitionControl").val(),
                   ordersort: orderSort
               }, CallBackSuccess, CallBackFailure, null);
               return false;
           }

           function CallBackFailure(xhr, status, error, callbackdata) {
               ws_hideProgressBar();
               if (xhr.statusText != null && xhr.statusText != undefined) {
                   wsLib_createBootstrapAlert($('#js-notice-message'), xhr.statusText, "error", true);
               }
           }

           function CallBackSuccess(data) {               
               clearPaging();
               var message = '';
               if (data.PageCount != undefined && data.RecordCount != undefined && data.Records != undefined && data.Records != null) {
                   enablePaging(data.PageCount, 7);
                   thePageCount = data.PageCount;
                   theRecordCount = data.RecordCount;
                   $.each(data.Records, function (k, v) {
                       {
                           var row = CreateRow(v);
                           $("#table-controls > tbody:last").append(row);
                       }
                   });

                   var theCount = data.PageCount;
                   if (theCount > 0) {
                       var recordcount = $('#pagesizedropdown').val() * (pagenumber);
                       if (data.RecordCount >= recordcount) {
                           var therecords = ($('#pagesizedropdown').val() * (-1 + pagenumber)) + 1;
                           message = 'Displaying ' + therecords + ' to ' + (therecords + parseInt($('#pagesizedropdown').val()) - 1) + ' of ' + data.RecordCount;
                       }
                       else {
                           var therecords = ($('#pagesizedropdown').val() * (-1 + pagenumber)) + 1;
                           message = 'Displaying ' + therecords + ' to ' + (data.RecordCount) + ' of ' + data.RecordCount;
                       }
                   }
               }
               else {
                   wsLib_createBootstrapAlert($('#js-notice-message'), '<%=Resources.Resource.WFAdminWeb_Page_NoResultFound %>', "success", true);
               }

               $('#rowDisplay').text(message);
               ws_hideProgressBar();
               if (_globalMessage != null && _globalMessage != undefined && $.trim(_globalMessage).length != 0) {
                   wsLib_createBootstrapAlert($('#js-notice-message'), _globalMessage, "success", true);
               }

               return false;
           }

           function DeleteControl(id) {
               if (window.confirm('Are you sure you want to delete the Form Control ?') == true) {
                   ws_showProgressBar();
                   _globalMessage = '';
                   $('#table-controls > tbody tr').remove();
                   ws_ajaxCall("/ServerConfig/DeleteInfoPathControl", { server: $('#select-webapp').val(),
                       id: id,
                       pagenumber: pagenumber,
                       pagesize: $('#pagesizedropdown').val(),
                       namefilter: $("#txtNameControl").val(),
                       descfilter: $("#txtDefinitionControl").val(),
                       ordersort: orderSort

                   }, CallBackSuccess, CallBackFailure, null);
               }

               return false;
           }

           function CreateRow(obj) {
               var markup = '    <tr id="' + obj.ID + '">' +
                                    '<td class="table-dropdown">' +
                                        '<span>' + obj.Name + '</span>' +
                                        '<div class="btn-group">' +
                                        '    <a class="btn btn-action dropdown-toggle" data-toggle="dropdown" href="#"></a>' +
                                       '     <ul class="dropdown-menu">' +
                                      '          <li><a href="editformcontrol?server=' + $('#select-webapp').val() + '&name=' + obj.Name + '">Edit</a></li>' +
                                     '           <li><a href="#" onclick = "DeleteControl(' + obj.ID + ')">Delete</a></li>' +
                                    '        </ul>' +
                                   '     </div>' +
                                  '  </td>' +
                                 '   <td>' + $('<span/>').text(obj.MetaData.toString()).html() + '</td>' +
                                '</tr> ';
               return markup;
           }
        </script>
        <script>
            function clearPaging() {
                $('#div-paging').html('');
                $('#div-paging').html('<ul id="pagination-elmt"class="pagination-sm"></ul>');
            }

            function enablePaging(totalPages, visiblePages) {
                $('#pagination-elmt').twbsPagination({
                    totalPages: totalPages,
                    visiblePages: visiblePages,
                    onPageClick: function (event, page) {
                        pagenumber = page;
                        _globalMessage = '';
                        LoadData(page);
                    }
                });
            }


            function resetSortingFunctionality() {
                var ths = $('#table-controls').find('th[sort-indicator]').removeClass().attr('sort-indicator', 'NoSort');
                orderSort = "DESC";
            }

            function CallBackFunctionFailure(xhr, status, error, callbackdata) {
                ws_hideProgressBar();
                if (xhr.statusText != null && xhr.statusText != undefined) {
                    wsLib_createBootstrapAlert($('#js-notice-message'), xhr.statusText, "error", true);
                }
            }

            function ApplySorting() {
                $('#table-controls').applySorting(function (event, data) {
                    ws_showProgressBar();
                    _globalMessage = '';
                    orderSort = (data.SortOrder.toLowerCase() == 'descending' ? 'DESC' : 'ASC');
                    LoadData(pagenumber);
                    return false;
                });
            }
           </script>
</asp:Content>
