﻿<%@ Page Title="Workflow Design Configuration" Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage" %>

<asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
	Workflow Design Configuration
</asp:Content>

<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
 <div class="row-fluid">
                    <div class="span12">
                        <ul id="breadcrumbs">
                            <li><a href="/Home">Administration</a> &rsaquo;</li>
                            <li>Workflow Design Configuration</li>
                            <li class="related-links">
								<ul>
									<li class="related-label">Related:</li>
									<li class="link"><a href="/ServerConfig/Plugins">Plugins</a></li>
									<li class="link"><a href="/ServerConfig/ParticipantResolvers">Participant Resolvers</a></li>
									<li class="link"><a href="/ServerConfig/FormControls">Form Controls</a></li>
								</ul>
							</li>
                        </ul>
                        <ul id="secnav">
                            <li class="active">
                                <h1>Workflow Design Configuration</h1>
                            </li>
                        </ul>
                    </div>
                    <div class="control-group">
                                        <span id="js-notice-message"></span>
                    </div>
                </div>
                
                <div class="row-fluid">
                    <div class="span12">
                        <table id="tableData" class="table table-scheduler table-striped table-bordered">
                            <thead>
								<tr>
							  		<th width="25%">Configuration Type</th>
							   		<th width="10%">Quantity</th>
							   		<th width="65%">Contents</th>
							    </tr>
						    </thead>
                            <tbody>
                            </tbody>
                        </table>
                        
                    </div><!-- /div .span12 -->
                </div><!-- /div .row-fluid -->
				
        <script src="http://ajax.googleapis.com/ajax/libs/jquery/1.11.1/jquery.min.js"></script>
        <script>
            if (!window.jQuery) {
                console.error("jQuery CDN is down.")
                document.write('<script src="<%=Url.Content("~/Content/assets/js/jquery.min.js") %>"><\/script>');
            }
        </script>
        <script src="http://maxcdn.bootstrapcdn.com/bootstrap/3.2.0/js/bootstrap.min.js"></script>
        <script>
            if (!$.fn.modal) {
                console.error("Bootstrap CDN is down.")
                document.write('<script src="<%=Url.Content("~/Content/assets/js/bootstrap.min.js") %>"><\/script>');
            }
        </script>
        <script src="<%=Url.Content("~/Content/assets/js/kendo.all.min.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/chosen.jquery.min.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/wslib_master.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/wsplugin_master.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/ws_common.js") %>"></script>
        <script>
            $('a.js-tooltip-target').tooltip({
                html: true,
                trigger: 'click',
                animation: true
            });
            
            $('body').on('click', '.js-tooltip-target', function(event) {
                event.stopPropagation();
                
                $('div.tooltip').not($(this).siblings('div.tooltip')).remove();
            });
        </script>
        <script>
            $(document).ready(function () {
                ws_showProgressBar();
                ws_initializeWebApp("/admin/GetAllWebApp", $('#select-webapp'), OnLoad);

                $('#select-webapp').change(function () {
                    SetupLinks();
                });
            });

            function OnLoad() {
                $("#tableData > tbody tr").remove();
                ws_ajaxCall("/ServerConfig/GetAllDataWithCount", { server: $('#select-webapp').val()
                }, CallBackSuccess, CallBackFailure, null);

                return false;
            }

            function CallBackSuccess(data) {                
                var html = '';
                if (data != null && data != undefined) {
                    for (var i = 0; i < data.length; i++) {
                        var obj = data[i]; {
                            var link = '';
                            if (obj.Key == "1") {
                                link = "/SERVERCONFIG/PLUGINS?server=" + $('#select-webapp').val();
                            }
                            else if (obj.Key == "3") {
                                link = "/SERVERCONFIG/ParticipantResolvers?server=" + $('#select-webapp').val();
                            }
                            else if (obj.Key == "4") {
                                link = "/SERVERCONFIG/FORMCONTROLS?server=" + $('#select-webapp').val();
                            }

                            html += '<tr>' +
                                    '<td>' + obj.Type + '</td>' +
                                    '<td><a href="' + link + '">' + obj.Count + '</a></td>' +
                                    '<td>' + obj.Values + '</td>' +
                                '</tr>';
                        }
                    }
                }
                else {
                    wsLib_createBootstrapAlert($('#js-notice-message'), '<%=Resources.Resource.WFAdminWeb_Page_NoResultFound %>', "error", true);
                }

                $("#tableData > tbody").html(html);
                ws_hideProgressBar();
            }

            function CallBackFailure(xhr, status, error, callbackdata) {
                ws_hideProgressBar();
                if (xhr.statusText != null && xhr.statusText != undefined) {
                    wsLib_createBootstrapAlert($('#js-notice-message'), xhr.statusText, "error", true);
                }
            }
        </script>
</asp:Content>
