﻿<%@ Page Title="" Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage" %>

<asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
	Plugins
</asp:Content>

<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
<div class="row-fluid">
                    <div class="span12">
                        <ul id="breadcrumbs">
                            <li><a href="/Home">Administration</a> &rsaquo;</li>
                            <li><a href="/ServerConfig">Workflow Design Configuration</a> &rsaquo;</li>
                            <li>Plugins</li>
                            <li class="related-links">
                                <ul>
                                    <li class="related-label">Related:</li>
                                    <li class="link"><a href="/ServerConfig/Index">Workflow Design Configuration</a></li>
                                    <li class="link"><a href="/ServerConfig/ParticipantResolvers">Participant Resolvers</a></li>
                                    <li class="link"><a href="/ServerConfig/FormControls">Form Controls</a></li>
                                </ul>
                            </li>
                        </ul>
                        <ul id="secnav">
                            <li class="pull-right">
                                <button id="btn-plugin-add" class="btn pull-right"><span>Add Plugin</span></button>
                            </li>
                            <li class="active">
                                <h1>Plugins</h1>
                            </li>
                        </ul>
                    </div>
                </div>
                <div class="row-fluid">
                <div class="control-group">
                    <span id="js-notice-message"></span>
                </div>
                </div>
                <div class="row-fluid">
                    <table class="table table-header">
                        <tbody>
                            <tr>
                                <td>
                                    <form id="form-plugin">
                                        <div>
                                            <label>Name contains</label>
                                            <input type="text" name="name" id="input-plugin-name" class="form-control input-large" placeholder=""/>
                                        </div>
                                        <div>
                                            <label>Definition contains</label>
                                            <input type="text" name="def" id="input-plugin-def" class="form-control input-large" placeholder=""/>
                                        </div>
                                        <div>
                                            <label>&nbsp;</label>
                                            <button class="btn btn-primary" id="btn-search"><span>Search</span></button>
                                        </div>
                                    </form>
                                </td>
                            </tr>
                        </tbody>
                    </table>
                </div>
                <div class="row-fluid">
                    <div class="span12">
                        <table class="table table-scheduler table-striped table-bordered" id="table-plugin-list">
                            <thead>
                                <tr class="table-menu">
                                    <th colspan="2">
                                        <div class="display">
                                            <span id="span-records-msg"></span>
                                            <select name="" class="input-small" id="select-pagesize">
                                                <option selected="selected" value="10">10</option>
                                                <option value="20">20</option>
                                                <option value="50">50</option>
                                                <option value="100">100</option>
                                            </select>
                                            <a href="#" onclick="return exportList()">   Export</a>
                                        </div>
                                    </th>
                                </tr>
                                <tr class="table-sort">
                                    <th sort-indicator="Ascending" class="sortup" sort-key="NAME"><a href="#">Name</a></th>
                                    <th class="no-sort">Definition</th>
                                </tr>
                            <tbody></tbody>
                        </table>
                        <div id="div-paging">
                            <ul id="pagination-elmt"class="pagination-sm"></ul>
                        </div>
                    </div>
                    <!-- /div .span8 -->
                </div>
                <!-- /div .row-fluid -->
				<script src="http://ajax.googleapis.com/ajax/libs/jquery/1.11.1/jquery.min.js"></script>
        <script>
            if (!window.jQuery) {
                console.error("jQuery CDN is down.")
                document.write('<script src="<%=Url.Content("~/Content/assets/js/jquery.min.js") %>"><\/script>');
            }
        </script>
        <script src="http://maxcdn.bootstrapcdn.com/bootstrap/3.2.0/js/bootstrap.min.js"></script>
        <script>
            if (!$.fn.modal) {
                console.error("Bootstrap CDN is down.")
                document.write('<script src="<%=Url.Content("~/Content/assets/js/bootstrap.min.js") %>"><\/script>');
            }
        </script>
        <script src="<%=Url.Content("~/Content/assets/js/kendo.all.min.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/chosen.jquery.min.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/wslib_master.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/wsplugin_master.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/ws_common.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/jquery.twbsPagination.min.js") %>"></script>
        <script>
            var _globalMsg = '<%=TempData["PluginAddEdit_Key"] %>';
            $('a.js-tooltip-target').tooltip({
                html: true,
                trigger: 'click',
                animation: true
            });
            
            $('body').on('click', '.js-tooltip-target', function(event) {
                event.stopPropagation();
                
                $('div.tooltip').not($(this).siblings('div.tooltip')).remove();
            });

            var _searchData = {};
            function load(data, callbackdata) {

                var webapp = getServer();
                $('#select-webapp').val(webapp);
                var data = "url=" + webapp;
                var url = '/serverconfig/getallplugins';
                _searchData = { "Url": url, "Data": data };

                loadPlugins('/serverconfig/getallplugins', data, 1);
            }

            $(document).ready(function () {

                ws_showProgressBar();
                ws_initializeWebApp('/admin/getallwebapp', $('#select-webapp'), function (data, callbackdata) {
                    load(data, callbackdata);
                });

                $('#btn-search').on('click', function () {
                    _globalMsg = '';
                    ws_showProgressBar();

                    var webapp = $('#select-webapp option:selected').val();
                    var url = '/serverconfig/getplugins';
                    var name = $('#input-plugin-name').val();
                    var def = $('#input-plugin-def').val();
                    var data = 'name=' + name + "&url=" + webapp + '&def=' + def;

                    if (name == '' && def == '') {
                        url = '/serverconfig/getallplugins';
                        data = "url=" + webapp;
                    }

                    _searchData = { "Url": url, "Data": data };

                    clearPaging();
                    loadPlugins(url, data, 1);
                    return false;
                });

                $('#btn-plugin-add').on('click', function () {

                    var webapp = $('#select-webapp').val();
                    window.location.href = "addplugin?server=" + webapp;
                    return false;
                });

                $('#select-webapp').on('change', function () {
                    SetupLinks();
                });

                $('#select-pagesize').on('change', function () {

                    ws_showProgressBar();

                    clearPaging();
                    loadPlugins(_searchData.Url, _searchData.Data, 1, _searchData.sortData);
                });

                $('#table-plugin-list').applySorting(function (event, data) {
                    _globalMsg = '';
                    ws_showProgressBar();
                    clearPaging();
                    _searchData.sortData = data;
                    loadPlugins(_searchData.Url, _searchData.Data, 1, _searchData.sortData);
                    return false;
                });

                return false;
            });

            function fillTable(data, callbackdata) {

                $('#table-plugin-list tbody tr').remove();
                $('#span-records-msg').text(data.DisplayMessage);
                if (data.Count > 0) {
                    var webapp = $('#select-webapp').val();
                    $.each(data.Rows, function (key, value) {

                        var row = '<tr><td class="table-dropdown" style="width:10%;"><span>' + value.Name + '</span><div class="btn-group"><a class="btn btn-action dropdown-toggle" data-toggle="dropdown" href="#"></a><ul class="dropdown-menu"><li><a href="editplugin?name=' + value.Name + '&server=' + webapp + '">Edit</a></li><li><a href="#" onclick="callDelete(' + value.Id + ',\'' + value.Name + '\')">Delete</a></li></ul></div></td><td style="width:90%;word-wrap:break-word;">' + ws_getEncodedData(value.MetaData) + '</td></tr>';

                        $('#table-plugin-list tbody').append(row);
                    });

                    enablePaging(data.TotalPage, 7);
                }

                if (_globalMsg != '') {
                    wsLib_createBootstrapAlert($('#js-notice-message'), _globalMsg, "success", true);
                }

                ws_hideProgressBar();
            }

            function onError(xhr, status, error) {
                ws_hideProgressBar();
            }

            function loadPlugins(url, data, curPage, sortDataObj) {
                var sortData = '';
                if (sortDataObj != null && sortDataObj != undefined) {
                    sortData = '&sortKey=' + sortDataObj.SortKey + '&sortOrder=' + sortDataObj.SortOrder;
                }

                data += '&curPage=' + curPage + '&pageSize=' + $('#select-pagesize option:selected').val() + sortData;

                ws_ajaxCall(url, data, fillTable, onError, null);
            }

            function callDelete(id, name) {
                if (!confirm('The plugin ' + name + ' will be permanently removed from the system. Do you want to proceed?')) {
                    return false;
                }

                ws_showProgressBar();
                
                _globalMsg = name + ' plugin removed.';
                var webapp = $('#select-webapp option:selected').val();
                ws_ajaxCall('/serverconfig/DeletePlugin', { url: webapp, id: id }, function (data, callbackdata) {

                    wsLib_createBootstrapAlert($('#js-notice-message'), _globalMsg, "success", true);
                    _globalMsg = '';

                    ws_showProgressBar();

                    clearPaging();
                    loadPlugins(_searchData.Url, _searchData.Data, 1, _searchData.sortData);

                }, onError, null);
            }

            function exportList() {
                var webapp = $('#select-webapp option:selected').val();
                var name = $('#input-plugin-name').val();
                window.open('/serverconfig/export?url=' + webapp + '&name=' + name);
            }

            function getServer() {

                var server = wsPlugin_getURLParameter('server');
                if (server == undefined || server == null || server == '') {
                    server = $('#select-webapp :selected').val();
                }

                return server;
            }

            function enablePaging(totalPages, visiblePages) {
                $('#pagination-elmt').twbsPagination({
                    totalPages: totalPages,
                    visiblePages: visiblePages,
                    onPageClick: function (event, page) {
                        ws_showProgressBar();

                        loadPlugins(_searchData.Url, _searchData.Data, page, _searchData.sortData);
                    }
                });
            }

            function clearPaging() {
                $('#div-paging').html('');
                $('#div-paging').html('<ul id="pagination-elmt"class="pagination-sm"></ul>');
            }
            
        </script>
</asp:Content>
