﻿<%@ Page Title="Excel Workflow Data Dump" Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage" %>

<asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
	Excel Workflow Data Dump
</asp:Content>

<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
<div class="row-fluid">
                    <div class="span12">
                        <ul id="breadcrumbs">
                            <li><a href="/home">Administration</a> &rsaquo;</li>
                            <li>Excel Workflow Data Dump</li>
                            <li class="related-links">
                                <ul>
                                    <li class="related-label">Related:</li>
                                    <li class="link"><a href="/LogViewer">Log File Viewer</a></li>
                                    <li class="link"><a href="/Chart">Charts</a></li>
                                    <li class="link"><a href="/Scheduler">Scheduler</a></li>
                                </ul>
                            </li>
                        </ul>
                        <ul id="secnav">
                            <li id="js-header" class="active">
                                <h1>Excel Workflow Data Dump</h1>
                                <div class="row-fluid">
                                    <div class="span8 page-description"><%=Resources.Resource.SVAdminWeb_Page_Dump_NoteDescription %></div>
                                    <div class="page-description"><%=Resources.Resource.SVAdminWeb_Page_Dump_Note %></div>
                                </div>
                            </li>
                        </ul>
                    </div>
                </div>
<div class="row-fluid">
                    <div class="span8">
                        <div class="settings-info">
                            <form id="form-data" class="form-horizontal">
                                <fieldset>
                                    <div class="control-group">
                                        <label class="control-label">Site <span class="required">*</span></label>
                                        <div class="controls">
                                            <select id="select-site" data-generation-level="1" data-generationdropdown-id="location" class="js-admincommands-form-field-generation input-max" validation-type="required" required-message="Site is mandatory.">
                                                <option value="N/A">Select</option>
                                            </select>
                                           
                                            <div class="help-block">Only fully-qualified SharePoint sites are available.</div>
                                        </div>
                                    </div>
                                    <div class="control-group">
                                        <label class="control-label">Save To <span class="required">*</span></label>
                                        <div class="controls">
                                            <select id="select-doclib" data-generation-level="2" data-generationdropdown-id="location" class="js-admincommands-form-field-generation input-max" disabled="disabled" validation-type="required" required-message="Document Library is mandatory.">
                                                <option value="N/A">Select</option>
                                            </select>
                                            
                                            <div class="help-block">Document Library to save data dump in.</div>
                                        </div>
                                    </div>
                                    <div class="control-group">
                                        <label class="control-label">File Extension <span class="required">*</span></label>
                                        <div class="controls">
                                            <select id="select-ext" class="input-onethirds" validation-type="required" required-message="File type is mandatory.">
                                                <option value="N/A">Select file type</option>
                                                <option value=".html">.html</option>
                                                <option value=".csv">.csv</option>
                                            </select>
                                            
                                        </div>
                                    </div>
                                    <div class="control-group">
                                        <label class="control-label">Send Notification to</label>
                                        <div class="controls string-max">
                                            <input id="input-email" type="text"  class="input-max" placeholder="e.g. user@winshuttle, user@email.com" validation-type="regex" validation-regex="^((\w+([-+.]\w+)*@\w+([-.]\w+)*\.\w+([-.]\w+)*)\s*[,]{0,1}\s*)+$" regex-message="Email should be in the format abc@xyz.com."/>
                                            
                                        </div>
                                    </div>
                                    <div class="control-group">
                                        <span id="js-notice-message"></span>
                                    </div>
                                    <div class="form-actions top-line">
                                        <button id="btn-save" class="btn btn-primary"><span>Save</span></button>
                                        <button class="btn" id="btn-cancel"><span>Cancel</span></button>
                                    </div>
                                </fieldset>
                            </form>
                        </div>
                    </div>
                    <!-- /div .span8 -->
                </div>    
                 <script src="http://ajax.googleapis.com/ajax/libs/jquery/1.11.1/jquery.min.js"></script>
        <script>
            if (!window.jQuery) {
                console.error("jQuery CDN is down.");
                document.write('<script src="<%=Url.Content("~/Content/assets/js/jquery.min.js") %>"><\/script>');
            }
        </script>
        <script src="http://maxcdn.bootstrapcdn.com/bootstrap/3.2.0/js/bootstrap.min.js"></script>
        <script>
            if (!$.fn.modal) {
                console.error("Bootstrap CDN is down.");
                document.write('<script src="<%=Url.Content("~/Content/assets/js/bootstrap.min.js") %>"><\/script>');
            }
        </script>
        <script src="<%=Url.Content("~/Content/assets/js/kendo.all.min.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/chosen.jquery.min.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/wslib_master.js") %>"></script>
        <script src="<%=Url.Content("/Content/assets/js/wsplugin_master.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/ws_workflow_admin.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/ws_common.js") %>"></script>
        <script>
            $('.chzn-select').chosen();

            $(document).ready(function () {

                ws_showProgressBar();
                ws_initializeWebApp('/admin/GetAllWebApp', $('#select-webapp'), function () {

                    load();

                    $("#select-site").on("change", function () {
                        ws_showProgressBar();
                        var selected = $(this).find("option:selected").val();
                        $("#select-doclib").find("option:not(:first)").remove();

                        if (selected == 'N/A') {
                            $("#select-doclib").prop('disabled', 'disabled');
                            ws_hideProgressBar();
                            return;
                        }

                        ws_ajaxCall('/admin/getalldoclib', { site: selected }, function (data) {
                            var options = '';
                            $.each(data, function (key, value) {

                                options += '<option value="' + value.Name + '">' + value.Name + '</option>';
                            });

                            $("#select-doclib").append(options);
                            $("#select-doclib").prop('disabled', '');
                            ws_hideProgressBar();
                        }, null, null);
                    });

                    $('#select-webapp').on('change', function () {
                        SetupLinks();
                    });

                    $('#btn-cancel').on('click', function () {
                        var webapp = $('#select-webapp').val();
                        window.location.href = '/home?server=' + webapp;
                        return false;
                    });

                    $("#btn-save").on("click", function () {

                        if (!validateClientSide("form-data")) {

                            return false;
                        }

                        ws_showProgressBar();
                        var siteurl = $("#select-site option:selected").val();
                        var list = $("#select-doclib option:selected").val();
                        var email = $("#input-email").val();
                        var ext = $("#select-ext option:selected").val();
                        var data = { webappUrl: $('#select-webapp').val(), siteUrl: siteurl, doclib: list, email: email, ext: ext };
                        ws_ajaxCall('/workflowdump/dump', data, function (successData) {

                            ws_hideProgressBar();
                            wsLib_createBootstrapAlert($('#js-notice-message'), successData, "success", true);

                        }, function (xhr, status, error) {

                            ws_hideProgressBar();
                            if (xhr.statusText != null && xhr.statusText != undefined) {
                                wsLib_createBootstrapAlert($('#js-notice-message'), xhr.statusText, "error", true);
                            }
                            else {
                                wsLib_createBootstrapAlert($('#js-notice-message'), xhr.responseText, "error", true);
                            }
                        }, null);

                        return false;
                    });
                });
            });

            function load() {
                var $webappUrl = getServer();
                $('#select-webapp').val($webappUrl);

                ws_ajaxCall('/admin/getallsites', { server: $webappUrl }, function (data) {

                    var options = '';
                    $.each(data, function (key, value) {

                        options += '<option value="' + value.URL + '">' + value.ServerRelativeURL + '</option>';
                    });

                    $("#select-site").append(options);
                    ws_hideProgressBar();
                }, null, null);
            }

            function getServer() {

                var server = wsPlugin_getURLParameter('server');
                if (server == undefined || server == null || server == '') {
                    server = $('#select-webapp :selected').val();
                }

                return server;
            }
            
        </script>
</asp:Content>
