﻿<%@ Page Title="Process Control" Language="C#" MasterPageFile="~/Views/Shared/Site.Master" Inherits="System.Web.Mvc.ViewPage" %>

<asp:Content ID="Content1" ContentPlaceHolderID="TitleContent" runat="server">
	Process Control
</asp:Content>

<asp:Content ID="Content2" ContentPlaceHolderID="MainContent" runat="server">
  <div class="row-fluid">
                    <div class="span12">
                        <ul id="breadcrumbs">
                            <li><a href="/Home">Administration</a> &rsaquo;</li>
                            <li>Process Control</li>
                            <li class="related-links">
                                <ul>
                                    <li class="related-label">Related:</li>
                                    <li class="link"><a href="/Job">Manage Background Jobs</a></li>
                                    <li class="link"><a href="/Scheduler">Scheduler</a></li>
                                </ul>
                            </li>
                        </ul>
                        <ul id="secnav">
                            <li class="active">
                                <h1>Process Control</h1>
                            </li>
                        </ul>
                    </div>
                </div>
                <div class="form-actions top-line">
                    <span id="js-notice-message"></span>
                </div>
                <div class="row-fluid">
                    <table class="table table-header">
                        <tbody>
                            <tr>
                                <td>
                                    <form>
                                        <div>
                                            <label>Server</label>
                                            <select name="webapp" id="select-server" class="input-medium">
                                                <option selected="selected" value="%">All</option>
                                            </select>
                                        </div>
                                        <div>
                                            <label>Site</label>
                                            <select name="site" id="select-site" class="input-small">
                                                <option selected="selected" value="%">All</option>
                                            </select>
                                        </div>
                                        <div>
                                            <label>Status</label>
                                            <select name="procStatus" id="select-status" class="input-small">
                                                <option selected="selected" value="%">All</option>
                                            </select>
                                        </div>
                                        <div>
                                            <label>Definition</label>
                                            <select name="procDef" id="select-def" class="input-small">
                                                <option selected="selected" value="%">All</option>
                                            </select>
                                        </div>
                                        <div>
                                            <label>Process name contains</label>
                                            <input type="text" id="input-process" class="form-control input-large" placeholder=""/>
                                        </div>
                                        <div>
                                            <label>Doc/Form</label>
                                            <select name="docOrForm" id="select-docform" class="input-small">
                                                <option selected="selected" value="%">All</option>
                                            </select>
                                        </div>
                                        <div>
                                            <label>Originator</label>
                                            <select name="originator" id="select-originator" class="input-small">
                                                <option selected="selected" value="%">All</option>
                                            </select>
                                        </div>
                                        <div>
                                            <label>Overdue</label>
                                            <select name="overdueDate" id="select-overdue" class="input-mini"></select>
                                        </div>
                                        <div>
                                            <label>&nbsp;</label>
                                            <button class="btn btn-primary" id="btn-submit" type="submit"><span>Search</span></button>
                                        </div>
                                    </form>
                                </td>
                            </tr>
                        </tbody>
                    </table>
                </div>
                <div class="row-fluid">
                    <table class="table table-striped table-bordered" id="tbl-process-control" style="display:none;">
                        <thead>
                            <tr class="table-menu">
                                <th colspan="11">
                                    <div class="js-administration-processcontrol-visiblefor-runningprocess js-initial-hide" style="text-transform:none;">
                                        <input type="text" class="form-control input-large" placeholder="Comments" id="input-comment" />
                                    </div>
                                    <div class="input-btn js-administration-processcontrol-visiblefor-runningprocess js-initial-hide">
                                        <input class="btn" type="submit" name="" value="cancel" id="btn-cancel" field-action="cancel" action-comment="The selected process will be cancelled. Do you want to proceed?"/>
                                    </div>
                                    <div class="input-btn js-administration-processcontrol-visiblefor-runningprocess js-initial-hide">
                                        <input class="btn" type="submit" name="" value="reject" id="btn-reject" field-action="reject" action-comment="The selected process will be rejected. Do you want to proceed?"/>
                                    </div>
                                    <div class="input-btn js-administration-processcontrol-visiblefor-runningprocess js-initial-hide">
                                        <input class="btn" type="submit" name="" value="approve" id="btn-approve" field-action="approve" action-comment="The selected process will be approved. Do you want to proceed?"/>
                                    </div>
                                    <div class="display">
                                        <span id="span-records-msg">Displaying 1 - 50 of 125 </span>
                                        <select name="" id="select-pagesize" onchange="" class="input-small">
                                            <option selected="selected" value="10">10</option>
                                            <option value="20">20</option>
                                            <option value="50">50</option>
                                            <option value="100">100</option>
                                        </select>
                                        <a href="#" onclick="return exportProcess();">   Export</a>
                                    </div>
                                </th>
                            </tr>
                            <tr class="table-sort">
                                <th title="checkbox" class="no-sort" width="2%">
                                    <span title="Select All">
                                    <input class="js-processcontrol-check-all-master" type="checkbox" name=""/>
                                    </span>
                                </th>
                                <th sort-indicator="Descending" class="sortdown" sort-key="PROCESSID"><a href="#">ID</a></th>
                                <th sort-key="PROCESSSTATUS"><a href="#">Status</a></th>
                                <th sort-key="CONTEXTPATH"><a href="#">Site</a></th>
                                <th sort-key="PROCESSDEFINITIONNAME"><a href="#">Definition</a></th>
                                <th sort-key="TASKITEMTITLE"><a href="#">Process</a></th>
                                <th sort-key="ORIGINATOR"><a href="#">Originator</a></th>
                                <th sort-key="CREATIONDATE"><a href="#">Created</a></th>
                                <th sort-key="COMPLETIONDATE"><a href="#">Completed</a></th>
                                <th sort-key="DURATION"><a href="#">Days</a></th>
                                <th sort-key="OVERDUE"><a href="#">Due on</a></th>
                            </tr>
                        </thead>
                        <tbody></tbody>
                    </table>
                    <div id="div-paging">
                        <ul id="pagination-elmt"class="pagination-sm"></ul>
                    </div>
                </div>
                 <script src="http://ajax.googleapis.com/ajax/libs/jquery/1.11.1/jquery.min.js"></script>
        <script>
            if (!window.jQuery) {
                console.error("jQuery CDN is down.")
                document.write('<script src="<%=Url.Content("~/Content/assets/js/jquery.min.js") %>"><\/script>');
            }
        </script>
        <script src="http://maxcdn.bootstrapcdn.com/bootstrap/3.2.0/js/bootstrap.min.js"></script>
        <script>
            if (!$.fn.modal) {
                console.error("Bootstrap CDN is down.")
                document.write('<script src="<%=Url.Content("~/Content/assets/js/bootstrap.min.js") %>"><\/script>');
            }
        </script>
        <script src="<%=Url.Content("~/Content/assets/js/kendo.all.min.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/chosen.jquery.min.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/wslib_master.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/wsplugin_master.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/ws_global_initialization_administration.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/ws_common.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/jquery.tmpl.js") %>"></script>
        <script src="<%=Url.Content("~/Content/assets/js/jquery.twbsPagination.min.js") %>"></script>
        <script>
            $('a.js-tooltip-target').tooltip({
                html: true,
                trigger: 'click',
                animation: true
            });

            $('body').on('click', '.js-tooltip-target', function (event) {
                event.stopPropagation();

                $('div.tooltip').not($(this).siblings('div.tooltip')).remove();
            });

            var _searchData = {};
            $(document).ready(function () {

                ws_showProgressBar();
                ws_initializeWebApp('/admin/getallwebapp', $('#select-webapp'), function (data) {

                    var option = '';

                    $.each(data, function (k, v) {
                        option += '<option value="' + v.WebAppUrl + '">' + v.Name + '</option>';
                    });

                    $('#select-server option').remove();
                    $('#select-server').append(option);
                    var server = $('#select-server option:selected').val();
                    ws_ajaxCall('/workflowprocess/GetControls', { webapp: server }, fillControls, onError, null);
                });

                $('#input-process').on('keypress', function (e) {

                    if (e.keyCode == 13) {
                        $('#btn-submit').click();
                        e.keyCode = 500;
                        e.preventDefault();
                    }
                });

                $('#select-server').on('change', function () {
                    ws_showProgressBar();
                    var webapp = $('#select-server option:selected').val();
                    ws_ajaxCall('/workflowprocess/GetControls', { webapp: webapp }, fillControls, onError, null);
                });

                $("#select-webapp").change(function () {
                    SetupLinks();
                    return false;
                });

                $('#btn-submit').on('click', function () {
                    ws_showProgressBar();
                    _searchData = getSearchCriteria();
                    clearPaging();
                    resetOpsControl();
                    loadProcess(_searchData, 1);
                    return false;
                });

                $('#select-status').on('change', function () {

                    var value = $(this).find('option:selected').val();
                    if (value != "Running") {
                        $('#select-overdue').prop('disabled', true);
                        $('#select-overdue option:first').prop('selected', 'selected');
                    }
                    else {
                        $('#select-overdue').prop('disabled', false);
                    }
                });

                $('#select-pagesize').on('change', function () {

                    ws_showProgressBar();
                    clearPaging();
                    _searchData.pageSize = $('#select-pagesize option:selected').val();
                    loadProcess(_searchData, 1);
                });

                $('#tbl-process-control').applySorting(function (event, data) {

                    $('#input-comment').removeClass('input-validation-error').siblings('label.field-validation-error').remove();
                    ws_showProgressBar();
                    clearPaging();
                    _searchData.sortKey = data.SortKey;
                    _searchData.sortOrder = data.SortOrder;
                    loadProcess(_searchData, 1);
                    return false;
                });

                $('#btn-cancel,#btn-reject,#btn-approve').on('click', function () {
                    if ($.trim($('#input-comment').val()) == '') {

                        $('#input-comment').removeClass('input-validation-error').siblings('label.field-validation-error').remove();
                        $('#input-comment').addClass('input-validation-error').after('<label class="field-validation-error">Comments is a required field.</label>').off('blur').on('blur', function () {

                            if ($.trim($('#input-comment').val()) == '') {
                                $('#input-comment').removeClass('input-validation-error').siblings('label.field-validation-error').remove();
                                $('#input-comment').addClass('input-validation-error').after('<label class="field-validation-error">Comments is a required field.</label>');
                            }
                            else {
                                $('#input-comment').removeClass('input-validation-error').siblings('label.field-validation-error').remove();
                            }
                        });

                        return false;
                    }
                    else {
                        $('#input-comment').removeClass('input-validation-error').siblings('label.field-validation-error').remove();
                    }

                    if (!confirm($(this).attr('action-comment'))) {
                        return false;
                    }

                    ws_showProgressBar();
                    var webapp = $('#select-server option:selected').val();
                    var action = $(this).attr('field-action');
                    var comment = $.trim($('#input-comment').val());
                    var process = new Array();
                    $.each($('#tbl-process-control > tbody tr').filter(':has(:checkbox:checked)').find('td:eq(1)'), function (k, v) {
                        process.push($(v).html());
                    });

                    var data = { webApp: webapp, ops: action, processId: process, comment: comment };

                    $.ajax({
                        url: '/workflowprocess/doaction',
                        data: data,
                        cache: false,
                        traditional: true,
                        success: function (data) {
                            clearPaging();
                            resetOpsControl();
                            loadProcess(_searchData, 1);
                            $('div.js-administration-processcontrol-visiblefor-runningprocess').css('display', 'none');
                            wsLib_createBootstrapAlert($('#js-notice-message'), data, "success", true);
                        },
                        error: function (xhr, status, error) {
                            onError(xhr, status, error);
                        }
                    });

                    return false;
                });
            });

            function getSearchCriteria() {

                var webapp = $('#select-server option:selected').val();
                var site = $('#select-site option:selected').val();
                var procDef = $('#select-def option:selected').val();
                var originator = $('#select-originator option:selected').val();
                var overdue = $('#select-overdue option:selected').val();
                var status = $('#select-status option:selected').val();
                var docform = $('#select-docform option:selected').val();
                var pageSize = $('#select-pagesize option:selected').val();
                var procName = $('#input-process').val();

                var data = { webapp: webapp, site: site, procDef: procDef, originator: originator, overdueDate: overdue, procStatus: status, docOrForm: docform, procName: procName, pageSize: pageSize};

                return data;
            }

            function loadProcess(data, curPage) {
                data['curPage'] = curPage;
                ws_ajaxCall('/workflowprocess/fetch', data, fillProcessData, onError, null);
            }

            function fillProcessData(data, callbackData) {

                $('#tbl-process-control tbody tr').remove();
                $('#tbl-process-control').css('display', 'none');
                $('#span-records-msg').text(data.DisplayMessage);
                if (data.Count > 0) {
                    var rows = $('#process-control-tmpl').tmpl(data.Rows);

                    $('#tbl-process-control tbody').append(rows);
                    $('#tbl-process-control').css('display', '');

                    enablePaging(data.TotalPage, 7);

                    var $administrationProcessControlCommentsButtons = $('div.js-administration-processcontrol-visiblefor-runningprocess');
                    wsLib_checkAll('processcontrol', undefined, {
                        empty: function () {
                            $administrationProcessControlCommentsButtons.fadeOut();
                        },
                        partial: function () {
                            $administrationProcessControlCommentsButtons.fadeIn();
                        },
                        full: function () {
                            $administrationProcessControlCommentsButtons.fadeIn();
                        },
                        toggleCheckbox: {
                            single: function (whichState, $whichCheckbox) {
                                wsLib_console({
                                    whichState: whichState,
                                    whichCheckbox: $whichCheckbox,
                                    status: $whichCheckbox.data('status')
                                });
                            },
                            all: function (whichState) {

                            }
                        }
                    });
                }
                else {

                    wsLib_createBootstrapAlert($('#js-notice-message'), '<%=Resources.Resource.WFAdminWeb_Page_NoResultFound %>', "success", true);
                }

                ws_hideProgressBar();
            }

            function enablePaging(totalPages, visiblePages) {
                
                $('#pagination-elmt').twbsPagination({
                    totalPages: totalPages,
                    visiblePages: visiblePages,
                    onPageClick: function (event, page) {
                        ws_showProgressBar();
                        loadProcess(_searchData, page);
                    }
                });
            }

            function clearPaging() {
                $('#div-paging').html('');
                $('#div-paging').html('<ul id="pagination-elmt"class="pagination-sm"></ul>');
            }

            function fillControls(data, callbackdata) {

                fillSites(data.AllContextPath);
                fillStatus(data.AllStatus);
                fillDef(data.ProcDef);
                fillDocOrForm(data.DocOrForm);
                fillOriginator(data.Originator);
                fillOverdue(data.Overdue);

                ws_hideProgressBar();
            }

            function fillStatus(data) {
                var option = '';

                $.each(data, function (k, v) {
                    option += '<option value="' + v.ProcessStatus + '">' + v.ProcessStatus + '</option>';
                });

                $('#select-status option:not(:first)').remove();
                $('#select-status').append(option);
            }

            function fillOverdue(data) {
                var option = '';

                $.each(data, function (k, v) {
                    option += '<option value="' + v.Value + '">' + v.Name + '</option>';
                });

                $('#select-overdue option').remove();
                $('#select-overdue').append(option);
                $('#select-overdue').prop('disabled', true);
            }

            function fillDef(data) {
                var option = '';

                $.each(data, function (k, v) {
                    option += '<option value="' + v.ProcessDefinitionName + '">' + v.ProcessDefinitionName + '</option>';
                });

                $('#select-def option:not(:first)').remove();
                $('#select-def').append(option);
            }

            function fillDocOrForm(data) {
                var option = '';

                $.each(data, function (k, v) {
                    option += '<option value="' + v.DocOrForm + '">' + v.DocOrForm + '</option>';
                });

                $('#select-docform option:not(:first)').remove();
                $('#select-docform').append(option);
            }

            function fillOriginator(data) {
                var option = '';

                $.each(data, function (k, v) {
                    option += '<option value="' + v.Originator + '">' + v.Originator + '</option>';
                });

                $('#select-originator option:not(:first)').remove();
                $('#select-originator').append(option);
            }

            function fillSites(data) {
                var options = '';
                $.each(data, function (key, value) {
                    options += '<option value="' + value.ContextPath + '">' + value.ContextPath + '</option>';
                });

                $("#select-site option:not(:first)").remove();
                $("#select-site").append(options);
            }

            function onError(xhr, status, error) {
                if (xhr.statusText != null && xhr.statusText != undefined) {
                    wsLib_createBootstrapAlert($('#js-notice-message'), xhr.statusText, "error", true);
                }
                else {
                    wsLib_createBootstrapAlert($('#js-notice-message'), xhr.responseText, "error", true);
                }

                ws_hideProgressBar();
            }

            function exportProcess() {

                var webapp = $('#select-server option:selected').val();
                var site = $('#select-site option:selected').val();
                var procDef = $('#select-def option:selected').val();
                var originator = $('#select-originator option:selected').val();
                var overdue = $('#select-overdue option:selected').val();
                var status = $('#select-status option:selected').val();
                var docform = $('#select-docform option:selected').val();
                var procName = $('#input-process').val();

                var data = { webapp: webapp, site: site, procDef: procDef, originator: originator, overdueDate: overdue, procStatus: status, docOrForm: docform, procName: procName };

                window.open('/workflowprocess/Export?' + $.param(data));

                return false;
            }

            function resetOpsControl() {

                $('#input-comment').val('');
                $('div.js-administration-processcontrol-visiblefor-runningprocess').css('display', 'none');
                $('#tbl-process-control tr').find('th input[type="checkbox"].js-processcontrol-check-all-master').prop('indeterminate', false);
            }

        </script>

        <script id="process-control-tmpl" type="text/x-jQuery-tmpl">
        <tr>
            <td class="js-processcontrol-check-all-slaves" title="checkbox" width="2%">
            {{if ProcessStatus == 'Running'}}
            <input type="checkbox" data-status="${ProcessStatus}"/>
            {{/if}}
            </td>
            <td>${ProcessId}</td>
            <td class="process-status">
            {{if ProcessStatus == 'Completed'}}
            <span class="icon-status-complete"></span>
            {{/if}}
            {{if ProcessStatus == 'Approved'}}
            <span class="icon-status-approved"></span>
            {{/if}}
            {{if ProcessStatus == 'Cancelled'}}
            <span class="icon-status-cancelled"></span>
            {{/if}}
            {{if ProcessStatus == 'Rejected'}}
            <span class="icon-status-cancelled"></span>
            {{/if}}
            {{if ProcessStatus == 'Running'}}
            <span class="icon-status-running"></span>
            {{/if}}
            ${ProcessStatus}</td>
            <td>${ContextPath}</td>
            <td>${ProcessDefinitionName}</td>
            <td>${TaskItemTitle}</td>
            <td>${Originator}</td>
            <td>${CreationDate}</td>
            <td>${CompletionDate}</td>
            <td>${Duration}</td>
            <td>${DueDate}</td>
        </tr>
        </script>
</asp:Content>
